<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

//Starts PHP Sessions
session_start();

if ($_SESSION['username'] != "")
{
	//FusionPBX Integration
	require_once "../fusionpbx/includes/header.php";
	
	?>
	<h2>Sangoma Media Gateway Help</h2>
	<p>This page will guide you on how to initially setup and configure your Sangoma Hardware, and to start Sangoma Media Gateway.<br />
    The menu on the left hand side of the browser is how you would have to navigate throught the various areas of the Sangoma Media Gateway Web interface.<br />
    The Sangoma Media Gateway Web interface contains 4 main areas:
    <ul>
    	<li><a href="#configuration">Configuration</a></li>
        <li><a href="#Operation">Operation</a></li>
        <li><a href="#Statistics">Statistics</a></li>
        <li><a href="#Administration">Administration</a></li>
    </ul>
    For Initial Setup instructions, <a href="#setup">Click Here</a><br /></p>
    <br />
    <hr />
    <h4 id="configuration">Configuration</h4>
    <ol>
    	<li>
        	TDM Configuration Page<br />
            - Detects all Sangoma Hardware Present in the system.<br />
            - Configures for different signalling types based on hardware available (T1/E1, BRI, SS7 and Analog).<br />
            - Configures each TDM span for voice and/or signalling.<br /> 
            - Generates configuration required for Sangoma Media Gateway's Operation.<br />
        </li>
        <li>
        	PBX Integration<br />
            - Displays how to configure your third party PBX in order for it to be able to communicate with Sangoma Media Gateway.
        </li>
        <li>
        	File Editor<br />
            - Can open any file on the file system for editing.<br />
            - Can be used to manually add/remove options from Sangoma Media Gateway configuration files or other system files.<br />
        </li>
    </ol>    
    <h4 id="Operation">Operation</h4>
    <ol>
    	<li>
        	Control Panel<br />
            - Used to control the Gateway and the Sangoma TDM Drivers.<br />
            - Contains an Auto-Refresh feature to avoid manually refreshing the page upon the start/stop/restart of Sangoma Media Gateway and the Sangoma TDM Drivers.<br />
            - Contains a visual representation of whether the Gateway and the Drivers are started/stopped.<br />
        </li>
        <li>
        	Command Execution<br />
            - Gives the user the ability to run Linux Shell commands and Sangoma Media Gateway commands directly from the Sangoma Media Gateway Web Interface.<br />
            - Provides links to the Sangoma Wiki Page for more advanced Sangoma Media Gateway commands.<br />
            - Can display a Shell Command and a Sangoma Media Gateway Command simultaneously on the same page.<br />
        </li>
    </ol>
    <h4 id="Statistics">Statistics</h4>
    <ol>
    	<li>
        	TDM Status<br />
            - Contains statistical information related to the gateway and the physical system.<br />
            - Sangoma TDM Status<br />
            	<ul>
                	<li>Lists all TDM Driver related information</li>
                    <li>Each Physical span is represented by a "wanpipe" number which relates to the Sangoma Media Gateway Spans</li>
                    <li>Shows whether the Physical Layer of the TDM Cards are connected or disconnected</li>
               </ul>
            - List Spans<br />
            	<ul>
                	<li>Lists all spans present and running within Sangoma Media Gateway</li>
					<li>Each span shows the following information:</li>
	                <ol type="i">
    	            	<li>Name</li>
    	                <li>Type</li>
    	                <li>Physical Status</li>
    	                <li>Signalling Status</li>
    	                <li>Channel Counter</li>
    	                <li>Dialplan Information</li>
    	                <li>Context</li>
					</ol>
                </ul>
			- List all Interfaces on the System<br />
            	<ul>
                	<li>Shows all network and Sangoma interfaces present and activated on the system</li>
                    <li>Shows the following information:</li>
                    <ol type="i">
                    	<li>Networking IP Address, Subnet Masks and other networking related information</li>
                        <li>TDM interface operational statistics (errors, overruns, etc.)</li>
                    </ol>
                </ul>    
        </li>
    	<li>
        	SIP Status<br />
            - Displays all SIP related information present on the Gateway.<br />
        </li>        
    </ol>
    <h4 id="Administration">Administration</h4>
    <ol>
    	<li>
        	Menu Manager <br />
            - Manage the way the Sangoma Media Gateway Web Interface menu looks.<br />
            - SuperAdmin accounts can re-design the layout to their liking.<br />
            - Limited to SuperUser accounts <b>ONLY</b>.
        </li>
    	<li>
        	User Manager<br />
            - Manage all the Users that can access the Sangoma Media Gateway Web Interface.<br />
            - Limited to Administrative Accounts <b>ONLY</b>.<br />
            - Admin accounts can create all levels of accounts other than SuperAdmin accounts.<br />
            - Only SuperAdmin accounts can create SuperAdmin users.<br />
        </li>
    </ol>

	<br />
    <hr />
   	<h4 id="setup">Initial Setup</h4>
    Follow the steps below in order to setup Sangoma Media Gateway for the first time.
    
    <ol>
    	<li>Configure the Sangoma TDM Devices using the TDM Configuration Link</li>
        <ul>
        	<li>This is where you will setup the physical spans and configure the grouping of each span</li>
            <li>Perform the steps below in order to generate TDM Configuration Files</li>
            <ol type="a">
            	<li>Detect Sangoma Hardware</li>
                <li>Configure each TDM Span for voice and/or signalling</li>
                <li>Generate Configuration</li>
            </ol>
            <li><font color="red">NOTE: This step only generates configuration files. It does not start the Gateway</font></li>
        </ul>
        <li>Dialplan Configuration</li>
        <ul>
        	<li>Gateway Dialplan is already setup for a user</li>
            <li>All incoming calls from the TDM interfaces will be passed to registered SIP endpoints</li>
            <li>All incoming calls from the SIP endpoints will be passed to the TDM spans based on the groups assigned during the TDM Configuration</li>
        </ul>
        <li>Use the PBX Integration in order to setup your third party PBX in order to communicate with Sangoma Media Gateway via SIP</li>
        <ul>
        	<li>This page will explain how to setup Asterisk and FreeSWITCH for use with Sangoma Media Gateway</li>
        </ul>
        <li>Confirm the Gateway Operation</li>
        <ul>
        	<li>Use the Control Panel in order to start the Sangoma TDM Drivers and Sangoma Media Gateway</li>
            <li><font color="red">NOTE: The Sangoma TDM Drivers <b>MUST</b> be started before Sangoma Media Gateway</font></li>
       	</ul>
        <li>Check the Signalling Status</li>
        <ul>
        	<li>Go to the TDM Status page in order to confirm that the physical layer and the Signalling layers are both up</li>
            <li>The TDM Physical layer can be checked by clicking on the "Sangoma TDM Status" button</li>
            <li>The Signalling Status can be checked by clicking on the "List Spans" button</li>
        </ul>
    </ol>

    <?php
	//FusionPBX Integration
	require_once "../fusionpbx/includes/footer.php";
}
else
{
	header( 'Location:../index.php' ) ;
}