<?php
/*
	SMG WebGUI
	Version: 1.1

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

//Contains all the display related code

	//Contains Common display functions
	class Display_common
	{
		//HTML Header
	  	function html_header()
	  	{
	  		?>
	  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	  <html xmlns="http://www.w3.org/1999/xhtml">
	  <head>
	  		<?php
	  	}
	  
	  	//HTML Title
	  	function html_title($title, $css_location)
	  	{
	  		?>
		  <title><?php echo $title; ?></title>
		  <link rel="stylesheet" type="text/css" href="<?php echo "$css_location"; ?>" />
	  </head>
	  <body>
	  		<?php
	  	}
	  
	  	//HTML Footer
	  	function html_footer()
	 	{
		  //<div class="footer">Copyright Sangoma Technologies 2010</div>
			?>
		</body>
	  </html>
			<?php
		}		
	}
	
	//Class that contains the display functions for Hardware Probe
	class Display_hwprobe
	{	
		//Controls the Main HTML table used to display wanrouter hwprobe information
		function create_html_table($a101, $a102, $a104, $a108, $a200, $a400, $b601, $b700, $a500, $data, $tokenization, $bri_info, $bri_b700_info, $b600)
		{
				//include the file
				include 'ss7_display.php';
						
				if ($_SESSION['freetdm'] == "True")
				{
					$app = "Sangoma Media Gateway";
				}
				elseif ($_SESSION['dahdi'] == "True")
				{
					$app = "Asterisk";
				}
						
				//create the class
				$ss7_class = new ss7_display;
				echo "<p>
				In order to use $app, you must configure the required Sangoma Cards listed below.<br />
				Each Sangoma card is broken down and listed as an available span for use with $app.<br />";
				
				if ($_SESSION['create'] != "")
				{
					echo "<br /><b>In order to proceed to configuration file generation, please <a href=\"#generate\">click here</a> or scroll down to the bottom of the page</b>";
				}
				echo "</p>\n";
				echo "<hr />\n";
				echo "\t<form method=\"post\">\n";
		
				//Keeps a count of the amount of cards in the system
				$a101count = count($a101);
				$a102count = count($a102);
				$a104count = count($a104);		
				$a108count = count($a108);	
				$b601count = count($b601);	
				$a200count = count($a200);
				$a400count = count($a400);	
				$a500count = count($a500);	
				$b600count = count($b600);	
				$b700count = count($b700);
		
				//Total number of cards in the system
				$total_cards = $a101count + $a102count + $a104count + $a108count + $a500count + $a200count + $a400count + $b600count + $b700count + $b701count;
		
				if ($a101[$a101count]->device_name != "" || $a102[$a102count]->device_name != "" || $a104[$a104count]->device_name != "" || $a108[$a108count]->device_name != "")
				{
					echo "\t\t<h4>T1/E1/J1 Cards</h4>\n";

					for ($x = 0; $x <= $a108count; $x++)
					{
						if ($a108[$x]->device_name != "")
						{
							$count++;			
							$this->table($a108[$x], $count,$tokenization, $data,"", $ss7_class);
							$data->insert_card_database($a108[$x], $count, $x);	
							echo "\t\t<br />\n";						
						}	
					}
					
					for ($x = 0; $x <= $a104count; $x++)
					{		
						if ($a104[$x]->device_name != "")
						{
							$count++;			
							$this->table($a104[$x], $count,$tokenization, $data,"", $ss7_class);
							$data->insert_card_database($a104[$x], $count, $x);	
							echo "\t\t<br />\n";						
						}
					}
					
					for ($x = 0; $x <= $a102count; $x++)
					{		
						if ($a102[$x]->device_name != "")
						{
							$count++;										
							$this->table($a102[$x], $count,$tokenization, $data,"", $ss7_class);                 
							$data->insert_card_database($a102[$x], $count, $x);
							echo "\t\t<br />\n";						
						}
					}
																			
					for ($x = 0; $x <= $a101count; $x++)
					{	
						if ($a101[$x]->device_name != "")
						{
							$count++;
							$this->table($a101[$x],$count,$tokenization, $data,"", $ss7_class);
							$data->insert_card_database($a101[$x], $count, $x);	
							echo "\t\t<br />\n";					
						}
					}
				?>                   
				<br />
			<hr />
				<?php
				}
				if ($a500[$a500count]->device_name != "")
				{
					echo "\t\t<h4>BRI Cards</h4>\n";
					for ($x = 1; $x <= $a500count; $x++)
					{
						$bri_values = "";
						$count++;
						//echo "card = $x<br />";
						foreach ($bri_info[$x] as $key => $value)
						{
							//echo "$key = $value<br />";
							$bri_values[$key] = $value;
						}
						$this->table($a500[$x], $count,$tokenization, $data, $bri_values, "");	
						$data->insert_card_database($a500[$x], $count, $x);
						echo "\t\t<br />\n";					
					}
				?>
				<br />        
			<hr />
				<?php						
				}
				if ($a200[$a200count]->device_name != "" || $a400[$a400count]->device_name != "")
				{
					echo "\t\t<h4>Analog Cards</h4>\n";
					for ($x = 0; $x <= $a200count; $x++)
					{
						if ($a200[$x]->device_name != "")
						{
							$count++;	
							$this->table($a200[$x], $count,$tokenization, $data, "", "");
							$data->insert_card_database($a200[$x], $count, $x);
							echo "\t\t<br />\n";						
						}
					}
				
					for ($x = 0; $x <= $a400count; $x++)
					{
						if ($a400[$x]->device_name != "")
						{
							$count++;				
							$this->table($a400[$x], $count,$tokenization, $data, "", "");
							$data->insert_card_database($a400[$x], $count, $x);		
							echo "\t\t<br />\n";					
						}
					}
					
				?>
					<br />        
				<hr />
				<?php
				}	
				if ( $b601[$b601count]->device_name != "" || $b700[$b700count]->device_name != "" || $b600[$b600count]->device_name != "" )
				{
					
					echo "\t\t<h4>Hybrid Cards</h4>\n";

					for ($x = 0; $x <= $b600count; $x++)
					{
						if ($b600[$x]->device_name != "")
						{				
							$count++;	
							$this->table($b600[$x], $count,$tokenization, $data, "", "");
							$data->insert_card_database($b600[$x], $count, $x);
							echo "\t\t<br />\n";						
						}
					}								
					
					for ($x = 0; $x <= $b601count; $x++)
					{
						//echo "device name = " . $b601[$x]->device_name . "<br />";
						if ($b601[$x]->device_name != "")
						{
							$count++;				
							$this->table($b601[$x], $count,$tokenization, $data, "", $ss7_class);	
							$data->insert_card_database($b601[$x], $count, $x);
						}
						echo "\t\t<br />\n";
					}

					for ($x = 0; $x <= $b700count; $x++)
					{
						if ($b700[$x]->device_name != "")
						{
							$bri_values = "";
							$count++;
							//echo "card = $x<br />";
							foreach ($bri_b700_info[$x] as $key => $value)
							{
								//echo "$key = $value<br />";
								$bri_values[$key] = $value;
							}
							$this->table($b700[$x], $count,$tokenization, $data, $bri_values, "");	
							$data->insert_card_database($b700[$x], $count, $x);								
						}					
						echo "\t\t<br />\n";						
					}
						
					echo "<hr />\n";									
				}		
				
				if ($_SESSION['create'] != "")
				{
				?>
                <h4 id="generate"></h4>
            	Start the Sangoma TDM Driver on System Boot:
				<br />
                YES: <input type="radio" name="wanrouter" value="YES" <?php if ($_SESSION['wanrouter'] == "YES" || $_SESSION['wanrouter'] == "") { ?> checked="checked" <?php } ?>/>
                NO: <input type="radio" name="wanrouter" value="NO" <?php if ($_SESSION['wanrouter'] == "NO") { ?> checked="checked" <?php } ?>/>               
                <br />
            	<?php
					if ($_SESSION['dahdi'] != "")
					{
						if ($_SESSION['dahdi_device'] == "yes")
						{
				?>
            	Run dahdi_cfg after starting the TDM Driver: 
                <br />
                YES: <input type="radio" name="dahdi_cfg" value="YES" <?php if ($_SESSION['dahdi_cfg'] == "YES" || $_SESSION['dahdi_cfg'] == "") { ?> checked="checked" <?php } ?>/>
                NO: <input type="radio" name="dahdi_cfg" value="NO" <?php if ($_SESSION['dahdi_cfg'] == "NO") { ?> checked="checked" <?php } ?> /> 
                <br />
                <?php
						}
						if ($_SESSION['bri_exists'] == "yes")
						{
				?>
                Run smg_ctrl after starting the TDM Driver:
                <br />
                YES: <input type="radio" name="smg_bri" value="YES" <?php if ($_SESSION['smg_bri'] == "YES" || $_SESSION['smg_bri'] == "") { ?> checked="checked" <?php } ?>/>
                NO: <input type="radio" name="smg_bri" value="NO" <?php if ($_SESSION['smg_bri'] == "NO") { ?> checked="checked" <?php } ?> /> 
                <br />
            	<?php
						}
					}					
					echo "<br /><input type=\"submit\" name=\"generate\" value=\"Generate Config\" style=\"background-color: #CCC\"/>\n";
				}
				echo "<input type=\"submit\" name=\"reset\" value=\"Reset Config\" style=\"background-color: #CCC\"/>\n";
				echo "<input type=\"submit\" name=\"restore\" value=\"Restore Config\" style=\"background-color: #CCC\"/>\n";				
			?>
				</form>
            <?php
				if ($_SESSION['created'] == "YES")
				{
			?>		
				<hr />
				<a name="wanpipe"><h3>Summary - Files Created</h3></a>                 
			<?php					
					echo "TDM Driver configuration files created -> <b>" . $_SESSION['wanpipes'] . "</b><br />";
					if ($_SESSION['dahdi'] != "")
					{
						echo "Dahdi configuration files created -> <b>/etc/asterisk/chan_dahdi.conf, /etc/dahdi/system.conf</b><br />";
					}
					if ($_SESSION['smg_bri'] != "")
					{
						echo "BRI configuration files created -> <b>/etc/asterisk/smg_bri.conf, /etc/asterisk/woomera.conf</b><br />";
					}
					if ($_SESSION['wanrouter'] == "YES")
					{
						echo "TDM Driver <b>will</b> Start on system startup<br />";
					}
					elseif ($_SESSION['wanrouter'] == "NO")
					{
						echo "TDM Driver <b>will not</b> Start on system startup<br />";
					}
					if ($_SESSION['dahdi'] != "" && $_SESSION['dahdi_cfg'] == "YES")
					{
						echo "dahdi_cfg <b>will</b> run after the TDM Driver has started<br />";
					}
					if ($_SESSION['dahdi'] != "" && $_SESSION['dahdi_cfg'] == "NO")
					{
						echo "dahdi_cfg <b>will not</b> run after the TDM Driver has started<br />";
					}
					if ($_SESSION['smg_bri'] != "" && $_SESSION['smg_bri'] == "YES" && $_SESSION['dahdi'] != "")
					{
						echo "smg_ctrl <b>will</b> run after the TDM Driver has started<br />";
					}
					if ($_SESSION['smg_bri'] != "" && $_SESSION['smg_bri'] == "NO" && $_SESSION['dahdi'] != "")
					{
						echo "smg_ctrl <b>will not</b> run after the TDM Driver has started<br />";
					}
					if ($_SESSION['freetdm'])
					{
						echo "For instructions on how to register Asterisk or FreeSWITCH with Sangoma Media Gateway, please <a href=\"Howtos/dialplans.php\">click here</a><br />";
					}
				}
			return $count; 
			//unset($_SESSION['span_num']);
			//$_SESSION['span_num'] = 0;
		}	

	//Creates the table as per the layout needed
	function table($object, $span, $tokenization, $data, $bri_info, $ss7_class)
	{	
		//Tokenizes the card name and removes everything but the actual card name
		$card_name = $tokenization->tokenize_name($object->device_name);  
		$card_only_name = $tokenization->token_name($card_name);
		$db_location = "sqlite:sqlite/cardinfo.db";		
		
		//Gets all the Required information for BRI
		if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
		{
			$port = array();
			$p = 1;
			foreach ($bri_info as $key => $value)
			{
				//echo "$key = $value<br />";
				$port[$p] = $key;
				$port_type[$p] = $value;
				//echo "$port[$p], $port_type[$p]<br />";
				if ($object->device_name == "AFT-A500-SH")
				{
					$_SESSION['a500_ports'][$p] = $port[$p];
					//echo $_SESSION['a500_ports'][$p] . "<br />";
				}
				elseif ( $object->device_name == "AFT-B700-SH")
				{
					$_SESSION['b700_ports'] = $port;					
				}
				//Insert the port numbers into the hardware database
				$table = $card_only_name . "_" . $span;
				//check if the table exists
				$existance = $data->check_for_table ($db_location, $table);
				
				if ($existance > 1)
				{
					//Check if the line exists
					$param = "port_id";
					$where_param = "port_id = " . $port[$p];
					$result = $data->select_statement ($db_location, $table_name, $param, $where_param);
					
					if ($result != "")
					{
						$update_bri_parameter = "port_id = \"" . $port[$p] . "\"";
						$where_update = "port_id = " . $port[$p];
						$data->update_table ($db_location, $table, $update_bri_parameter, $where_update);				
					}
					else
					{
						$parameters = "port_id";
						$values =  $port[$p] . "";				
						$data->insert_statement($db_location, $table, $parameters, $values);						
					}
				}
				elseif ($existance < 2)
				{
					$param = "port_id int primary key, conn_type varchar(10), dev_name varchar(30), hw_ec varchar(10), hw_dtmf varchar(10), hw_fax varchar(10), rxgain decimal(10,2), txgain decimal(10,2)";
					$data->create_table($db_location, $table, $param);
					
					$parameters = "port_id";
					$values =  $port[$p] . "";				
					$data->insert_statement($db_location, $table, $parameters, $values);
				}
				
				$p++;				
			}
		}
		//echo $object->device_name;
		for ($count = 1; $count <= $object->port_num; $count++)
		{
			//Increments the SS7 span number
			if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" && $count == 1)
			{
				$_SESSION['span_num']++;
			}			
			
			//Port Counter which increments after each port is displayed on the screen.
			//Used when generating wanpipe configs	
			if ($object->device_name != "AFT-A500-SH" && $object->device_name != "AFT-B700-SH")
			{
				$_SESSION['port']++;
				$port = $_SESSION['port'];
			}

			/*if ($object->echo == 0)
			{
				$table_name = $card_only_name . "_" . $span;
				//Update the table
				if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
				{
					$no_echo = "yes";
					$table_exists = $data->check_for_table ($db_location, $table_name);
								
					//Check if hardware table exists
					//if it doesn't exist, create it and insert
					if ($table_exists < 2)
					{
						$param = "port_id int primary key, conn_type varchar(10), dev_name varchar(30), hw_ec varchar(10), hw_dtmf varchar(10), hw_fax varchar(10), rxgain decimal(10,2), txgain decimal(10,2)";
						$data->create_table($db_location, $table_name, $param);
					}
						
					//Place in database
					if ($table_exists > 1)
					{
						//Check if the line exists
						$param = "port_id";
						$where_param = "port_id = " . $port[$count];
						$result = $data->select_statement ($db_location, $table_name, $param, $where_param);
										
						if ($result['port_id'] != "")
						{
							//update
							$parameters = "port_id = \"" .   $port[$count] . "\", dev_name = \"" . $card_only_name . "\", conn_type = \"" . $port_type[$count] . "\", hw_ec = \"no\", hw_dtmf = \"no\", hw_fax = \"no\", rxgain=\"0.0\", txgain=\"0.0\"";
							$where_param = "port_id = " . $port[$count];
							$data->update_table ($db_location, $table_name, $parameters, $where_param);
						}
						else
						{
							$parameters = "port_id, dev_name, conn_type, hw_ec, hw_dtmf, hw_fax, rxgain, txgain";
							$values =  $port[$count] . ", \"" . $card_only_name . "\", \"" . $port_type[$count] . "\", \"no\", \"no\", \"no\", \"0.0\", \"0.0\"";				
							$data->insert_statement($db_location, $table_name, $parameters, $values);
						}
					}
					elseif ($table_exists < 2)
					{
						//insert
						$parameters = "port_id, dev_name, conn_type, hw_ec, hw_dtmf, hw_fax, rxgain, txgain";
						$values =  $port[$count] . ", \"" . $card_only_name . "\", \"" . $port_type[$count] . "\", \"no\", \"no\", \"no\", \"0.0\", \"0.0\"";				
						$data->insert_statement($db_location, $table_name, $parameters, $values);			
					}
				}
				//Update the table
				if ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH")
				{
					$no_echo = "yes";
					$table_exists = $data->check_for_table ($db_location, $table_name);
						
					//Check if hardware table exists
					//if it doesn't exist, create it and insert
					if ($table_exists < 2)
					{
						$param = "port_id int primary key, conn_type varchar(10), dev_name varchar(30), hw_ec varchar(10), hw_dtmf varchar(10), hw_fax varchar(10, rxgain decimal(10,2), txgain decimal(10,2))";
						$data->create_table($db_location, $table_name, $param);
					}
						
					//Place in database
					if ($table_exists > 1)
					{
						//Check if the line exists
						$param = "port_id";
						$where_param = "port_id = " . $span;
						$result = $data->select_statement ($db_location, $table_name, $param, $where_param);
							
						if ($result['port_id'] != "")
						{
							//update
							$parameters = "port_id = \"1\", dev_name = \"" . $card_only_name . "\", hw_ec = \"no\", hw_dtmf = \"no\", hw_fax = \"no\", rxgain=\"0.0\", txgain=\"0.0\"";
							$where_param = "port_id = " . $span;
							$data->update_table ($db_location, $table_name, $parameters, $where_param);
						}
						else
						{
							$parameters = "port_id, dev_name, hw_ec, hw_dtmf, hw_fax, rxgain, txgain";
							$values = "\"1\", \"" . $card_only_name . "\",\"no\", \"no\", \"no\", \"0.0\", \"0.0\"";				
							$data->insert_statement($db_location, $table_name, $parameters, $values);
						}
					}
					elseif ($table_exists < 2)
					{
						//insert
						$parameters = "port_id, dev_name, hw_ec, hw_dtmf, hw_fax, rxgain, txgain";
						$values = "\"1\", \"" . $card_only_name . "\", \"no\", \"no\", \"no\, \"0.0\", \"0.0\"";				
						$data->insert_statement($db_location, $table_name, $parameters, $values);
					
					}
				}
			}*/
					
			//Gets hardware/signalling information
			if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH" )
			{
				//Gets the hardware information from the database
				$hw_info = $data->get_hardware_info($card_name, $port[$count], $span);
				
				//Gets the signalling information from the database
				$sig_info = $data->get_signalling_info($card_name, $port[$count], $span);
			}
			elseif ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" )
			{
				//Gets the hardware information from the database
				$hw_info = $data->get_hardware_info($card_name, $count, $span);
				//Gets the signalling information from the database
				$sig_info = $data->get_signalling_info($card_name, $count, $span);
				//Gets the SS7 Link information from the database
				$ss7_info = $data->get_ss7_link($card_name, $count, $span);
				
				//Get linkset info
				$table_name = $card_only_name . "_" . $span . "_SS7_Link";
				$where = "port_id = " . $count;
				$ss7_linkset = $data->select_statement("sqlite:sqlite/cardinfo.db",$table_name, "linkset", $where);
				
				$ss7_voice = $data->select_statement("sqlite:sqlite/cardinfo.db",$table_name, "voice", $where);
				
				//Get ccspan info
				$table_name = $card_only_name . "_" . $span . "_SS7_ccspans";
				$where = "port_id = " . $count;
				$ss7_ccspan = $data->select_statement("sqlite:sqlite/cardinfo.db",$table_name, "isup", $where);	
				
			}
			elseif ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH")
			{
				//Gets the hardware information from the database
				$hw_info = $data->get_hardware_info($card_name, $count, $span);
				$sig_info = $data->get_signalling_info($card_name, $count, $span);
			}

			if (isset($sig_info[0]) && isset($hw_info[0]))
			{
				//echo "\t<table border=2 style=\"border-width:medium; border-color:#6698FF\">\n";
				if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" && $count == 0 || $object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
				{
					echo "\t<table border=4 width=\"870\" bordercolor=#6698FF>\n";
				}
				else
				{
					echo "\t<table border=4 width=\"770\" bordercolor=#6698FF>\n";
				}
				echo "\t\t<tr>\n";
				echo "\t\t\t<td>\n";
				
				echo "\t\t<table border=\"1\" height=\"63px\">\n";
				echo "\t\t\t<tr align=\"center\">\n";
	
				if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
				{			
					echo "\t\t\t\t<td><font color=\"#4AA02C\"><strong>$card_name</strong><br />Port " . $port[$count] . "<br />Card $span</font></td>\n";
				}
				elseif ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH")
				{
					echo "\t\t\t\t<td><font color=\"#4AA02C\"><strong>$card_name</strong><br />Port $count<br />Card $span</font></td>\n";
				}
				elseif ($object->device_name == "AFT-A200-SH" ||$object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH")
				{
					echo "\t\t\t\t<td><font color=\"#4AA02C\"><strong>$card_name</strong><br />Card $span</font></td>\n";
				}
				elseif ($object->device_name == "AFT-B601-SH")
				{
					echo "\t\t\t\t<td><font color=\"#4AA02C\"><strong>$card_name</strong><br />Port $count<br />Card $span</font></td>\n";
				}				
				
			}
			elseif (isset($hw_info[0]) && isset($ss7_info[0]) && isset($ss7_linkset) && isset ($ss7_ccspan) || isset($hw_info[0]) && isset($ss7_voice[0]) && isset ($ss7_ccspan) )
			{
				//echo "\t<table border=2 style=\"border-width:medium; border-color:#6698FF\">\n";
				if (isset($ss7_voice[0]))
				{
					echo "\t<table border=4 width=\"950\" bordercolor=#6698FF>\n";
				}
				else
				{
					echo "\t<table border=4 width=\"1130\" bordercolor=#6698FF>\n";
				}
				echo "\t\t<tr>\n";
				echo "\t\t\t<td>\n";
				
				echo "\t\t<table border=\"1\" height=\"63px\">\n";
				echo "\t\t\t<tr align=\"center\">\n";
				
				if (isset($ss7_voice[0]))
				{
				}
				
				if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH")
				{
					echo "\t\t\t\t<td><font color=\"#4AA02C\"><strong>$card_name</strong><br />Port $count<br />Card $span</font></td>\n";
				}
				elseif ($object->device_name == "AFT-B601-SH")
				{
					echo "\t\t\t\t<td><font color=\"#4AA02C\"><strong>$card_name</strong><br />Port $count<br />Card $span</font></td>\n";
				}				
				
			}
			else
			{
				//echo "\t<table width=\"1024px\">\n";
				echo "\t<table>\n";
				echo "\t\t<tr>\n";
				echo "\t\t\t<td>\n";
				
				echo "\t\t<table border=\"1\" height=\"63px\">\n";
				echo "\t\t\t<tr align=\"center\">\n";
	
				if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
				{			
					echo "\t\t\t\t<td><strong>$card_name</strong><br />Port " . $port[$count] . "<br />Card $span</td>\n";
				}
				elseif ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH")
				{
					echo "\t\t\t\t<td><strong>$card_name</strong><br />Port $count<br />Card $span</td>\n";
				}
				elseif ($object->device_name == "AFT-A200-SH" ||$object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH")
				{
					echo "\t\t\t\t<td><strong>$card_name</strong><br />Card $span</td>\n";
				}
				elseif ($object->device_name == "AFT-B601-SH")
				{
					echo "\t\t\t\t<td><strong>$card_name</strong><br />Port $count<br />Card $span</td>\n";
				}				
			}
			
			echo "\t\t\t\t<td>\n";
			//if ($hw_info[0] != "" || $skip_hw == "yes")
			//{		
			//	echo "\t\t\t\t\t<table width=\"300px\" height=\"50px\" style=\"background-color:#80B0D6\">\n";
			//}
			//else
			//{
				echo "\t\t\t\t\t<table width=\"300px\" height=\"50px\">\n";
			//}
			echo "\t\t\t\t\t\t<tr align=\"right\">\n";
			echo "\t\t\t\t\t\t\t<td align=\"left\">$object->pci_int</td>\n";						
			echo "\t\t\t\t\t\t<td>Bus=$object->pci_bus</td>\n";
			echo "\t\t\t\t\t\t<td>Slot=$object->pci_slot</td>\n";
			echo "\t\t\t\t\t\t<td>Echo=$object->echo</td>\n";
			//Displays the number of TE or NT ports on BRI interface
			if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
			{
				echo "\t\t\t\t\t\t<td align=\"right\">Type=$port_type[$count]</td>\n";
				$_SESSION['bri_exists'] = "yes";			
			}				
							
			echo "\t\t\t\t\t</tr>\n";
			
			/*if ($object->echo == 0 && $object->device_name == "AFT-A200-SH")
			{
				$skip_hw = "yes";
			}
			elseif ($object->echo == 0 && $object->device_name == "AFT-A400-SH")
			{
				$skip_hw = "yes";
			}
			elseif ($object->echo == 0 && $object->device_name == "AFT-B600-SH")
			{
				$skip_hw = "yes";
			}
			elseif ($object->echo == 0 && $object->device_name == "AFT-A500-SH")
			{
				$skip_hw = "yes";
			}
			elseif ($object->echo == 0 && $object->device_name == "AFT-B700-SH")
			{
				$skip_hw = "yes";
			}
			elseif ($object->echo == 0 && $object->device_name == "AFT-B601-SH" && $count == 2)
			{
				$skip_hw = "yes";
			}*/
			
			//Only Displays this information if the database is present
			//echo $hw_info[0];
			if ($hw_info[0] != "" || $skip_hw == "yes")
			{	
			//echo "Pass";
				echo "\t\t\t\t\t<tr align=\"right\">\n";		
				if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" && $count == 1)
				{
					$_SESSION['dahdi_device'] = "yes";
					$_SESSION['hw_line'] = $hw_info[0];
					echo "\t\t\t\t\t\t<td align=\"left\">$hw_info[0]</td>\n";			
					echo "\t\t\t\t\t\t<td>Framing=$hw_info[2] </td>\n";
					echo "\t\t\t\t\t\t<td>Coding=$hw_info[1] </td>\n";
					if ($hw_info[3] == "normal")
					{
						echo "\t\t\t\t\t\t<td>Clocking=N</td>\n";
					}
					elseif ($hw_info[3] == "master")
					{
						echo "\t\t\t\t\t\t<td>Clocking=M,$hw_info[4]</td>\n";				
					}	
				}			
			
				echo "\t\t\t\t\t</tr>\n";
				echo "\t\t\t\t\t<tr align=\"right\">\n";

				if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
				{
					//Insert the module type into the hardware database
					//type = $port_type[$count]
					$table = $card_only_name . "_" . $span;
					
					$update_bri_parameter = "conn_type = \"" . $port_type[$count] . "\", hw_ec = \"$hw_info[0]\", hw_dtmf = \"$hw_info[1]\", hw_fax = \"$hw_info[2]\", txgain=\"0.0\", rxgain=\"0.0\"" ;
					$where_update = "port_id = " . $port[$count];
					$data->update_table ($db_location, $table, $update_bri_parameter, $where_update);
					
					echo "\t\t\t\t\t\t<td align=\"left\">HW</td>\n";
					echo "\t\t\t\t\t\t<td>Echo=$hw_info[0]</td>\n";
		
					echo "\t\t\t\t\t\t<td>DTMF=$hw_info[1]</td>\n";
					echo "\t\t\t\t\t\t<td>Fax=$hw_info[2]</td>\n";
				}			
				elseif ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-A200-SH" ||$object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH" || $object->device_name == "AFT-B601-SH")
				{
					$db_location = "sqlite:sqlite/cardinfo.db";
					$table = $table_name = $card_only_name . "_" . $span;	
					if ($object->echo > 0)
					{
						if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH")
						{
							echo "\t\t\t\t\t\t<td align=\"left\">HW</td>\n";
							echo "\t\t\t\t\t\t<td>Echo=$hw_info[5]</td>\n";
			
							echo "\t\t\t\t\t\t<td>DTMF=$hw_info[6]</td>\n";
							echo "\t\t\t\t\t\t<td>Fax=$hw_info[7]</td>\n";
						}
						elseif ($object->device_name == "AFT-A200-SH" ||$object->device_name == "AFT-A400-SH"|| $object->device_name == "AFT-B600-SH")
						{
							$_SESSION['dahdi_device'] = "yes";
							echo "\t\t\t\t\t\t<td align=\"left\">HW</td>\n";
							echo "\t\t\t\t\t\t<td>Echo=$hw_info[0]</td>\n";
			
							echo "\t\t\t\t\t\t<td>DTMF=$hw_info[1]</td>\n";
							echo "\t\t\t\t\t\t<td>Fax=$hw_info[2]</td>\n";							
						}						
					}
					elseif ($object->echo == 0)
					{
						echo "\t\t\t\t\t\t<td align=\"left\">HW</td>\n";
						echo "\t\t\t\t\t\t<td>Echo=disable</td>\n";
			
						echo "\t\t\t\t\t\t<td>DTMF=disable</td>\n";
						echo "\t\t\t\t\t\t<td>Fax=disable</td>\n";					
					}
				}
			}
				echo "\t\t\t\t\t</tr>\n";
				echo "\t\t\t\t</table>\n";	
		
				if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH" && $no_echo != "yes")
				{
					echo "\t\t\t<td><input type=\"submit\" name=\"config-hw-" . $port_type[$count] . "-" . $card_name . "-". $port[$count] . "-" . $span . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";
				}
				elseif ($no_echo != "yes")
				{
					echo "\t\t\t<td><input type=\"submit\" name=\"config-hw-" . $card_name . "-". $count . "-" . $span . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";					
				}
				elseif ($no_echo == "yes")
				{
					echo "\t\t\t<td><b>Not<br />Required</b><br />No EC Module</td>\n";					
				}
				echo "\t\t</tr>\n";		
				echo "\t</table>\n";  
				
				//Master Table Separations (Needed to seperate the specific tables)
				echo "\t\t</td>\n";
				echo "\t\t<td>\n";
				
				//echo "$hw_info[0] <br />";
				
				//Creates the signalling parameter box
				if ($hw_info[0] != "" || $no_echo == "yes")
				{
					$hash = "voice_link" . $card_name . "-" .  $span;
					$var = $card_name . "-". $count . "-" . $span;
					//if ($_SESSION[$hash][$count] != $var)
					//{
						if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" && $count == 1)
						{
							echo "\t<table border=\"1\" width=\"150px\" height=\"70px\">\n";
						}
						else
						{
							echo "\t<table border=\"1\" width=\"150px\" height=\"63px\">\n";
						}
					//}
					//else
					//{
					//	echo "\t<table border=\"1\" width=\"100px\" height=\"63px\">\n";
					//}
					echo "\t\t<tr>\n";
					echo "\t\t\t<td>\n";
					
					//If Statement for Signalling Check. If check passes, display signalling information, if it fails, display signalling options
					if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" && $count == 1)
					{					
						?>
						<select name="signal-<?php echo $card_name . "-". $count . "-" . $span; ?>">
							<option value="PRI">PRI</option>
						<?php
						if ($_SESSION['dahdi'] != "True")
						{	
						?>
							<option value="SS7" <?php if ($ss7_info[0] != "" ) { echo "selected=selected"; } ?> >SS7</option>
						<?php
						}
						if ($hw_info[0] == "E1" && $hw_info[8] == "CAS")
						{
							?>
							<option value="CAS">CAS</option>
							<?php                        
						}
						?>
						</select>                     
						<?php
						$db_location = "sqlite:sqlite/cardinfo.db";
						//Check to see if the Port is configured for the right signalling profile
						if ($sig_info[0] != "" && $hw_info[0] == $sig_info[0])
						{
							echo "\t\t\t\t<br /><b>Profile:</b>\n<br />\n";
							if ($object->device_name == "AFT-B601-SH" && $count == 1)
							{
								echo "\t\t\t\t -> $sig_info[2]\n<br />\n";
							}
							else
							{
								echo "\t\t\t\t -> $sig_info[1]\n<br />\n";								
							}
						}	
						elseif ($ss7_info[0] != "" && $hw_info[0] == $ss7_info[1])
						{
							echo "\t\t\t\t<br /><b>SS7 Link:</b>\n<br />\n";
							echo "\t\t\t\t -> $ss7_info[0]\n<br />\n";	
						}
						elseif ($ss7_info[0] != "" && $hw_info[0] != $ss7_info[1])
						{
							//Remove the line out of the signalling database
							$table_name = $card_only_name . "_" . $span . "_SS7_link";
							$parameters = "port_id = " . $count;
							$data->delete_generic($db_location, $table_name, $parameters);
							echo "\t\t\t\t <br /><font color=\"#FF0000\">Media Type Changed<br /><b>$ss7_info[0]</b> cannot be used</font>\n";	
							unset ($ss7_info[0]);												
						}
						elseif ($sig_info[0] != "" && $hw_info[0] != $sig_info[0])
						{
								//Remove the line out of the signalling database
								$table_name = $card_only_name . "_" . $span . "_signalling";
								$parameters = "port_id = " . $count;
								$data->delete_generic($db_location, $table_name, $parameters);
								if ($object->device_name == "AFT-B601-SH" && $count == 1)
								{	
									echo "\t\t\t\t <br /><font color=\"#FF0000\"><b>$sig_info[2]</b> cannot be used on this port</font><br />\n";													
									unset ($sig_info[0]);									
								}
								else
								{
									echo "\t\t\t\t <br /><font color=\"#FF0000\"><b>$sig_info[1]</b> cannot be used on this port</font><br />\n";	
									unset ($sig_info[0]);						
								}
						}
						echo "\t\t\t</td>";
						//$var = $card_name . "-". $count . "-" . $span;
						//$hash = "voice_link" . $card_name . "-" .  $span;
						//echo $_SESSION['voice_link'][$count] . "<br />";
						//if ($_SESSION[$hash][$count] != $var)
						//{
							echo "\t\t\t<td align=\"center\"><input type=\"submit\" name=\"config-sig-" . $card_name . "-". $count . "-" . $span . "-" . $_SESSION['span_num'] . "-" . $hw_info[0] . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";									
						//}
					}	
					elseif ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH") 
					{
						$db_location = "sqlite:sqlite/cardinfo.db";
						if ($port_type[$count] == "NT" || $port_type[$count] == "TE")
						{
							echo "<strong>BRI Profile</strong><br />\n";
							//Checks to see if the port is configured for the right signalling profile
							if ($sig_info[0] != "" && $sig_info[1] == $port_type[$count])
							{
								echo "\t\t\t\t -> $sig_info[0]\n<br />\n";
							}
							elseif ($sig_info[0] != "" && $sig_info[1] != $port_type[$count])
							{
								//Remove the line out of the signalling database
								$table_name = $card_only_name . "_" . $span . "_signalling";
								$parameters = "id = " . $port[$count];
								$data->delete_generic($db_location, $table_name, $parameters);
								echo "\t\t\t\t <font color=\"#FF0000\"><b>$sig_info[0]</b> cannot be used on this port</font><br />\n";
							}
						}
						if ($port_type[$count] == "FXO" || $port_type[$count] == "FXS")
						{
							echo "<strong>Analog Profile</strong><br />\n";
	
							//Checks to see if the port is configured for the right signalling profile
							if ($sig_info[0] != "")
							{
								echo "\t\t\t\t -> $sig_info[0]\n<br />\n";
							}
						}
						echo "\t\t\t</td>";
						echo "\t\t\t<td><input type=\"submit\" name=\"config-sig-" . $port_type[$count] . "-" . $card_name . "-". $port[$count] . "-" . $span . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";					
					}
					elseif ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH") 
					{
						echo "<strong>Analog Profile</strong><br />\n";

						//Checks to see if the port is configured for the right signalling profile
						if ($sig_info[0] != "")
						{
							echo "\t\t\t\t -> $sig_info[0]\n<br />\n";
						}

						echo "\t\t\t</td>";
						echo "\t\t\t<td><input type=\"submit\" name=\"config-sig-" . $card_name . "-". $count . "-" . $span . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";					
					}
					elseif ($object->device_name == "AFT-B601-SH" && $count == 2)
					{
						echo "<strong>Analog Profile</strong><br />\n";

						//echo $sig_info[1];

						//Checks to see if the port is configured for the right signalling profile
						if ($sig_info[1] != "")
						{
							echo "\t\t\t\t -> $sig_info[1]\n<br />\n";
						}

						echo "\t\t\t</td>";
						echo "\t\t\t<td><input type=\"submit\" name=\"config-sig-" . $card_name . "-". $count . "-" . $span . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";					
					}
		

					echo "\t\t</tr>\n";
					echo "\t</table>\n";		
					
					//echo "$sig_info[0] , $hw_info[3], $sig_info[4]<br />";
					//echo $sig_info[0] . " = " . $hw_info[3] .  " = " . $sig_info[4];
					//Redirects to the ss7_display_class for that port
					if ($ss7_info[0] != "")
					{	
						$ss7_class->card_num = $span;
						$ss7_class->port_count = $count;
						$ss7_class->card_name = $card_name;
						$ss7_class->line_type = $hw_info[0];
						
						//redirect to the main display for ss7
						$ss7_class->main();
					}
					//Goes to channel Mapping/Context/Group Numbering
					elseif ($sig_info[0] != "" && $hw_info[0] == $sig_info[0] || $sig_info[0] != "" && $sig_info[1] == $port_type[$count] || $sig_info[0] != "" && $hw_info[3] == $sig_info[4] ||$sig_info[1] != "" && $hw_info[9] == $sig_info[4] )
					{
						//Master Table Separations (Needed to seperate the specific tables)
						echo "\t\t</td>\n";
						echo "\t\t<td>\n";						
						
						//Channels Table
						//Figures out default channel maps
						
						if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH")
						{
							if ($sig_info[2] != "")
							{
								//Takes the channels from the database
								$channels = $sig_info[2];
							}
							else
							{
								//echo "Not Found<br />";
							
								if ($hw_info[0] == "T1")
								{
									$channels = "1-23";
								}
								elseif ($hw_info[0] == "E1")
								{
									$channels = "1-15,17-31";
								}
							}
							
							//Figures out the group number
							if (isset($sig_info[3]))
							{
								$group = $sig_info[3];
							}
							elseif ($sig_info[3] == "")
							{	
								$group = 1 + $_SESSION['group'];
								$_SESSION['group'] = $group;
							}
							$_SESSION['group'] = $group;							
						}
						elseif ($object->device_name == "AFT-B601-SH" && $count == 1)
						{
							if ($sig_info[9] != "")
							{
								//Takes the channels from the database
								$channels = $sig_info[9];
							}
							else
							{
								//echo "Not Found<br />";
							
								if ($hw_info[0] == "T1")
								{
									$channels = "1-23";
								}
								elseif ($hw_info[0] == "E1")
								{
									$channels = "1-15,17-31";
								}
							}
							
							//Figures out the group number
							if (isset($sig_info[3]))
							{
								$group = $sig_info[3];
							}
							elseif ($sig_info[3] == "")
							{	
								$group = 1 + $_SESSION['group'];
								$_SESSION['group'] = $group;
							}
							$_SESSION['group'] = $group;							
						}
						elseif ($object->device_name == "AFT-A500-SH") 
						{	
							if ($sig_info[3] != "")
							{
								//Takes the channels from the database
								$channels = $sig_info[3];
							}
							else
							{
								$channels = "1-2";
							}

							//Figures out the group number
							if (isset($sig_info[4]))
							{
								$group = $sig_info[4];
							}
							elseif ($sig_info[4] == "")
							{	
								$group = 1 + $_SESSION['group'];
								$_SESSION['group'] = $group;
							}
							$_SESSION['group'] = $group;							
						}
						elseif ($object->device_name == "AFT-B700-SH")
						{
							//echo $port_type[$count] . "<br />";
							if ($port_type[$count] == "TE" || $port_type[$count] == "NT")
							{
								if ($sig_info[3] != "")
								{
									//Takes the channels from the database
									$channels = $sig_info[3];
								}
								else
								{
									$channels = "1-2";
								}
	
								//Figures out the group number
								if (isset($sig_info[4]))
								{
									$group = $sig_info[4];
								}
								elseif ($sig_info[4] == "")
								{	
									$group = 1 + $_SESSION['group'];
									$_SESSION['group'] = $group;
								}
								$_SESSION['group'] = $group;															
							}
							elseif ($port_type[$count] == "FXO" || $port_type[$count] == "FXS")
							{
								//Figures out the group number
								if ($sig_info[4] != "")
								{
									$group = $sig_info[4];
								}
								elseif ($sig_info[4] == "")
								{	
									$group = 1 + $_SESSION['group'];
									$_SESSION['group'] = $group;
								}
	
								$_SESSION['group'] = $group;									
							}
						}
						elseif ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH" || $object->device_name == "AFT-B601-SH" && $count == 2) 
						{	
							//Figures out the group number
							if ($sig_info[3] != "")
							{
								$group = $sig_info[3];
							}
							elseif ($sig_info[3] == "")
							{	
								$group = 1 + $_SESSION['group'];
								$_SESSION['group'] = $group;
							}

							$_SESSION['group'] = $group;							
						}

						if ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH" || $object->device_name == "AFT-B601-SH" && $count == 2)
						{
							echo "\t<table border=\"1\" width=\"70px\" height=\"63px\">\n";
						}
						elseif ($object->device_name == "AFT-B700-SH" && $port_type[$count] == "FXS" || $port_type[$count] == "FXO")
						{
							echo "\t<table border=\"1\" width=\"70px\" height=\"63px\">\n";
						}
						else
						{
							echo "\t<table border=\"1\" width=\"200px\" height=\"70px\">\n";
						}
						echo "\t\t\t<tr>\n";
						echo "\t\t\t\t<td>\n";					
						echo "\t\t<table>\n";
						echo "\t\t\t<tr>\n";

						if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B601-SH" && $count == 1)
						{
							echo "\t\t\t<td align=\"center\">Channel Map</td>\n";
						}
						elseif ($object->device_name == "AFT-B700-SH" && $port_type[$count] == "NT" || $port_type[$count] == "TE")
						{
							echo "\t\t\t<td align=\"center\">Channel Map</td>\n";
						}
						echo "\t\t\t<td align=\"center\">Group</td>\n";
						
						//Shows the context table if the customer is using Dahdi/Asterisk
						if ($_SESSION['dahdi'] == "True")
						{
							echo "\t\t\t<td align=\"center\">Context</td>\n";
						}
						
						//Submit button for this box
						
						//echo "\t\t</tr>\n";
						echo "\t\t<tr>\n";
						if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" && $count == 1)
						{
							echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"channel-map-" . $card_name . "-". $count . "-" . $span . "\" style=\"text-align:right; width:100px\" value=\"$channels\" readonly=\"readonly\" /></td>\n";
							echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"group-" . $card_name . "-" . $count . "-" . $span . "\" value=\"" . $group . "\" style=\"text-align:right; width:30px\" /></td>\n";
						}
						elseif ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH" )
						{
							if ($port_type[$count] == "NT" || $port_type[$count] == "TE")
							{
								echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"channel-map-" . $card_name . "-". $port[$count] . "-" . $span . "\" value=\"$channels\" readonly=\"readonly\" style=\"text-align:right; width:100px\" /></td>\n";
							}
							echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"group-" . $card_name . "-" . $port[$count] . "-" . $span . "\" value=\"" . $group . "\" style=\"text-align:right; width:30px\" /></td>\n";							
						}
						elseif ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH" || $object->device_name == "AFT-B601-SH" && $count == 2)
						{
							echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"group-" . $card_name . "-" . $count . "-" . $span . "\" value=\"" . $group . "\" style=\"text-align:right; width:30px\" /></td>\n";
						}
						
						//Shows the context table if the customer is using Dahdi/Asterisk
						if ($_SESSION['dahdi'] == "True")
						{
							//Figures out the context entered
							if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH")
							{
								if ($sig_info[4] != "")
								{
									$context = $sig_info[4];
								}
								else
								{						
									$context = "from-port" . $port;
								}
								echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"context-" . $card_name . "-". $count . "-" . $span . "\" style=\"width:90px\" value=\"" . $context . "\" /></td>\n";								
							}
							elseif ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH" || $object->device_name == "AFT-B601-SH")
							{
								if ($sig_info[5] != "")
								{
									$context = $sig_info[5];
								}
								else
								{						
									$context = "from-" . $card_only_name . "-" . $span;
								}
								echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"context-" . $card_name . "-". $count . "-" . $span . "\" style=\"width:90px\" value=\"" . $context . "\" /></td>\n";								
							}
							elseif ($object->device_name == "AFT-A500-SH")
							{
								if ($sig_info[5] != "")
								{
									$context = $sig_info[5];
								}
								else
								{						
									$context = "from-port" . $port[$count];
								}
								echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"context-" . $card_name . "-". $port[$count] . "-" . $span . "\" style=\"width:90px\" value=\"" . $context . "\" /></td>\n";								
							}
							elseif ($object->device_name == "AFT-B700-SH")
							{
								if ($port_type[$count] == "FXS" || $port_type[$count] == "FXO")
								{
									if ($sig_info[5] != "")
									{
										$context = $sig_info[5];
									}
									else
									{						
										$context = "from-" . $card_only_name . "-" . $span;
									}
									echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"context-" . $card_name . "-". $count . "-" . $span . "\" style=\"width:90px\" value=\"" . $context . "\" /></td>\n";								
								}
								elseif ($port_type[$count] == "NT" || $port_type[$count] == "TE")
								{
									if ($sig_info[5] != "")
									{
										$context = $sig_info[5];
									}
									else
									{						
										$context = "from-port" . $port[$count];
									}
									echo "\t\t\t<td align=\"center\"><input type=\"text\" name=\"context-" . $card_name . "-". $port[$count] . "-" . $span . "\" style=\"width:90px\" value=\"" . $context . "\" /></td>\n";									
								}
							}
						}
						echo "\t\t</tr>";		
						echo "\t</table>\n";	
						echo "\t\t\t</td>\n";
						
						if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH"|| $object->device_name == "AFT-B601-SH")	
						{					
							echo "\t\t\t<td><input type=\"submit\" name=\"config-accept-" .  $card_name . "-". $count . "-" . $span . "\" value=\"Accept\" style=\"background-color: #CCC\"/></td>\n";
						}
						elseif ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
						{
							echo "\t\t\t<td><input type=\"submit\" name=\"config-accept-" .   $port_type[$count] . "-" .$card_name . "-". $port[$count] . "-" . $span . "\" value=\"Accept\" style=\"background-color: #CCC\" /></td>\n";							
						}
						echo "\t\t</tr>\n";
						echo "\t</table>\n";	

						//Master Table Separations (Needed to seperate the specific tables)
						echo "\t\t</td>\n";
						//echo "\t\t<td>\n";	

						//Shows the submit buttons if all the required information is taken
						//echo "\t<input type=\"submit\" name=\"save-" . $card_name . "-". $count . "-" . $span . "\" value=\"Save Config\" /></td>\n";
						
						//Autosaves the channel/group/context information into the signalling database
						//Tokenize card name so that it can be passed as the table name
						$name = $tokenization->token_name($card_name);
						$_SESSION['create'] = "YES";
						
						$db_location = "sqlite:sqlite/cardinfo.db";
						$table_name = $name . "_" . $span . "_signalling";
						
						if ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-B601-SH" && $count == 1)	
						{						
							if ($_SESSION['dahdi'] != "")
							{
								$param = "channels = \"" . $channels . "\", group_num = \"" . $group . "\", context = \"" . $context . "\"";	
								$where_param = "port_id = " . $count;
							}
							if ($_SESSION['freetdm'] != "")
							{
								$param = "channels = \"" . $channels . "\", group_num = \"" . $group . "\"";
								$where_param = "port_id = " . $count;							
							}
						}
						elseif ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH")
						{
							if ($_SESSION['dahdi'] != "")
							{
								$param = "channels = \"" . $channels . "\", group_num = \"" . $group . "\", context = \"" . $context . "\"";	
								$where_param = "id = " . $port[$count];
							}
							if ($_SESSION['freetdm'] != "")
							{
								$param = "channels = \"" . $channels . "\", group_num = \"" . $group . "\"";
								$where_param = "id = " . $port[$count];							
							}							
						}
						elseif ($object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH")
						{
							if ($_SESSION['dahdi'] != "")
							{
								$param = "group_num = \"" . $group . "\", context = \"" . $context . "\"";	
								$where_param = "port_id = 1";
							}
							if ($_SESSION['freetdm'] != "")
							{
								$param = "group_num = \"" . $group . "\"";
								$where_param = "port_id = 1";							
							}							
						}
						elseif ($object->device_name == "AFT-B601-SH" && $count == 2)
						{
							if ($_SESSION['dahdi'] != "")
							{
								$param = "group_num = \"" . $group . "\", context = \"" . $context . "\"";	
								$where_param = "port_id = $count";
							}
							if ($_SESSION['freetdm'] != "")
							{
								$param = "group_num = \"" . $group . "\"";
								$where_param = "port_id = $count";							
							}								
						}
						
						//Updates the signalling table with default values
						$data->update_table ($db_location, $table_name, $param, $where_param);						
					}
				}
			
			//Master Table (Closes the entire table)
			//echo "\t\t\t</td>\n";

			if ($hw_info[0])
			{
				if ($object->device_name == "AFT-A500-SH" || $object->device_name == "AFT-B700-SH") 
				{
					echo "\t\t\t<td><input type=\"submit\" name=\"config-clear-" . $card_name . "-". $port[$count] . "-" . $span . "\" value=\"Clear\" style=\"background-color: #CCC\"/></td>\n";
					//echo "\t\t\t<input type=\"submit\" name=\"config-clear-" . $card_name . "-". $port[$count] . "-" . $span . "\" value=\"Clear Config\" /><br />\n";					
				}
				elseif ($object->device_name == "AFT-A101-SH" || $object->device_name == "AFT-A102-SH" || $object->device_name == "AFT-A104-SH" || $object->device_name == "AFT-A108-SH" || $object->device_name == "AFT-A200-SH" || $object->device_name == "AFT-A400-SH" || $object->device_name == "AFT-B600-SH" || $object->device_name == "AFT-B601-SH")
				{
					echo "\t\t\t<td><input type=\"submit\" name=\"config-clear-" . $card_name . "-". $count . "-" . $span . "\" value=\"Clear\" style=\"background-color: #CCC\"/></td>\n";
					//echo "\t\t\t<input type=\"submit\" name=\"config-clear-" . $card_name . "-". $count . "-" . $span . "\" value=\"Clear Config\" /><br />\n";
				}
			}	
			
			echo "\t\t</tr>\n";
			echo "\t</table>\n";		
		}
	}
}
	
//Contains all the PRI Profile Creation Class information
class config_PRI_Profiles
{
	//Displays  Create/Edit Profile for PRI Configuration
	function display_PRI_profile_options ($edit, $error, $_REQUEST)
	{
		if ($_SESSION['id_num'] == "") { echo"<h3>" . $_SESSION['line_type'] . " Profile Creation</h3>"; } else { echo "<h3>" . $_SESSION['line_type'] . " Profile Editing</h3>"; } 
		
		if ($edit['ton_name'] != "" || $edit['ton_value'] != "" || $edit['npi_name'] != "" || $edit['npi_value'] != "")
		{
			$tok = strtok($edit['ton_name'], ",");

			$count = 0;
			while ($tok !== false) 
			{
				$token[$count] = $tok;
			    $tok = strtok(",");
				$count++;
			}	
		
			$edit['ton_name1'] = $token[0];
			$edit['ton_name2'] = $token[1];
			$edit['ton_name3'] = $token[2];

			$token = "";		
			$tok = strtok($edit['ton_value'], ",");

			$count = 0;
			while ($tok !== false) 
			{
				$token[$count] = $tok;
			    $tok = strtok(",");
				$count++;
			}	
		
			$edit['ton_value1'] = $token[0];
			$edit['ton_value2'] = $token[1];
			$edit['ton_value3'] = $token[2];
		
			$token = "";		
			$tok = strtok($edit['npi_name'], ",");

			$count = 0;
			while ($tok !== false) 
			{
				$token[$count] = $tok;
			    $tok = strtok(",");
				$count++;
			}	
		
			$edit['npi_name1'] = $token[0];
			$edit['npi_name2'] = $token[1];
			$edit['npi_name3'] = $token[2];
		
			$token = "";		
			$tok = strtok($edit['npi_value'], ",");

			$count = 0;
			while ($tok !== false) 
			{
				$token[$count] = $tok;
			    $tok = strtok(",");
				$count++;
			}	
		
			$edit['npi_value1'] = $token[0];
			$edit['npi_value2'] = $token[1];
			$edit['npi_value3'] = $token[2];		
		}
		
		
		//Dropdown box if statements. Control what item is selected on the return of the form
		if ($_REQUEST['signalling'] == "PRI CPE")
		{
			$pick['signalling_cpe'] = "yes";
		}
		elseif ($_REQUEST['signalling'] == "PRI NET")
		{
			$pick['signalling_net'] = "yes";
		}
		if ($edit['signalling'] == "PRI CPE")
		{
			$pick['signalling_cpe'] = "yes";
		}
		elseif ($edit['signalling'] == "PRI NET")
		{
			$pick['signalling_net'] = "yes";
		}
			
		if ($_REQUEST['switchtype'] == "NI2")
		{
			$pick['switchtype_ni2'] = "yes";
		}
		elseif ($_REQUEST['switchtype'] == "4ESS")
		{
			$pick['switchtype_4ess'] = "yes";
		}
		elseif ($_REQUEST['switchtype'] == "5ESS")
		{
			$pick['switchtype_5ess'] = "yes";
		}
		elseif ($_REQUEST['switchtype'] == "QSIG")
		{
			$pick['switchtype_qsig'] = "yes";
		}
		elseif ($_REQUEST['switchtype'] == "NTT")
		{
			$pick['switchtype_ntt'] = "yes";
		}		
		elseif ($_REQUEST['switchtype'] == "EuroISDN")
		{
			$pick['switchtype_euroisdn'] = "yes";
		}
		if ($edit['switchtype'] == "NI2")
		{
			$pick['switchtype_ni2'] = "yes";
		}
		elseif ($edit['switchtype'] == "4ESS")
		{
			$pick['switchtype_4ess'] = "yes";
		}
		elseif ($edit['switchtype'] == "5ESS")
		{
			$pick['switchtype_5ess'] = "yes";
		}
		elseif ($edit['switchtype'] == "QSIG")
		{
			$pick['switchtype_qsig'] = "yes";
		}
		elseif ($edit['switchtype'] == "EuroISDN")
		{
			$pick['switchtype_euroisdn'] = "yes";
		}
		elseif ($edit['switchtype'] == "NTT")
		{
			$pick['switchtype_ntt'] = "yes";
		}		
		
		if ($_REQUEST['facility'] == "no")
		{
			$pick['facility_no'] = "no";
		}		
		elseif ($_REQUEST['facility'] == "yes")
		{
			$pick['facility_yes'] = "yes";
		}
		elseif ($edit['facility'] == "no" || $edit['facility'] == "")
		{
			$pick['facility_no'] = "no";
		}
		elseif ($edit['facility'] == "yes")
		{
			$pick['facility_yes'] = "yes";
		}
		
		if ($_REQUEST['bearer_ITC'] == "3.1khz")
		{
			$pick['bearer_ITC_31khz'] = "yes";
		}
		elseif ($_REQUEST['bearer_ITC'] == "unrestricted-digital")
		{
			$pick['bearer_ITC_ud'] = "yes";
		}
		elseif ($_REQUEST['bearer_ITC'] == "speech")
		{
			$pick['bearer_ITC_speech'] = "yes";
		}
		elseif ($edit['bearer_ITC'] == "3.1khz")
		{
			$pick['bearer_ITC_31khz'] = "yes";
		}
		elseif ($edit['bearer_ITC'] == "unrestricted-digital")
		{
			$pick['bearer_ITC_ud'] = "yes";
		}
		elseif ($edit['bearer_ITC'] == "speech")
		{
			$pick['bearer_ITC_speech'] = "yes";
		}
		
		if ($_REQUEST['bearer_UIL'] == "v110")
		{
			$pick['bearer_UIL_v110'] = "yes";
		}
		elseif ($_REQUEST['bearer_UIL'] == "ulaw")
		{
			$pick['bearer_UIL_ulaw'] = "yes";
		}
		elseif ($_REQUEST['bearer_UIL'] == "alaw")
		{
			$pick['bearer_UIL_alaw'] = "yes";
		}
		elseif ($edit['bearer_UIL'] == "v110")
		{
			$pick['bearer_UIL_v110'] = "yes";
		}
		elseif ($edit['bearer_UIL'] == "alaw")
		{
			$pick['bearer_UIL_alaw'] = "yes";
		}
		elseif ($edit['bearer_UIL'] == "ulaw")
		{
			$pick['bearer_UIL_ulaw'] = "yes";
		}
		

		if ($edit['ton_name1'] == "outbound-called-ton ")
		{
			if ($edit['ton_value1'] == "international ")
			{
				$pick['ton_value1_international'] = "yes";
			}
			elseif ($edit['ton_value1'] == "national ")
			{
				$pick['ton_value1_national'] = "yes";
			}
			elseif ($edit['ton_value1'] == "local ")
			{
				$pick['ton_value1_local'] = "yes";
			}
		}

		if ($_REQUEST['ton_value1'] == "international")
		{
			$pick['ton_value1_international'] = "yes";
		}
		elseif ($_REQUEST['ton_value1'] == "national")
		{
			$pick['ton_value1_national'] = "yes";
		}
		elseif ($_REQUEST['ton_value1'] == "local")
		{
			$pick['ton_value1_local'] = "yes";
		}
		
		if($edit['ton_name2'] == " outbound-calling-ton ")
		{
			if ($edit['ton_value2'] == " international ")
			{
				$pick['ton_value2_international'] = "yes";
			}
			elseif ($edit['ton_value2'] == " national ")
			{
				$pick['ton_value2_national'] = "yes";
			}
			elseif ($edit['ton_value2'] == " local ")
			{
				$pick['ton_value2_local'] = "yes";
			}
		}

		if ($_REQUEST['ton_value2'] == "international")
		{
			$pick['ton_value2_international'] = "yes";
		}
		elseif ($_REQUEST['ton_value2'] == "national")
		{
			$pick['ton_value2_national'] = "yes";
		}
		elseif ($_REQUEST['ton_value2'] == "local")
		{
			$pick['ton_value2_local'] = "yes";
		}
		
		if($edit['ton_name3'] == " outbound-rdnis-ton")
		{
			if ($edit['ton_value3'] == " international")
			{
				$pick['ton_value3_international'] = "yes";
			}
			elseif ($edit['ton_value3'] == " national")
			{
				$pick['ton_value3_national'] = "yes";
			}
			elseif ($edit['ton_value3'] == " local")
			{
				$pick['ton_value3_local'] = "yes";
			}
		}
		
		if ($_REQUEST['ton_value3'] == "international")
		{
			$pick['ton_value3_international'] = "yes";
		}
		elseif ($_REQUEST['ton_value3'] == "national")
		{
			$pick['ton_value3_national'] = "yes";
		}
		elseif ($_REQUEST['ton_value3'] == "local")
		{
			$pick['ton_value3_local'] = "yes";
		}
				
		if ($edit['npi_name1'] == "outbound-called-npi ")
		{
			if ($edit['npi_value1'] == "isdn ")
			{
				$pick['npi_value1_isdn'] = "yes";
			}
			elseif ($edit['npi_value1'] == "e164 ")
			{
				$pick['npi_value1_e164'] = "yes";
			}
			elseif ($edit['npi_value1'] == "data ")
			{
				$pick['npi_value1_data'] = "yes";
			}
			elseif ($edit['npi_value1'] == "telex ")
			{
				$pick['npi_value1_telex'] = "yes";
			}
			elseif ($edit['npi_value1'] == "national ")
			{
				$pick['npi_value1_national'] = "yes";
			}
			elseif ($edit['npi_value1'] == "reserved ")
			{
				$pick['npi_value1_reserved'] = "yes";
			}
			elseif ($edit['npi_value1'] == "private ")
			{
				$pick['npi_value1_private'] = "yes";
			}			
		}

		if ($_REQUEST['npi_value1'] == "isdn")
		{
			$pick['npi_value1_isdn'] = "yes";
		}
		elseif ($_REQUEST['npi_value1'] == "e164")
		{
			$pick['npi_value1_e164'] = "yes";
		}
		elseif ($_REQUEST['npi_value1'] == "data")
		{
			$pick['npi_value1_data'] = "yes";
		}
		elseif ($_REQUEST['npi_value1'] == "telex")
		{
			$pick['npi_value1_telex'] = "yes";
		}
		elseif ($_REQUEST['npi_value1'] == "national")
		{
			$pick['npi_value1_national'] = "yes";
		}
		elseif ($_REQUEST['npi_value1'] == "reserved")
		{
			$pick['npi_value1_reserved'] = "yes";
		}
		elseif ($_REQUEST['npi_value1'] == "private")
		{
			$pick['npi_value1_private'] = "yes";
		}

		if($edit['npi_name2'] == " outbound-calling-npi ")
		{
			if ($edit['npi_value2'] == " isdn ")
			{
				$pick['npi_value2_isdn'] = "yes";
			}
			elseif ($edit['npi_value2'] == " e164 ")
			{
				$pick['npi_value2_e164'] = "yes";
			}
			elseif ($edit['npi_value2'] == " data ")
			{
				$pick['npi_value2_data'] = "yes";
			}
			elseif ($edit['npi_value2'] == " telex ")
			{
				$pick['npi_value2_telex'] = "yes";
			}
			elseif ($edit['npi_value2'] == " national ")
			{
				$pick['npi_value2_national'] = "yes";
			}
			elseif ($edit['npi_value2'] == " reserved ")
			{
				$pick['npi_value2_reserved'] = "yes";
			}
			elseif ($edit['npi_value2'] == " private ")
			{
				$pick['npi_value2_private'] = "yes";
			}			
		}

		if ($_REQUEST['npi_value2'] == "isdn")
		{
			$pick['npi_value2_isdn'] = "yes";
		}
		elseif ($_REQUEST['npi_value2'] == "e164")
		{
			$pick['npi_value2_e164'] = "yes";
		}
		elseif ($_REQUEST['npi_value2'] == "data")
		{
			$pick['npi_value2_data'] = "yes";
		}
		elseif ($_REQUEST['npi_value2'] == "telex")
		{
			$pick['npi_value2_telex'] = "yes";
		}
		elseif ($_REQUEST['npi_value2'] == "national")
		{
			$pick['npi_value2_national'] = "yes";
		}
		elseif ($_REQUEST['npi_value2'] == "reserved")
		{
			$pick['npi_value2_reserved'] = "yes";
		}
		elseif ($_REQUEST['npi_value2'] == "private")
		{
			$pick['npi_value2_private'] = "yes";
		}

		if($edit['npi_name3'] == " outbound-rdnis-npi")
		{
			if ($edit['npi_value3'] == " isdn")
			{
				$pick['npi_value3_isdn'] = "yes";
			}
			elseif ($edit['npi_value3'] == " e164")
			{
				$pick['npi_value3_e164'] = "yes";
			}
			elseif ($edit['npi_value3'] == " data")
			{
				$pick['npi_value3_data'] = "yes";
			}
			elseif ($edit['npi_value3'] == " telex")
			{
				$pick['npi_value3_telex'] = "yes";
			}
			elseif ($edit['npi_value3'] == " national")
			{
				$pick['npi_value3_national'] = "yes";
			}
			elseif ($edit['npi_value3'] == " reserved")
			{
				$pick['npi_value3_reserved'] = "yes";
			}
			elseif ($edit['npi_value3'] == " private")
			{
				$pick['npi_value3_private'] = "yes";
			}				
		}
						
		if ($_REQUEST['npi_value3'] == "isdn")
		{
			$pick['npi_value3_isdn'] = "yes";
		}
		elseif ($_REQUEST['npi_value3'] == "e164")
		{
			$pick['npi_value3_e164'] = "yes";
		}
		elseif ($_REQUEST['npi_value3'] == "data")
		{
			$pick['npi_value3_data'] = "yes";
		}
		elseif ($_REQUEST['npi_value3'] == "telex")
		{
			$pick['npi_value3_telex'] = "yes";
		}
		elseif ($_REQUEST['npi_value3'] == "national")
		{
			$pick['npi_value3_national'] = "yes";
		}
		elseif ($_REQUEST['npi_value3'] == "reserved")
		{
			$pick['npi_value3_reserved'] = "yes";
		}
		elseif ($_REQUEST['npi_value3'] == "private")
		{
			$pick['npi_value3_private'] = "yes";
		}
		
		if ($_SESSION['profile_num'] == "")
		{
			$a = 1;
			$_SESSION['profile_num'] = $a;
		}
		elseif ($_SESSION['profile_num'] != "")
		{
			$a = $_SESSION['profile_num'];
			$a++;
			$_SESSION['profile_num'] = $a;
		}
		?>
	<p>
    	Please enter the Signalling Level configuration in order to generate a valid T1/E1 Profile.<br />
        Advanced options are available for your T1/E1 Profile. They are populated with their default values, but you may change them if required.
    </p>	
	<form name="create_profile">
	   <hr />    		
       <h4>Standard Options</h4>
    	<table>
			<tr>
				<td>Profile Name</td>
				<td><input type="text" name="profile_name" value="<?php if ($edit['profile_name'] != "") { echo $edit['profile_name']; } elseif($_REQUEST['profile_name'] == "") { echo "New " . $_SESSION['line_type'] . " Profile$a"; } else { echo $_REQUEST['profile_name']; } ?>" /></td>
				<td><?php echo $error['profile_name']; ?></td>
			</tr>
			<tr>
				<td>Line Type</td>        
				<td><input type="text" name="line_type" value="<?php echo $_SESSION['line_type']; ?>" readonly="readonly" /></td>
			</tr>            
	<?php 
		if ($_SESSION['line_type'] == "E1")
		{
	?>
			<tr>
				<td>Protocol</td>
				<td>
					<select name="protocol">
						<option value="">Please Select a Protocol</option>
						<?php /* <option value="CAS" <?php if ($edit['protocol'] != "") { ?> selected="selected" <?php } elseif ($_REQUEST['protocol'] == "CAS") { ?> selected="selected" <?php } ?> >CAS</option> */ ?>
						<option value="CCS" <?php if ($edit['protocol'] != "") { ?> selected="selected" <?php } elseif ($_REQUEST['protocol'] == "CCS") { ?> selected="selected" <?php } ?> >CCS</option>
					</select>
				</td>
				<td><?php echo $error['protocol']; ?></td>                                        
			</tr>            
	<?php
		}
	?>        
			<tr>
				<td>Signalling Type</td>                                        
				<td> 
					<select name="signalling">
						<option value="">Select Signalling</option>
						<option value="PRI CPE" <?php if ($pick['signalling_cpe'] == "yes") { ?> selected="selected" <?php }?> >PRI CPE</option>
						<option value="PRI NET" <?php if ($pick['signalling_net'] == "yes") { ?> selected="selected" <?php }?> >PRI NET</option>
					<?php /*	<option value="E&MWink" <?php if ($edit['signalling'] == "E&MWink") { ?> selected="selected" <?php } elseif ($_REQUEST['signalling'] == "E&MWink") { ?> selected="selected" <?php } ?> >E & M Wink</option> */ ?>
					</select>
				</td>
				<td><?php echo $error['switchtype'] . " " . $error['signalling'];  ?></td>
			</tr>
			<tr>
				<td>Switchtype</td>
				<td>
					<select name="switchtype">
						<option value="">Select Switchtype</option>
	<?php
		if ($_SESSION['line_type'] == "T1")
		{
	?>
						<option value="NI2" <?php if ($pick['switchtype_ni2'] == "yes") { ?> selected="selected" <?php } ?> >National ISDN 2</option>		
						<option value="4ESS" <?php if ($pick['switchtype_4ess'] == "yes") { ?> selected="selected" <?php }?> >Lucent 4ESS</option>
						<option value="5ESS" <?php if ($pick['switchtype_5ess'] == "yes") { ?> selected="selected" <?php }?> >Lucent 5ESS</option>
						<option value="NTT" <?php if ($pick['switchtype_ntt'] == "yes") { ?> selected="selected" <?php }?> >NTT DMS-100</option>   
	<?php	
		}
		elseif ($_SESSION['line_type'] == "E1")
		{
	?>
						<option value="EuroISDN" <?php if ($pick['switchtype_euroisdn'] == "yes") { ?> selected="selected" <?php }?> >EuroISDN</option>
						<option value="QSIG" <?php if ($pick['switchtype_qsig'] == "yes") { ?> selected="selected" <?php }?> >QSIG</option>                        
					<?php /*	<option value="E&MWink" <?php if ($pick['switchtype_em'] == "yes") { ?> selected="selected" <?php }?> >E & M Wink</option> */ ?>
	<?php
		}
	?>	
					</select>
				</td>
                <td><?php echo $error['switchtype'];?></td>                
			</tr> 
	<?php
			if ($_SESSION['freetdm'] == "True")
			{
	?>      
    	</table>
        <br />
		<hr />    		
       <h4>Advanced Options</h4> 
       <font color="red">NOTE: These options are set to their default parameters and shouldn't be changed unless required.</font>     
       <table>
            <tr>
            	<td>Facility Message</td>
                <td>
                	<select name="facility">
                    	<option value="yes" <?php if ($pick['facility_yes'] == "yes") { ?> selected="selected" <?php }?> >Enable</option>
                        <option value="no" <?php if ($pick['facility_no'] == "no") { ?> selected="selected" <?php } ?> >Disable</option>
                    </select>
                </td>
                <td><?php echo $error['facility']; ?></td>
            </tr>
            <tr>
            	<td>Facility Message Timeout</td>
                <td>
                	<input type="text" name="facility_timeout" <?php if ($edit['facility_timeout'] != "") { echo "value=\"" . $edit['facility_timeout'] . "\""; } elseif ($_REQUEST['facility_timeout'] != "") { echo "value=\"" . $_REQUEST['facility_timeout'] . "\""; } else { echo "value=\"\""; } ?> style="width:50px" />
                </td>
                <td><?php echo $error['facility_timeout']; ?></td>
            </tr>
        </table>
        <br />
        Bearer Capability<br />
        <font color="red"><i>Note:Used only when the Bearer Capability is <b>not available</b></i></font>
        <table>              
            <tr>
            	<td>Bearer Capability - Information Transfer Capability</td>
                <td>
                	<select name="bearer_ITC">
                    	<option value="">Default</option>
                    	<option value="speech" <?php if ($pick['bearer_ITC_speech'] == "yes") { ?> selected="selected" <?php }?> >Speech</option>
                        <option value="unrestricted-digital" <?php if ($pick['bearer_ITC_ud'] == "yes") { ?> selected="selected" <?php } ?> >Unrestricted Digital</option>
                        <option value="3.1khz" <?php if ($pick['bearer_ITC_31khz'] == "yes") { ?> selected="selected" <?php }?> >3.1 KHz</option>
                    </select>
                </td>
            </tr>
            <tr>
            	<td>Bearer Capability - User Information layer 1 Protocol</td>
                <td>
                	<select name="bearer_UIL">
                    	<option value="">Default</option>
                    	<option value="v110" <?php if ($pick['bearer_UIL_v110'] == "yes" ) { ?> selected=selected <?php }?> >V.110</option>
                        <option value="ulaw" <?php if ($pick['bearer_UIL_ulaw'] == "yes" ) { ?> selected=selected <?php }?> >uLaw</option>
                        <option value="alaw" <?php if ($pick['bearer_UIL_alaw'] == "yes" ) { ?> selected=selected <?php }?> >aLaw</option>
                    </select>
                </td>
            </tr>      
         </table>
         <br />
         Type of Number (TON)
         <table>      
			<tr>    
				<td>Outbound Called TON</td>        
                <td>
                	<select name="ton_value1">
                    	<option value="">Default</option>
                        <option value="international" <?php if ($pick['ton_value1_international'] == "yes") { ?> selected="selected" <?php } ?> >International</option>
                        <option value="national" <?php if ($pick['ton_value1_national'] == "yes") { ?> selected="selected" <?php }?> >National</option>
                        <option value="local" <?php if ($pick['ton_value1_local'] == "yes") { ?> selected="selected" <?php }?> >Local</option>
                    </select>
                </td>
				<td><?php if ($error['ton_name1'] == "") { echo $error['ton_value1']; } elseif ($error['ton_value1'] == "") { echo $error['ton_name1']; } ?></td>
			</tr>
			<tr>    
				<td>Outbound Calling TON</td>        
                <td>
                	<select name="ton_value2">
                    	<option value="">Default</option>
                        <option value="international" <?php if ($pick['ton_value2_international'] == "yes") { ?> selected="selected" <?php } ?> >International</option>
                        <option value="national" <?php if ($pick['ton_value2_national'] == "yes") { ?> selected="selected" <?php }?> >National</option>
                        <option value="local" <?php if ($pick['ton_value2_local'] == "yes") { ?> selected="selected" <?php }?> >Local</option>
                    </select>
                </td>
				<td><?php if ($error['ton_name2'] == "") { echo $error['ton_value2']; } elseif ($error['ton_value2'] == "") { echo $error['ton_name2']; } ?></td>
			</tr>
			<tr>    
				<td>Outbound rdnis TON</td>
                <td>
                	<select name="ton_value3">
                    	<option value="">Default</option>
                        <option value="international" <?php if ($pick['ton_value3_international'] == "yes") { ?> selected="selected" <?php } ?> >International</option>
                        <option value="national" <?php if ($pick['ton_value3_national'] == "yes") { ?> selected="selected" <?php }?> >National</option>
                        <option value="local" <?php if ($pick['ton_value3_local'] == "yes") { ?> selected="selected" <?php }?> >Local</option>
                    </select>
                </td>
				<td><?php if ($error['ton_name3'] == "") { echo $error['ton_value3']; } elseif ($error['ton_value3'] == "") { echo $error['ton_name3']; } ?></td>
			</tr>                        
        </table> 
        <br />
        Numbering Plan Identification
        <table>   
			<tr>
				<td>Outbound Called NPI</td>
                <td>
                	<select name="npi_value1">
                    	<option value="">Default</option>
                        <option value="isdn" <?php if ($pick['npi_value1_isdn'] == "yes") { ?> selected="selected" <?php } ?> >ISDN</option>
                        <option value="e164" <?php if ($pick['npi_value1_e164'] == "yes") { ?> selected="selected" <?php } ?> >E.164</option>
                        <option value="data" <?php if ($pick['npi_value1_data'] == "yes") { ?> selected="selected" <?php } ?> >Data</option>
                        <option value="telex" <?php if ($pick['npi_value1_telex'] == "yes") { ?> selected="selected" <?php } ?> >Telex</option>
                        <option value="national" <?php if ($pick['npi_value1_national'] == "yes") { ?> selected="selected" <?php } ?> >National</option>
                        <option value="private" <?php if ($pick['npi_value1_private'] == "yes") { ?> selected="selected" <?php } ?> >Private</option>
                        <option value="reserved" <?php if ($pick['npi_value1_reserved'] == "yes") { ?> selected="selected" <?php } ?> >Reserved</option>
                    </select>
                </td>   
				<td><?php if ($error['npi_name1'] == "") { echo $error['npi_value1']; } elseif ($error['npi_value1'] == "") { echo $error['npi_name1']; } ?></td>
            </tr> 
			<tr>
				<td>Outbound Calling NPI</td>
                <td>
                	<select name="npi_value2">
                    	<option value="">Default</option>
                        <option value="isdn" <?php if ($pick['npi_value2_isdn'] == "yes") { ?> selected="selected" <?php } ?> >ISDN</option>
                        <option value="e164" <?php if ($pick['npi_value2_e164'] == "yes") { ?> selected="selected" <?php } ?> >E.164</option>
                        <option value="data" <?php if ($pick['npi_value2_data'] == "yes") { ?> selected="selected" <?php } ?> >Data</option>
                        <option value="telex" <?php if ($pick['npi_value2_telex'] == "yes") { ?> selected="selected" <?php } ?> >Telex</option>
                        <option value="national" <?php if ($pick['npi_value2_national'] == "yes") { ?> selected="selected" <?php } ?> >National</option>
                        <option value="private" <?php if ($pick['npi_value2_private'] == "yes") { ?> selected="selected" <?php } ?> >Private</option>
                        <option value="reserved" <?php if ($pick['npi_value2_reserved'] == "yes") { ?> selected="selected" <?php } ?> >Reserved</option>
                    </select>
                </td>   
				<td><?php if ($error['npi_name2'] == "") { echo $error['npi_value2']; } elseif ($error['npi_value2'] == "") { echo $error['npi_name2']; } ?></td>
            </tr> 
			<tr>
				<td>Outbound rdnis NPI</td>
                <td>
                	<select name="npi_value3">
                    	<option value="">Default</option>
                        <option value="isdn" <?php if ($pick['npi_value3_isdn'] == "yes") { ?> selected="selected" <?php } ?> >ISDN</option>
                        <option value="e164" <?php if ($pick['npi_value3_e164'] == "yes") { ?> selected="selected" <?php } ?> >E.164</option>
                        <option value="data" <?php if ($pick['npi_value3_data'] == "yes") { ?> selected="selected" <?php } ?> >Data</option>
                        <option value="telex" <?php if ($pick['npi_value3_telex'] == "yes") { ?> selected="selected" <?php } ?> >Telex</option>
                        <option value="national" <?php if ($pick['npi_value3_national'] == "yes") { ?> selected="selected" <?php } ?> >National</option>
                        <option value="private" <?php if ($pick['npi_value3_private'] == "yes") { ?> selected="selected" <?php } ?> >Private</option>
                        <option value="reserved" <?php if ($pick['npi_value3_reserved'] == "yes") { ?> selected="selected" <?php } ?> >Reserved</option>
                    </select>
                </td>   
				<td><?php if ($error['npi_name3'] == "") { echo $error['npi_value3']; } elseif ($error['npi_value3'] == "") { echo $error['npi_name3']; } ?></td>
            </tr>
		<?php
			}
		?>
		</table>
		<br />
        <hr />
		<input type="submit" name="create" value="<?php if ($_SESSION['id_num'] == "") { echo "Create Profile"; } else { echo "Save Profile"; } ?>" style="background-color: #CCC"/>
		<input type="submit" name="cancel" value="<?php if ($_SESSION['id_num'] == "") { echo "Cancel Profile Creation"; } else { echo "Cancel Profile Editing"; } ?>" style="background-color: #CCC"/>
	</form>  
	<?php
	}
}

class view_pri_profiles
{
	function display_profiles($profile_array, $a)
	{
?>	
    	<h3><?php echo $_SESSION['line_type']; ?> Signalling Profiles</h3>

		<p>
        	Below is a list of all <?php echo $_SESSION['line_type']; ?> Profiles configured on this system.<br />
            There are two default profiles configured for the user. These profiles can be edited to add more functionality to the profile.<br />
            You can manage you profiles using the edit and delete buttons on the right of the specific profile.<br />
            In order to create a new profile, click on "Create New Profile".<br />
            In order to use a specific profile on a port, click on "Use" or "Use for All Ports".
        </p>
        <hr />
		<form name="view">    
    	<table>
    		<th>Profile Name</th>
    	    <th>Line Type</th>
    	    <th>Protocol</th>
    	    <th>Switchtype</th>
    	    <th>Signalling</th>
<?php
		//Displays the following information only if SMG/FreeTDM is installed
		if ($_SESSION['freetdm'] == "True")
		{
?>			
            <th>Facility</th>
            <th>Facility Timeout</th>
            <th>Bearer Capability (ITC)</th>
            <th>Bearer Capability (UIL)</th>
            <th>TON</th>
            <th>NPI</th>
<?php
		}

		for ($b = 0; $b < $a; $b++)
		{
			echo "\t\t\t<tr>\n";
			if ($_SESSION['last_profile'] == $profile_array[$b]['profile_name'])
			{
				echo "\t\t\t\t<td align=\"center\"><b>" . $profile_array[$b]['profile_name'] . "</b></td>\n";
			}
			else
			{
				echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['profile_name'] . "</td>\n";
			}
			echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['line_type'] . "</td>\n";
			echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['protocol'] . "</td>\n";
			echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['switchtype'] . "</td>\n";
			echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['signalling'] . "</td>\n";
			
			//Displays the following information only if SMG/FreeTDM is installed
			if ($_SESSION['freetdm'] == "True")
			{
				echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['facility'] . "</td>\n";
				echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['facility_timeout'] . "</td>\n";
				echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['bearer_ITC'] . "</td>\n";
				echo "\t\t\t\t<td align=\"center\">" . $profile_array[$b]['bearer_UIL'] . "</td>\n";
				if ($profile_array[$b]['ton_name'] == "" || $profile_array[$b]['ton_name'] == " ,  , ")
				{
					echo "\t\t\t\t<td align=\"center\"></td>\n";	
				}	
				elseif ($profile_array[$b]['ton_name'] != "")
				{
					$tons = $this->tokenize_values($profile_array[$b]['ton_name']);
					if ($tons == 1)
					{
						echo "\t\t\t\t\t\t\t<td align=\"center\">$tons entry exists</td>\n";
					}
					elseif ($tons > 1)
					{
						echo "\t\t\t\t\t\t\t<td align=\"center\">$tons entries exist</td>\n";
					}
					//echo "\t\t\t\t\t\t\t<td align=\"right\">" . $this->profile_array[$b]['ton_value'] . "</td>\n";
				}				
				if ($profile_array[$b]['npi_name'] == "" || $profile_array[$b]['npi_name'] == " ,  , ")
				{
					echo "\t\t\t\t<td align=\"center\"></td>\n";	
				}	
				elseif ($profile_array[$b]['npi_name'] != "")
				{
					$npis = $this->tokenize_values($profile_array[$b]['npi_name']);
					if ($npis == 1)
					{
						echo "\t\t\t\t\t\t\t<td align=\"center\">$npis entry exists</td>\n";	
					}
					elseif ($npis > 1)
					{
						echo "\t\t\t\t\t\t\t<td align=\"center\">$npis entries exist</td>\n";
					}					
				}									
			}
			echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"use" . $profile_array[$b]['id'] . "\" value=\"Use\" style=\"background-color: #CCC\"/></td>\n";
			if ($_SESSION['card_clicked'] != "B601")
			{		
				echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"use-all-" . $profile_array[$b]['id'] . "\" value=\"Use for all Ports\" style=\"background-color: #CCC\"/></td>\n";		
			}
			echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"config" . $profile_array[$b]['id'] . "\" value=\"Edit Profile\" style=\"background-color: #CCC\"/></td>\n";
	
			$skip = 0;
			//Disables deleting the default profile
			if ($profile_array[$b]['profile_name'] == "T1 PRI CPE" || $profile_array[$b]['profile_name'] == "T1 PRI NET")
			{
				$skip = 1;
			}
			elseif ($profile_array[$b]['profile_name'] == "E1 PRI CPE" || $profile_array[$b]['profile_name'] == "E1 PRI NET")
			{
				$skip = 1;
			}
			
			if ($skip == 0)
			{
				echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"delete" . $profile_array[$b]['id'] . "\" value=\"Delete Profile\" style=\"background-color: #CCC\"/></td>\n";
			}

			echo "\t\t\t<tr>\n";
			$num_entries++;
		}
		echo "\t\t</table>\n";		
	
	//Puts the number of entries in the database into a session variable
	$_SESSION['num_entries'] = $num_entries;
?>	        
		</table> 
    	<br />
    	<input type="submit" name="create" value="Create New Profile" style="background-color: #CCC"/>
    	<input type="submit" name="back" value="Go Back to Hardware Information" style="background-color: #CCC"/>   
</form>        

<?php
	}
	
	//Tokenizes the TON and NPI values for entry into the form
	function tokenize_values($string)
	{
		$tok = strtok($string, ",");

		$count = 0;
		while ($tok !== false) 
		{
			$token[$count] = $tok;
		    $tok = strtok(",");
			$count++;
		}	
		
		for ($a = 0; $a < $count; $a++)
		{
			if ($token[$a] == " " || $token[$a] == "  ")
			{
			}
			else
			{
				$counter++;
			}
		}
		
		return $counter;			
	}		
}
?>