<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

class transcoding_class
{
	//Variable declarations
	public $is_sangoma="";					//Variable which states whether the device is a sangoma device
	public $array_name="";					//contains all the values returned from ifconfig
	public $array_ip_addr="";				//contains all the values returned from ifconfig
	public $array_mask="";					//contains all the values returned from ifconfig
	public $array_mac="";					//contains all the values returned from ifconfig
	public $array_nibble=array();			//Contians the nibble value for the configuration of the modules
	public $counter="";						//contains all the values returned from ifconfig
	public $num_modules=array();			//Contains the array of modules on the cards
	public $db_location="";					//Contains the Database Location
	public $data="";						//Contains the database class
	public $total_entries="";				//Contains the total entries in the transcode table
	public $array_names=array();			//Contains an Array of ethernet devices that need to be brought up
	public $codec_array = array();			//Contains the available codecs within the transcoding class
	public $codec_names = array();			//Contains the names of the codecs available for use
	public $codec_info = array();			//Contains the information about the codec
	public $bind_addr = "";
	public $bind_port = "";
	
	//Retrieves all the codecs from the database
	function get_codecs()
	{
		$database = "sqlite:../sqlite/smg_data.db";
		$table_name = "codecs";
		
		$select = "SELECT codec_name, codec_syntax, info FROM " . $table_name . " ORDER BY codec_name;";

		$count = 1;
		try
		{
			//open the database
			$db = new PDO($database);

			$result = $db->query($select);
					
			foreach($result as $row)
			{
				$this->codec_array[$count] = $row['codec_syntax'];
				$this->codec_names[$count] = $row['codec_name'];
				$this->codec_info[$count] = $row['info'];
				
				$count++;				
			}
			// close the database connection
			$db = NULL;
		}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}		
	}
	
	function get_info()
    {
		exec("/sbin/ifconfig -a | grep eth | cut -d: -f1 | awk '{ print $1}'", $name_1);
		exec("/sbin/ifconfig -a | grep __tmp | cut -d: -f1 | awk '{ print $1}'", $name_2);
		
		for ($a = 0; $a < count($name_1); $a ++)
		{
			$command = "/sbin/ifconfig " . $name_1[$a] . " | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'";
			//echo $command . "<br />";
			$command_2 = "/sbin/ifconfig " . $name_1[$a] . " | grep -o -E '([[:xdigit:]]{1,2}:){5}[[:xdigit:]]{1,2}'";
			$command_3 = "/sbin/ifconfig " . $name_1[$a] . " | grep 'Mask:' | cut -d: -f4 | awk '{ print $1}'";
			exec($command, $name_1_ip_addr);
			exec($command_2, $name_1_mac);
			exec($command_3, $name_1_mask);
			if ($name_1_ip_addr[$a] == "")
			{
				$name_1_ip_addr[$a] = "";
			}
			if ($name_1_mask[$a] == "")
			{
				$name_1_mask[$a] = "";
			}
			if ( $name_1_mac[$a] == "")
			{
				 $name_1_mac[$a] = "";
			}
			//echo "$a = " . $name_1[$a] . " IP " . $name_1_ip_addr[$a] . " MAC " . $name_1_mac[$a] . " MASK " . $name_1_mask[$a] . "<br />";
			
		}
		for ($a = 0; $a < count($name_2); $a ++)
		{
			$command = "/sbin/ifconfig " . $name_2[$a] . " | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'";
			$command_2 = "/sbin/ifconfig " . $name_2[$a] . " | grep -o -E '([[:xdigit:]]{1,2}:){5}[[:xdigit:]]{1,2}'";
			$command_3 = "/sbin/ifconfig " . $name_2[$a] . " | grep 'Mask:' | cut -d: -f4 | awk '{ print $1}'";
			exec($command, $name_2_ip_addr);
			exec($command_2, $name_2_mac);
			exec($command_3, $name_2_mask);
			if ($name_2_ip_addr[$a] == "")
			{
				$name_2_ip_addr[$a] = "";
			}
			if ($name_2_mask[$a] == "")
			{
				$name_2_mask[$a] = "";
			}
			if ( $name_2_mac[$a] == "")
			{
				 $name_2_mac[$a] = "";
			}
			//echo $name_2[$a] . " " . $name_2_ip_addr[$a] . " " . $name_2_mac[$a] . " " . $name_2_mask[$a] . "<br />";
		}
		
		$this->counter = count($name_1) + count($name_2);
		
		for ($b = 0; $b < count($name_1); $b++)
		{
			$this->array_name[$b] = $name_1[$b];
			$this->array_ip_addr[$b] = $name_1_ip_addr[$b];
			$this->array_mask[$b] = $name_1_mask[$b];
			$this->array_mac[$b] = $name_1_mac[$b];
			$this->array_nibble[$b] = "150";
			//echo "$b = " . $this->array_name[$b] . " " . $this->array_ip_addr[$b] . " and " . $name_1_ip_addr[$b] . "<br />";
		}
		for ($c = 0; $c < count($name_2); $c++)
		{
			$this->array_name[$b] = $name_2[$c];
			$this->array_ip_addr[$b] = $name_2_ip_addr[$c];
			$this->array_mask[$b] = $name_2_mask[$c];
			$this->array_mac[$b] = $name_2_mac[$c];
			$this->array_nibble[$b] = "150";
			//echo "$b = " . $this->array_name[$b] . " " . $this->array_ip_addr[$b] . "<br />";
			$b++;
		}
	}
	
	//Insert entry into the database
	function initial_database($a, $num_modules)
	{
		$table_name = "transcode";
		$param = "interface";
		$where = "interface = " . $this->array_name[$a];
		$exist = $this->data->select_statement($this->db_location, $table_name, $paramters, $where_param);
		
		//echo "interface = " . $exist['interface'];
		if ($exist['interface'] == "")
		{
			//insert
			$param = "id, interface, ip_address, net_mask, mac_addr,  num_modules, nibble";
			$insert_param = "\"" . $a . "\", \"" . $this->array_name[$a] . "\", \"" . $this->array_ip_addr[$a] . "\", \"" . $this->array_mask[$a] . "\", \"" . $this->array_mac[$a] . "\", \"" . $num_modules . "\", \"150\"";
			$this->data->insert_statement($this->db_location, $table_name, $param, $insert_param);
		}
		elseif ($exist['interface'] != "")
		{
			//update
			$param = "id = \"" . $a . "\", interface = \"" . $this->array_name[$a] . "\", ip_address = \"" . $this->array_ip_addr[$a] . "\", net_mask = \"" . $this->array_mask[$a] . "\", mac_addr = \"" . $this->array_mac[$a] . "\", num_modules = \"" . $num_modules . "\", nibble = \"150\"";
			$where = "interface = " . $this->array_name[$a];
			$this->data->update_table ($this->db_location, $table_name, $param, $where);
		}
	}
	
	//Updates the database with the IP Nibble
	function update_nibble($a)
	{
		//update
		$table_name = "transcode";
		$param = "nibble = \"" . $this->array_nibble[$a] . "\"";
		$where = "interface = \"" . $this->array_name[$a] . "\"";
		$this->data->update_table ($this->db_location, $table_name, $param, $where);		
	}
	
	//Compare the first 3 elements of the mac address to find whether it is a sangoma mac address
	function compare_mac($mac_addr)
	{
		//tokenize the mac address
		$tok = strtok($mac_addr, ":");
	
		$count = 0;
		
		while ($tok !== false) {
			$token[$count] = $tok;
			
			//Stores the tokens in an array to be parsed
			$token_values[$total_token] = $token[$count];			
		    $tok = strtok(":");
			$count++;
			$total_token++;
		}
		
		if ($token[0] == "02")
		{
			if ($token[1] == "19")
			{
				if ($token[2] == "23")
				{
					$this->is_sangoma = "YES";
				}
				else
				{
					$this->is_sangoma = "NO";
				}
			}
			else
			{
				$this->is_sangoma = "NO";
			}
		}
		else
		{
			$this->is_sangoma = "NO";
		}
			
	}
	
	//Figures out what values are to be used
	function find_values($database, $a)
	{
		$request = "accept$a";
		$ip_hash = "ip_addr_$a";
		$netmask_hash = "netmask$a";
		$nibble_hash = "nibble$a";


		if ($_REQUEST[$ip_hash] != "")
		{
			$this->array_ip_addr[$a] = $_REQUEST[$ip_hash];
		}
		elseif ($database[$a]['ip_address'] != "")
		{
			$this->array_ip_addr[$a] = $database[$a]['ip_address'];
		}
		elseif ($_REQUEST[$ip_hash] == "" && $database[$a]['ip_address'] == "" && $this->array_ip_addr[$a] == "")
		{
			$this->array_ip_addr[$a] = "10.$a.199.$a";
		}
		
		if ($_REQUEST[$netmask_hash] != "")
		{
			$this->array_mask[$a] = $_REQUEST[$netmask_hash];
		}
		elseif ($database[$a]['net_mask'] != "")
		{
			$this->array_mask[$a] = $database[$a]['net_mask'];
		}
		elseif ($_REQUEST[$netmask_hash] == "" && $database[$a]['net_mask'] == "" && $this->array_mask[$a] == "")
		{
			$this->array_mask[$a] = "255.255.255.0";
		}
		
		if ($_REQUEST[$nibble_hash] != "")
		{
			$this->array_nibble[$a] = $_REQUEST[$nibble_hash];
		}
		elseif ($database[$a]['nibble'] != "")
		{
			$this->array_nibble[$a] = $database[$a]['nibble'];
		}
		
		if ($database[$a]['interface'] != "")
		{
			$this->array_name[$a] = $database[$a]['interface'];
		}	
		
		if ($database[$a]['num_modules'] != "")
		{
			$this->num_modules[$a] = $database[$a]['num_modules'];
		}
		
		//echo "IP = " . $this->array_ip_addr[$a] . "<br />";
		
		//Bind values
		$bind_table = "bind_transcode";
		$bind = $this->data->select_statement($this->db_location, $bind_table, "bind_addr", "id = 1");
		
		if ($bind['bind_addr'] != "")
		{
			$this->bind_addr = $bind['bind_addr'];
		}
		elseif ($_REQUEST['bind_addr'] != "")
		{
			$this->bind_addr = $_REQUEST['bind_addr'];
		}
		else
		{
			$this->bind_addr = "0.0.0.0";
		}
		
		if ($bind['bind_port'] != "")
		{
			$this->bind_port = $bind['bind_port'];
		}
		elseif ($_REQUEST['bind_port'] != "")
		{
			$this->bind_port = $_REQUEST['bind_port'];
		}
		else
		{
			$this->bind_port = "9000";
		}
			
	}
	
	//Determines the number of entries in the transcode table
	function num_entries()
	{
		$db_location = "sqlite:../sqlite/cardinfo.db";
		$table_name = "transcode";
	
		$select = "SELECT id FROM " . $table_name . ";";
		unset($this->total_ports);
		$count = 0;
		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
					
			foreach($result as $row)
			{
				$this->total_entries++;
			}
			// close the database connection
			$db = NULL;
		}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}			
	}
	
	//Generate sngtc_server.conf
	function sngtc_server()
	{
		//open a file
		$file_name = "sngtc_server.xml";		
		$filehandle = fopen($file_name, 'w') or die("can't open file");		

		$xml =	"
<configuration name=\"sngtc_server.conf\" description=\"Sangoma Transcoding Manager Configuration\">
	<settings>\n";
	
		if ($this->bind_addr != "" && $this->bindport != "")
		{
			$xml.="\n
		<param name=\"bindaddr\" value=\"" . $this->bind_addr . "\" />
		<param name=\"bindport\" value=\"" . $this->bindport . "\" />\n";
		}
		$xml.= "\n
	</settings>
	
	<vocallos>\n";
	
		//Enter each vocallo entry
		//For loop for all the entries
		for ($a = 0; $a < $this->total_entries; $a++)
		{
			//Pull information for each entry from the database
			//Enter the information
			$table_name = "transcode";
			$db_location = "sqlite:../sqlite/cardinfo.db";
			$param = "interface, nibble";
			$where_param = "id = $a";
			$info = $this->data->select_statement($db_location, $table_name, $param, $where_param);

			$xml .="\n
		<vocallo name=\"" . $info['interface'] . "\">
			<param name=\"base_udp\" value=\"5000\"/>
			<param name=\"base_ip_octet\" value=\"" . $info['nibble'] . "\"/>
		</vocallo>\n";
		}
	
		$xml.= "\n
	</vocallos>\n
</configuration>\n";

		//close the file
		fwrite($filehandle, $xml);
		fclose($filehandle);
	}
	
	//Generates the ifcfg files required
	function ifcfg()
	{
		$where_param = "";
		$table_name = "transcode";
		$a = 0;

		$select = "SELECT * FROM " . $table_name . ";";
		
		try
		{
			//open the database
			$db = new PDO($this->db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				$info[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}

		for ($b = 0; $b < $a; $b++)
		{
			$this->compare_mac($info[$b]['mac_addr']);
			
			if ($this->is_sangoma == "YES")
			{
				//Use this only if using a RedHat Install (CentOS, Fedora, RHEL)
				$file_name = "ifcfg-" . $info[$b]['interface'];
				$filehandle = fopen($file_name, 'w') or die("can't open file");		
		
		
				$ifcfg = "#Sangoma D-Series Card Networking Configuration
DEVICE=" . $info[$b]['interface'] . "\n
BOOTPROTO=static\n
IPADDR=" . $info[$b]['ip_address'] . "\n
NETMASK=" . $info[$b]['net_mask'] . "\n
HWADDR=" . $info[$b]['mac_addr'] . "\n
ONBOOT=yes\n   
USERCTL=no\n	
";
		
				//close the file
				fwrite($filehandle, $ifcfg);
				fclose($filehandle);
		
				$cmd = "mv " . $file_name . " /etc/sysconfig/network-scripts/" . $file_name;
				//Moves the created file to the required place.
				//Specific to RedHat Distributions
				exec($cmd);
			}
		}
	}
	
	//Generate sangoma_codec.conf
	function sangoma_codec()
	{
		$table = "bind_transcode";
		$result = $this->data->select_statement ($this->db_location, $table, "*", "id = 1");
		
		//open a file
		$file_name = "sangoma_codec.conf";		
		$filehandle = fopen($file_name, 'w') or die("can't open file");		
		
		$xml = "
<configuration name=\"sangoma_codec.conf\" description=\"Sangoma Codec Configuration\">\n
	<settings>\n";

		$where_param = "";
		$table_name = "user_codecs";
		$a = 0;

		$select = "SELECT * FROM " . $table_name . ";";
		
		try
		{
			//open the database
			$db = new PDO($this->db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				$info[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}	

		$last = $a -1;
		for ($b = 0; $b < $a; $b++)
		{
			if ($b == 0)
			{
				$string = $info[$b];
			}
			elseif ($b != $last)
			{
				$string .= "," . $info[$b];
			}
		}
		
		$xml.="
		<param name=\"register\" value=\"" . $string . "\" />\n
		<param name=\"soapserver\: value=\"http://" . $result['bind_addr'] . ":" . $result['bind_port'] . "\"/>\n
		<param name=\"rtpip\" value=\"127.0.0.1\"/>\n
	</settings>\n
</configuration>\n";
	
		//close the file
		fwrite($filehandle, $xml);
		fclose($filehandle);
	}
}

?>