<?php
/*
	SMG WebGUI
	Version: 1.0

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

class wanrouter_hwprobe_controls
{
//Redirects you to the page you have selected depending on the submit button that is pressed
function redirect($input, $data, $tokenization)
{
	//Counter for tokens to place into an array
	$total_token = 0;
	
	//Split up submit button return into smaller pieces to parse properly
	foreach ($input as $key => $value)
	{
		//echo $key . "=" . $value . "<br />";
		//Tokenize $key to split the submit button
		$tok = strtok($key, "-");
	
		$count = 0;
		
		while ($tok !== false) {
			$token[$count] = $tok;
			
			//Stores the tokens in an array to be parsed
			$token_values[$total_token] = $token[$count];			
		    $tok = strtok("-");
			$count++;
			$total_token++;
		}	
	}

	for ($a = 0; $a <= $total_token; $a ++)
	{
		//echo "$a = $token_values[$a]<br />";
		//Checks if T1/E1/J1 cards were selected
		if ($token_values[$a] == "A101" || $token_values[$a] == "A102" || $token_values[$a] == "A104" || $token_values[$a] == "A108")
		{
			//echo $a;
			//Relative positions of values needed
			$pos = $a - 1; //Position of the hw/sig
			$card_num = $a + 3;
			$card_port = $a + 2;
			$config = $a - 2;
			$ss7_span = $a + 4; //position of the ss7 span number	
			$ss7_line = $a + 5; //position of media type		
			
			//Checks to see if the hardware configuration button was clicked
			if ($token_values[$config] == "config" && $token_values[$pos] == "hw")
			{	
				//echo "Card number = " . $token_values[$card_num] . "<br />";;
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
			
				unset ($_SESSION['created']);
							
				//Redirect to t1/e1 configuration page
				header( 'Location:configuration/configure_t1e1.php' ) ;
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "sig")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				//Drop Down Box Position (Always above the signaling submit button. (Relative position 7, need to go back 7)
				$signal = $a - 7;
				$card_signal = $a - 6;
				$card_type = $a - 5;
				$card_signal_port = $a - 4;
				$card_signal_num = $a - 3;
				
				//Rebuild submit info
				$drop_down_signal = $token_values[$signal] . "-" . $token_values[$card_signal] . "-" . $token_values[$card_type] . "-" .  $token_values[$card_signal_port] ."-" .  $token_values[$card_signal_num];
				$submit_sig = "config-sig-" . $token_values[$a] . "-" . $token_values[$card_port] . "-" .  $token_values[$card_num];
									
				if ($input[$drop_down_signal] == "PRI")
				{
					//Store important information into session variable
					$_SESSION['port_num_clicked'] = $token_values[$card_port];
					$_SESSION['card_clicked'] = $token_values[$a];
					$_SESSION['card_num'] = $token_values[$card_num];					
	
					unset ($_SESSION['created']);
					
					//Redirect to t1/e1 configuration page
					header( 'Location:profiles/view_profiles.php' ) ;
				}
				elseif ($input[$drop_down_signal] == "SS7")
				{
					//Store important information into session variable
					$_SESSION['port_num_clicked'] = $token_values[$card_port];
					$_SESSION['card_clicked'] = $token_values[$a];
					$_SESSION['card_num'] = $token_values[$card_num];	
					$_SESSION['ss7_span'] = $token_values[$ss7_span];
					$_SESSION['ss7_line'] = $token_values[$ss7_line];				
					
					unset ($_SESSION['created']);						
										
					//Redirect to t1/e1 configuration page
					header( 'Location:SS7/SS7_link_config.php' ) ;
				}	
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "linkset")
			{
					//Store important information into session variable
					$_SESSION['port_num_clicked'] = $token_values[$card_port];
					$_SESSION['card_clicked'] = $token_values[$a];
					$_SESSION['card_num'] = $token_values[$card_num];	
					$_SESSION['ss7_span'] = $token_values[$ss7_span];

					unset ($_SESSION['created']);						
										
					//Redirect to t1/e1 configuration page
					header( 'Location:SS7/view_ss7_linkset.php' ) ;
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "ss7ccspan")
			{
					//Store important information into session variable
					$_SESSION['port_num_clicked'] = $token_values[$card_port];
					$_SESSION['card_clicked'] = $token_values[$a];
					$_SESSION['card_num'] = $token_values[$card_num];	
					$_SESSION['ss7_span'] = $token_values[$ss7_span];

					unset ($_SESSION['created']);						
										
					//Redirect to t1/e1 configuration page
					header( 'Location:SS7/create_ss7_ccspans.php' ) ;
			}			
			if ($token_values[$config] == "config" && $token_values[$pos] == "accept")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				//Create Channel Maps
				//Put directly into the signalling database for that card
				
				//Rebuilt textbox name
				$textbox = "channel-map-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$group = "group-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$context = "context-" . $_SESSION['card_clicked'] . "-SH-". $_SESSION['port_num_clicked'] . "-" . $_SESSION['card_num'];
				
				//Enter into the signalling database using update
				//Cardname-card_num-signalling
				$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] ."_signalling";
				
				//If dahdi is installed, use the following parameters
				if ($_SESSION['dahdi'] != "")
				{
					$parameters = "channels = \"$input[$textbox]\", group_num = \"$input[$group]\", context = \"$input[$context]\"";					
				}
				elseif ($_SESSION['freetdm'] != "")
				{
					$parameters = "channels = \"$input[$textbox]\", group_num = \"$input[$group]\"";
				}
				
				$where_param = "port_id = " . $_SESSION['port_num_clicked'];
				$data->update_table("sqlite:sqlite/cardinfo.db", $table_name, $parameters, $where_param);
				
				//$session_return = "channel-" . $_SESSION['card_clicked'] . "-" .  $_SESSION['card_num'] . "-" . $_SESSION['port_num_clicked'];

				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}
			if ($token_values[$config] == "ss7linkset" && $token_values[$pos] == "accept")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				//Rebuilds Drop Down Box
				$dropdown = "linkset-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				
				$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] ."_SS7_link";
				$parameters = "linkset = \"$input[$dropdown]\"";
				$where_param = "port_id = " . $_SESSION['port_num_clicked'];
				
				$data->update_table("sqlite:sqlite/cardinfo.db", $table_name, $parameters, $where_param);
				
				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}			
			if ($token_values[$config] == "config" && $token_values[$pos] == "clear")
			{
				//Clears the existing configuration for that specific port
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				$db_location = "sqlite:sqlite/cardinfo.db";
				$parameters = "port_id = " . $_SESSION['port_num_clicked'];
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'];
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_signalling";
				$data->delete_generic($db_location, $table_name, $parameters);

				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_link";
				$data->delete_generic($db_location, $table_name, $parameters);					

				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_ccspans";
				$data->delete_generic($db_location, $table_name, $parameters);					
			
				/*$table_name = "perm_" . $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'];
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = "perm_" . $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_signalling";
				$data->delete_generic($db_location, $table_name, $parameters);*/

				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}			

		}
		elseif ($token_values[$a] == "A200" || $token_values[$a] == "A400" || $token_values[$a] == "B600")
		{
			//echo $a;
			//Relative positions of values needed
			$pos = $a - 1; //Position of the hw/sig
			$card_num = $a + 3;
			$card_port = $a + 2;
			$config = $a - 2;			
			
			//Checks to see if the hardware configuration button was clicked
			if ($token_values[$config] == "config" && $token_values[$pos] == "hw")
			{	
				//echo "Card number = " . $token_values[$card_num] . "<br />";;
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
			
				unset ($_SESSION['created']);
							
				//Redirect to analog configuration page
				header( 'Location:configuration/configure_analog.php' ) ;
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "sig")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
										
				//Redirect to analog profiles page
				header( 'Location:profiles/view_analog_profiles.php' ) ;
			}							
			if ($token_values[$config] == "config" && $token_values[$pos] == "accept")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				//Create Channel Maps
				//Put directly into the signalling database for that card
				
				//Rebuilt textbox name
				$textbox = "channel-map-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$group = "group-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$context = "context-" . $_SESSION['card_clicked'] . "-SH-". $_SESSION['port_num_clicked'] . "-" . $_SESSION['card_num'];
				
				//Enter into the signalling database using update
				//Cardname-card_num-signalling
				$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] ."_signalling";
				
				//If dahdi is installed, use the following parameters
				if ($_SESSION['dahdi'] != "")
				{
					$parameters = "group_num = \"$input[$group]\", context = \"$input[$context]\"";					
				}
				elseif ($_SESSION['freetdm'] != "")
				{
					$parameters = "group_num = \"$input[$group]\"";
				}
				
				$where_param = "port_id = " . $_SESSION['port_num_clicked'];
				$data->update_table("sqlite:sqlite/cardinfo.db", $table_name, $parameters, $where_param);
				
				//$session_return = "channel-" . $_SESSION['card_clicked'] . "-" .  $_SESSION['card_num'] . "-" . $_SESSION['port_num_clicked'];

				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}
			
			if ($token_values[$config] == "config" && $token_values[$pos] == "clear")
			{
				//Clears the existing configuration for that specific port
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				$db_location = "sqlite:sqlite/cardinfo.db";
				$parameters = "port_id = " . $_SESSION['port_num_clicked'];
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'];
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_signalling";
				$data->delete_generic($db_location, $table_name, $parameters);

				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_link";
				$data->delete_generic($db_location, $table_name, $parameters);	

				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_ccspans";
				$data->delete_generic($db_location, $table_name, $parameters);									
			
				/*$table_name = "perm_" . $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'];
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = "perm_" . $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_signalling";
				$data->delete_generic($db_location, $table_name, $parameters);*/

				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}				
			
		}
		if ($token_values[$a] == "B601")
		{
			//echo $a;
			//Relative positions of values needed
			$pos = $a - 1; //Position of the hw/sig
			$card_num = $a + 3;
			$card_port = $a + 2;
			$config = $a - 2;	
			$ss7_span = $a + 4; //position of the ss7 span number
			$ss7_line = $a + 5; //position of media type		
			
			//Checks to see if the hardware configuration button was clicked
			if ($token_values[$config] == "config" && $token_values[$pos] == "hw")
			{	
				//echo "Card number = " . $token_values[$card_num] . "<br />";;
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
			
				unset ($_SESSION['created']);
							
				if ($token_values[$card_port] == 1)
				{
					//Redirect to t1/e1 configuration page
					header( 'Location:configuration/configure_t1e1.php' ) ;
				}
				elseif ($token_values[$card_port] == 2)
				{
					//Redirect to analog configuration page
					header( 'Location:configuration/configure_analog.php' ) ;
				}
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "sig")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				//Drop Down Box Position (Always above the signaling submit button. (Relative position 7, need to go back 7)
				$signal = $a - 7;
				$card_signal = $a - 6;
				$card_type = $a - 5;
				$card_signal_port = $a - 4;
				$card_signal_num = $a - 3;
				
				//Rebuild submit info
				$drop_down_signal = $token_values[$signal] . "-" . $token_values[$card_signal] . "-" . $token_values[$card_type] . "-" .  $token_values[$card_signal_port] ."-" .  $token_values[$card_signal_num];
				$submit_sig = "config-sig-" . $token_values[$a] . "-" . $token_values[$card_port] . "-" .  $token_values[$card_num];

				if ($token_values[$card_port] == 1)
				{
					if ($input[$drop_down_signal] == "PRI")
					{
						//Store important information into session variable
						$_SESSION['port_num_clicked'] = $token_values[$card_port];
						$_SESSION['card_clicked'] = $token_values[$a];
						$_SESSION['card_num'] = $token_values[$card_num];					
		
						unset ($_SESSION['created']);
						
						//Redirect to t1/e1 configuration page
						header( 'Location:profiles/view_profiles.php' ) ;
					}
					elseif ($input[$drop_down_signal] == "SS7")
					{
						//Store important information into session variable
						$_SESSION['port_num_clicked'] = $token_values[$card_port];
						$_SESSION['card_clicked'] = $token_values[$a];
						$_SESSION['card_num'] = $token_values[$card_num];										
						$_SESSION['ss7_span'] = $token_values[$ss7_span];
						$_SESSION['ss7_line'] = $token_values[$ss7_line];
											
						unset ($_SESSION['created']);	
																	
						//Redirect to t1/e1 configuration page
						header( 'Location:SS7/SS7_link_config.php' ) ;
					}
				}
				elseif ($token_values[$card_port] == 2)
				{
					unset ($_SESSION['created']);						
					//Redirect to analog configuration page
					header( 'Location:profiles/view_analog_profiles.php' ) ;
				}					
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "linkset")
			{
					//Store important information into session variable
					$_SESSION['port_num_clicked'] = $token_values[$card_port];
					$_SESSION['card_clicked'] = $token_values[$a];
					$_SESSION['card_num'] = $token_values[$card_num];	
					$_SESSION['ss7_span'] = $token_values[$ss7_span];

					unset ($_SESSION['created']);						
										
					//Redirect to t1/e1 configuration page
					header( 'Location:SS7/view_ss7_linkset.php' ) ;
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "ss7ccspan")
			{
					//Store important information into session variable
					$_SESSION['port_num_clicked'] = $token_values[$card_port];
					$_SESSION['card_clicked'] = $token_values[$a];
					$_SESSION['card_num'] = $token_values[$card_num];	
					$_SESSION['ss7_span'] = $token_values[$ss7_span];

					unset ($_SESSION['created']);						
										
					//Redirect to t1/e1 configuration page
					header( 'Location:SS7/create_ss7_ccspans.php' ) ;
			}					
			if ($token_values[$config] == "config" && $token_values[$pos] == "accept")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				//Create Channel Maps
				//Put directly into the signalling database for that card
				
				//Rebuilt textbox name
				$textbox = "channel-map-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$group = "group-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$context = "context-" . $_SESSION['card_clicked'] . "-SH-". $_SESSION['port_num_clicked'] . "-" . $_SESSION['card_num'];
				
				//Enter into the signalling database using update
				//Cardname-card_num-signalling
				$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] ."_signalling";
				
				//If dahdi is installed, use the following parameters
				if ($_SESSION['dahdi'] != "")
				{
					$parameters = "channels = \"$input[$textbox]\", group_num = \"$input[$group]\", context = \"$input[$context]\"";					
				}
				elseif ($_SESSION['freetdm'] != "")
				{
					$parameters = "channels = \"$input[$textbox]\", group_num = \"$input[$group]\"";
				}
				
				$where_param = "port_id = " . $_SESSION['port_num_clicked'];
				$data->update_table("sqlite:sqlite/cardinfo.db", $table_name, $parameters, $where_param);
				
				//$session_return = "channel-" . $_SESSION['card_clicked'] . "-" .  $_SESSION['card_num'] . "-" . $_SESSION['port_num_clicked'];

				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}
			
			if ($token_values[$config] == "config" && $token_values[$pos] == "clear")
			{
				//Clears the existing configuration for that specific port
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				$db_location = "sqlite:sqlite/cardinfo.db";
				$parameters = "port_id = " . $_SESSION['port_num_clicked'];
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'];
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_signalling";
				$data->delete_generic($db_location, $table_name, $parameters);

				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_link";
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_ccspans";
				$data->delete_generic($db_location, $table_name, $parameters);									
			
				/*$table_name = "perm_" . $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'];
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = "perm_" . $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_signalling";
				$data->delete_generic($db_location, $table_name, $parameters);*/

				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}			

		}		
		
		//Checks if BRI cards were selected
		elseif ($token_values[$a] == "A500" || $token_values[$a] == "B700")
		{
			//Relative positions of values needed
			$pos_hw = $a - 2; //Position of the hw/sig
			$card_num = $a + 3;
			$bri_type = $a - 1;
			$card_port = $a + 2;
			$config_hw = $a - 3;			
			$config = $a - 2;
			$pos = $a - 1; 

			//Checks to see if the hardware configuration button was clicked
			if ($token_values[$config_hw] == "config" && $token_values[$pos_hw] == "hw")
			{				
				//Store important information into session variable
				$_SESSION['bri_type'] = $token_values[$bri_type];
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
			
				unset ($_SESSION['created']);
			
				if ($token_values[$bri_type] == "NT" || $token_values[$bri_type] == "TE" )
				{
					//Redirect to BRI configuration page
					header( 'Location:configuration/configure_bri.php' ) ;
				}
				elseif ($token_values[$bri_type] == "FXO" || $token_values[$bri_type] == "FXS")
				{
					//Redirect to Analog configuration page
					header( 'Location:configuration/configure_analog.php' ) ;
				}
			}
			if ($token_values[$config] == "config" && $token_values[$pos] == "clear")
			{
				//Clears the existing configuration for that specific port
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				$db_location = "sqlite:sqlite/cardinfo.db";
				$parameters = "port_id = " . $_SESSION['port_num_clicked'];
				$param_signalling = "id = " . $_SESSION['port_num_clicked'];
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'];
				$data->delete_generic($db_location, $table_name, $parameters);
				
				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_signalling";
				$data->delete_generic($db_location, $table_name, $param_signalling);

				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_link";
				$data->delete_generic($db_location, $table_name, $parameters);

				$table_name = $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_ccspans";
				$data->delete_generic($db_location, $table_name, $parameters);				

				unset ($_SESSION['created']);
				
				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}	
			if ($token_values[$config_hw] == "config" && $token_values[$pos_hw] == "sig")
			{						
				//Store important information into session variable			
				$_SESSION['bri_type'] = $token_values[$bri_type];
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				unset ($_SESSION['created']);	

				if ($token_values[$bri_type] == "NT" || $token_values[$bri_type] == "TE" )
				{
					//Redirect to BRI configuration page
					header( 'Location:profiles/view_bri_profiles.php' ) ;
				}
				elseif ($token_values[$bri_type] == "FXO" || $token_values[$bri_type] == "FXS")
				{
					//Redirect to Analog configuration page
					header( 'Location:profiles/view_analog_profiles.php' ) ;
				}
				
			}
			//echo $token_values[$pos_hw];
			if ($token_values[$config_hw] == "config" && $token_values[$pos_hw] == "accept")
			{
				//Store important information into session variable
				$_SESSION['port_num_clicked'] = $token_values[$card_port];
				$_SESSION['card_clicked'] = $token_values[$a];
				$_SESSION['card_num'] = $token_values[$card_num];
				
				//Create Channel Maps
				//Put directly into the signalling database for that card
				
				//Rebuilt textbox name
				$textbox = "channel-map-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$group = "group-" . $_SESSION['card_clicked'] . "-SH" . "-" .  $_SESSION['port_num_clicked'] . "-" .  $_SESSION['card_num'];
				$context = "context-" . $_SESSION['card_clicked'] . "-SH-". $_SESSION['port_num_clicked'] . "-" . $_SESSION['card_num'];
				
				//echo $token_values[$bri_type] . ", " . $group . ", " . $input[$group] . "<br />";
				
				//Enter into the signalling database using update
				//Cardname-card_num-signalling
				$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] ."_signalling";
				
				//If dahdi is installed, use the following parameters
				if ($token_values[$bri_type] == "NT" || $token_values[$bri_type] == "TE")
				{
					if ($_SESSION['dahdi'] != "")
					{
						$parameters = "channels = \"$input[$textbox]\", group_num = \"$input[$group]\", context = \"$input[$context]\"";					
					}
					elseif ($_SESSION['freetdm'] != "")
					{
						$parameters = "channels = \"$input[$textbox]\", group_num = \"$input[$group]\"";
					}
				
					$where_param = "id = " . $_SESSION['port_num_clicked'];
					$data->update_table("sqlite:sqlite/cardinfo.db", $table_name, $parameters, $where_param);
				}
				elseif ($token_values[$bri_type] == "FXS" || $token_values[$bri_type] == "FXO")
				{
					if ($_SESSION['dahdi'] != "")
					{
						$parameters = "group_num = \"$input[$group]\", context = \"$input[$context]\"";					
					}
					elseif ($_SESSION['freetdm'] != "")
					{
						$parameters = "group_num = \"$input[$group]\"";
					}
				
					$where_param = "id = " . $_SESSION['port_num_clicked'];
					$data->update_table("sqlite:sqlite/cardinfo.db", $table_name, $parameters, $where_param);
				}
				
				//$session_return = "channel-" . $_SESSION['card_clicked'] . "-" .  $_SESSION['card_num'] . "-" . $_SESSION['port_num_clicked'];

				unset ($_SESSION['created']);

				//Redirect page to itself
				header( 'Location:wanrouterhwprobe.php' );				
			}
		}
	}
	if ($input['reset'] == "Reset Config")
	{
		//Clears the existing configuration for that specific card
		$db_location = "sqlite:sqlite/cardinfo.db";
		
		$select = "SELECT id, dev_name FROM card_present;";

		$a = 0;
	
		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
					
		    foreach($result as $row)
		    {
				$array[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
		}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}
		
		$z = 0; 				
		//Drop the tables	
		for ($b = 1; $b <= $a; $b++)
		{
			$card = $tokenization->tokenize_wanpipe($array[$z]['dev_name']);
			
			$table_name = $card . "_" . $array[$z]['id'];
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);
			}
			
			$table_name = $card . "_" . $array[$z]['id'] . "_signalling";
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);
			}
			
			$table_name = $card . "_" . $array[$z]['id'] . "_SS7_link";
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);
			}	
			
			$table_name = $card . "_" . $array[$z]['id'] . "_SS7_ccspans";
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);
			}						
			$z++;
		}

		//drop tables
		$table_name = "ss7_linkset_profile";
		$table = $data->check_for_table ($db_location, $table_name);
		if ($table > 0)
		{
			$data->drop_table($db_location, $table_name);
		}	

		$table_name = "ss7_isup_profile";
		$table = $data->check_for_table ($db_location, $table_name);
		if ($table > 0)
		{
			$data->drop_table($db_location, $table_name);
		}	

		$table_name = "ss7_route_profile";
		$table = $data->check_for_table ($db_location, $table_name);
		if ($table > 0)
		{
			$data->drop_table($db_location, $table_name);
		}	
										
		//Creates the SS7 Linkset Profile Table
		$table_name = "ss7_linkset_profile";
		$parameters = "id int primary key, profile_name varchar(60), apc int, minactive int";
		$data->create_table($db_location, $table_name, $parameters);	

		//Creates the SS7 ISUP Profile Table
		$table_name = "ss7_isup_profile";
		$parameters = "id int primary key, profile_name varchar(60), spc int, ssf varchar(30), route varchar(60)";
		$data->create_table($db_location, $table_name, $parameters);	

		//Creates the SS7 Route Profile Table
		$table_name = "ss7_route_profile";
		$parameters = "id int primary key, profile_name varchar(60), dpc int, linksets varchar(100), stp varchar(10)";
		$data->create_table($db_location, $table_name, $parameters);		

		unset ($_SESSION['created']);
		unset ($_SESSION['create']);
		
		//Redirect page to itself
		header( 'Location:wanrouterhwprobe.php' );
	}	
	
	if ($input['restore'] == "Restore Config")
	{
		//Restores information to the scratchpad database from the permanent databases
		//Straight Copy from permanent databases to scratchpad databases
		//Use database copy command
		//Clears the existing configuration for that specific card

		$db_location = "sqlite:sqlite/cardinfo.db";
		$select = "SELECT id, dev_name FROM card_present;";

		//While Loop Counter
		$a = 1;

		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
					
		    foreach($result as $row)
		    {
				$array[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
		}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}
						
		//Drop the tables	
		for ($b = 1; $b < $a; $b++)
		{
			$card = $tokenization->tokenize_wanpipe($array[$b]['dev_name']);
			
			$table_name = $card . "_" . $array[$b]['id'];
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);
			}
			
			//Copy table from the permanent table
			$new_table = $table_name;
			$table_name = "perm_" . $table_name;
			$data->select_into ($db_location, $table_name, "*", $new_table);	
			
			$table_name = $card . "_" . $array[$b]['id'] . "_signalling";
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);
			}
			
			if ($card == "A101" || $card == "A102" || $card == "A104" || $card == "A108" || $card == "B601")
			{
				//Copy table from the permanent table
				$new_table = $table_name;
				$table_name = "perm_" . $table_name;
				$data->select_into ($db_location, $table_name, "*", $new_table);			
				
				$table_name = $card . "_" . $array[$b]['id'] . "_SS7_link";
				$table = $data->check_for_table ($db_location, $table_name);
				if ($table > 0)
				{
					$data->drop_table($db_location, $table_name);
				}	
	
				//Copy table from the permanent table
				$new_table = $table_name;
				$table_name = "perm_" . $table_name;
				$data->select_into ($db_location, $table_name, "*", $new_table);			
				
				$table_name = $card . "_" . $array[$b]['id'] . "_SS7_ccspans";
				$table = $data->check_for_table ($db_location, $table_name);
				if ($table > 0)
				{
					$data->drop_table($db_location, $table_name);
				}				
	
				//Copy table from the permanent table
				$new_table = $table_name;
				$table_name = "perm_" . $table_name;
				$data->select_into ($db_location, $table_name, "*", $new_table);
			}
		}
		
		//copy back the linkset/route/isup tables from permanent tables
		//drop tables
		$table_name = "ss7_linkset_profile";
		$table = $data->check_for_table ($db_location, $table_name);
		if ($table > 0)
		{
			$data->drop_table($db_location, $table_name);
		}	

		$table_name = "ss7_isup_profile";
		$table = $data->check_for_table ($db_location, $table_name);
		if ($table > 0)
		{
			$data->drop_table($db_location, $table_name);
		}	

		$table_name = "ss7_route_profile";
		$table = $data->check_for_table ($db_location, $table_name);
		if ($table > 0)
		{
			$data->drop_table($db_location, $table_name);
		}	
				
		$table_name = "perm_ss7_linkset_profile";
		$new_table = "ss7_linkset_profile";
		$parameters = "id, profile_name, apc, minactive";
		$data->select_into ($db_location, $table_name, $parameters, $new_table);		
		
		$table_name = "perm_ss7_route_profile";
		$new_table = "ss7_route_profile";
		$parameters = "id, profile_name, dpc, stp";
		$data->select_into ($db_location, $table_name, $parameters, $new_table);
		
		$table_name = "perm_ss7_isup_profile";
		$new_table = "ss7_isup_profile";
		$parameters = "id, profile_name, spc, route";
		$data->select_into ($db_location, $table_name, $parameters, $new_table);		

		unset ($_SESSION['created']);
		
		//Redirect page to itself
		header( 'Location:wanrouterhwprobe.php' );
		
	}
	
	if ($input['generate'] == "Generate Config")
	{
		//Call the Wanpipe Configuration PHP class to generate wanpipeX.conf
		//Wanpipe configurations different whether using dahdi or freetdm
		
		//Retrieve the card, total cards, # of ports per card, total spans
		//Opens a database connection
		$db_location = "sqlite:sqlite/cardinfo.db";
	
		$select = "SELECT id, dev_name FROM card_present;";

		//While Loop Counter
		$a = 1;
	
		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
			
		    foreach($result as $row)
		    {
				$cards[$a] = $row;

				$device[$a]['dev_name'] = $tokenization->tokenize_wanpipe($cards[$a]['dev_name']);
				//echo "Device name = " . $device[$a]['dev_name'] . "<br />";
				//echo "Card number = " . $cards[$a]['id'] . "<br />"; 				
				
				$table_name = $device[$a]['dev_name'] . "_" . $cards[$a]['id'];
				//echo "Table = " . $table_name . "<br />";
				$hw_table = $data->check_for_table ($db_location, $table_name);				
				$table_name = $device[$a]['dev_name'] . "_" . $cards[$a]['id'] . "_signalling";
				//echo "Table = " . $table_name . "<br />";
				$sig_table = $data->check_for_table ($db_location, $table_name);
				
				$table_name = $device[$a]['dev_name'] . "_" . $cards[$a]['id'] . "_SS7_link";
				//echo "Table = " . $table_name . "<br />";
				$ss7_link = $data->check_for_table ($db_location, $table_name);
				
				$table_name = $device[$a]['dev_name'] . "_" . $cards[$a]['id'] . "_SS7_ccspans";
				//echo "Table = " . $table_name . "<br />";
				$ss7_ccspans = $data->check_for_table ($db_location, $table_name);								
				
				//echo "Hardware = $hw_table & sig = $sig_table <br />";
				if ($hw_table > 1 && $sig_table > 1 || $hw_table >1 && $ss7_ccspans >1 && $ss7_link >1)
				{
					//echo "Card number = " . $cards[$a]['id'] . "<br />"; 
					//$card_num[$a]['id'] = $cards[$a]['id'];				
					$a++;						
				}
			}
			// close the database connection
			$db = NULL;
		}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}

		//Drop the permanent tables
		//Drop the tables	
		for ($b = 1; $b < $a; $b++)
		{
			$card = $tokenization->tokenize_wanpipe($cards[$b]['dev_name']);
			//echo "Card number = " . $card_num[$b]['id'] . "<br />";
			$table_name = "perm_" . $card . "_" . $cards[$b]['id'];
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);
			}
			
			$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_signalling";
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);	
			}
			
			$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_SS7_link";
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);	
			}
			
			$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_SS7_ccspans";
			$table = $data->check_for_table ($db_location, $table_name);
			if ($table > 0)
			{
				$data->drop_table($db_location, $table_name);	
			}						
			
			//recreate the tables
			if ($card == "A101" || $card == "A102" || $card == "A104" || $card == "A108")
			{

				$table_name = "perm_" . $card . "_" . $cards[$b]['id'];

				$param = "port_id int primary key, dev_name varchar(300), line_type varchar(10), coding varchar(10), framing varchar(10), clock varchar(60), ref_clock int, echo varchar(60), dtmf varchar(60), fax varchar(60), lbo varchar(60), txtristate varchar(60), sigmode varchar(10), impedence varchar(60), rx_level varchar(60), rxgain decimal(10,2), txgain decimal(10,2)";
				$data->create_table($db_location, $table_name, $param);
			
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_signalling";
				if ($_SESSION['freetdm'] != "")
				{
					$param = "port_id int primary key, dev_name varchar(60), line_type varchar(10), signalling varchar(60), channels varchar(60), group_num int, ton_name varchar(30), ton_value varchar(30),  npi_name varchar(30), npi_value varchar(30), facility varchar(10), facility_timeout int, bearer_ITC varchar(30), bearer_UIL varchar(30)";
				}
				elseif ($_SESSION['dahdi'] != "")
				{
					$param = "port_id int primary key, dev_name varchar(60), line_type varchar(10), signalling varchar(60), channels varchar(60), group_num int, context varchar(60)";
				}
	

				if ($_SESSION['freetdm'] != "")
				{
					$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_SS7_link";
					$param = "port_id int primary key, link_name varchar(60), span int, sig_channel int, error_type varchar(30), lssu int, priority int, switchtype varchar(30), SSF varchar(30), SLC int, link_type varchar(30), line_type varchar(10), linkset varchar(60), voice varchar(10)";
	
					$data->create_table($db_location, $table_name, $param);
					
					$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_SS7_ccspans";
					$param = "port_id int primary key, profile_name varchar(60), isup varchar(30), cic varchar(30), channels varchar(30), min_digits int, clg_nadi int, cld_nadi int, obci_bita int, typeCntrl varchar(30), group_num int";

					$data->create_table($db_location, $table_name, $param);					
				}
			}
			elseif ($card == "B601")
			{
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'];

				$param = "port_id int primary key, dev_name varchar(60), line_type varchar(10), coding varchar(10), framing varchar(10), clock varchar(30), ref_clock int, echo varchar(30), dtmf varchar(30), fax varchar(30), lbo varchar(30), txtristate varchar(30), sigmode varchar(10), impedence varchar(30), rx_level varchar(30), rxgain decimal(10,2), txgain decimal(10,2)";
				
				$data->create_table($db_location, $table_name, $param);
			
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_signalling";
				if ($_SESSION['freetdm'] != "")
				{
					$param = "port_id int primary key, dev_name varchar(60), profile_name varchar(60), line_type varchar(10), signalling varchar(60), channels varchar(60), group_num int, ton_name varchar(30), ton_value varchar(30),  npi_name varchar(30), npi_value varchar(30), facility varchar(10), facility_timeout int, bearer_ITC varchar(30), bearer_UIL varchar(30), codec varchar(10), operation_mode varchar(10)";
				}
				elseif ($_SESSION['dahdi'] != "")
				{
					$param = "port_id int primary key, dev_name varchar(60), profile_name varchar(60), line_type varchar(10), signalling varchar(60), channels varchar(60), group_num int, context varchar(60), codec varchar(10), operation_mode varchar(10)";
				}
	
				$data->create_table($db_location, $table_name, $param);	
				
				if ($_SESSION['freetdm'] != "")
				{
					$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_SS7_link";
					$param = "port_id int primary key, link_name varchar(60), span int, sig_channel int, error_type varchar(30), lssu int, priority int, switchtype varchar(30), SSF varchar(30), SLC int, link_type varchar(30), line_type varchar(10), linkset varchar(60), voice varchar(10)";
	
					$data->create_table($db_location, $table_name, $param);
					
					$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_SS7_ccspans";
					$param = "port_id int primary key, profile_name varchar(60), isup varchar(30), cic varchar(30), channels varchar(30), min_digits int, clg_nadi int, cld_nadi int, obci_bita int, typeCntrl varchar(30)";

					$data->create_table($db_location, $table_name, $param);					
				}							
			}
			elseif ($card == "A500")
			{
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'];
				$param = "port_id int primary key, conn_type varchar(10), dev_name varchar(30), hw_ec varchar(10), hw_dtmf varchar(10), hw_fax varchar(10), rxgain decimal(10,2), txgain decimal(10,2)";
				$data->create_table($db_location, $table_name, $param);
			
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_signalling";
				if ($_SESSION['freetdm'] != "")
				{
					$param = "id int primary key, dev_name varchar(60), profile_name varchar(60), conn_type varchar(10), sig_type varchar(10), interface varchar(10), switchtype varchar(30), tei int, overlap varchar(10), ton_name varchar(30), ton_value varchar(30), npi_name varchar(30), npi_value varchar(30), bearer_ITC varchar(30), bearer_UIL varchar(30), msn int, channels varchar(60), group_num int";
				}
				elseif ($_SESSION['dahdi'] != "")
				{
					$param = "id int primary key, dev_name varchar(60),  profile_name varchar(60), conn_type varchar(10), sig_type varchar(10), interface varchar(10), switchtype varchar(30), tei int, channels varchar(60), group_num int, context varchar(60)";
				}
	
				$data->create_table($db_location, $table_name, $param);
			}
			elseif ($card == "A200" || $card == "A400" || $card == "B600")
			{
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'];
				$param = "port_id int primary key, conn_type varchar(10), dev_name varchar(30), hw_ec varchar(10), hw_dtmf varchar(10), hw_fax varchar(10), network_sync varchar(10) , rxgain decimal(10,2), txgain decimal(10,2)";
				$data->create_table($db_location, $table_name, $param);
			
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_signalling";
				if ($_SESSION['freetdm'] != "")
				{
					$param = "port_id int primary key, dev_name varchar(60), profile_name varchar(60), codec varchar(10), operation_mode varchar(10), group_num int";
				}
				elseif ($_SESSION['dahdi'] != "")
				{
					$param = "port_id int primary key,  dev_name varchar(60), profile_name varchar(60), codec varchar(10), operation_mode varchar(10), group_num int, context varchar(30)";
				}
	
				$data->create_table($db_location, $table_name, $param);
			}
			elseif ($card == "B700")
			{
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'];
				$param = "port_id int primary key, conn_type varchar(10), dev_name varchar(30), hw_ec varchar(10), hw_dtmf varchar(10), hw_fax varchar(10), rxgain decimal(10,2), txgain decimal(10,2)";
				$data->create_table($db_location, $table_name, $param);
			
				$table_name = "perm_" . $card . "_" . $cards[$b]['id'] . "_signalling";
				if ($_SESSION['freetdm'] != "")
				{
					$param = "id int primary key, dev_name varchar(60), profile_name varchar(60), conn_type varchar(10), sig_type varchar(10), interface varchar(10), switchtype varchar(30), tei int, overlap varchar(10), ton_name varchar(30), ton_value varchar(30), npi_name varchar(30), npi_value varchar(30), bearer_ITC varchar(30), bearer_UIL varchar(30), msn int, channels varchar(60), group_num int, codec varchar(10), operation_mode varchar(10)";
				}
				elseif ($_SESSION['dahdi'] != "")
				{
					$param = "id int primary key, dev_name varchar(60),  profile_name varchar(60), conn_type varchar(10), sig_type varchar(10), interface varchar(10), switchtype varchar(30), tei int, channels varchar(60), group_num int, context varchar(60), codec varchar(10), operation_mode varchar(10)";
				}
	
				$data->create_table($db_location, $table_name, $param);
			}			
		}		
		
		//Start a loop from counter $a and copy all the tables that are complete into the permanent tables
		//Discard partially completed configurations.
		//A line must exist for both the hardware table and the signalling table
		//i.e port numbers much match in both tables
		for ($c = 1; $c < $a; $c++)
		{	
			$device[$c]['dev_name'] = $tokenization->tokenize_wanpipe($cards[$c]['dev_name']);
			//$card_num = $c;
			$card_num = $cards[$c]['id'];
			
			$table_name = $device[$c]['dev_name'] . "_" . $card_num;
			
			$total = $data->check_for_table ($db_location, $table_name);
			
			if ($total > 1)
			{
				try
				{
					$select = "SELECT port_id FROM ". $table_name . " ORDER BY port_id;";

					//While Loop Counter
					$port_count = 0;
	
					//open the database
					$db = new PDO($db_location);

					$result = $db->query($select);
						
				    foreach($result as $row)
				    {			
						$array[$port_count] = $row;
						$port_count++;
					}
					// close the database connection
					$db = NULL;
				}
				catch(PDOException $e)
				{
					print 'Exception : '.$e->getMessage();
				}				
			}
			
			$device[$c]['port_num']	= $port_count;			

			for ($x = 0; $x < $port_count; $x++)
			{
				$db_location = "sqlite:sqlite/cardinfo.db";
				$table_name = $device[$c]['dev_name'] . "_" . $card_num;
				$param = "*";
				
				//echo $device[$c]['dev_name'] . " before config port id = " . $array[$x]['port_id'] . "<br />";
				if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108" || $device[$c]['dev_name'] == "A200" || $device[$c]['dev_name'] == "A400" || $device[$c]['dev_name'] == "B600" || $device[$c]['dev_name'] == "B601")
				{
					$where_param = "port_id = " . $array[$x]['port_id'];
				}
				elseif ($device[$c]['dev_name'] == "A500" || $device[$c]['dev_name'] == "B700")
				{
					$where_param = "port_id = " . $array[$x]['port_id'];
				}				
							
				$hw_information = $data->select_statement ($db_location, $table_name, $param, $where_param);
			
				$table_name = $device[$c]['dev_name'] . "_" . $card_num . "_signalling";
				$param = "*";

				if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108" || $device[$c]['dev_name'] == "A200" || $device[$c]['dev_name'] == "A400" || $device[$c]['dev_name'] == "B600" || $device[$c]['dev_name'] == "B601")
				{
					$where_param = "port_id = " . $array[$x]['port_id'];
				}
				elseif ($device[$c]['dev_name'] == "A500" || $device[$c]['dev_name'] == "B700" )
				{
					$where_param = "id = " . $array[$x]['port_id'];
				}				
				
				$table = $data->check_for_table ($db_location, $table_name);
				if ($table > 1)
				{
					$sig_information = $data->select_statement ($db_location, $table_name, $param, $where_param);
				}
				if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108" ||$device[$c]['dev_name'] == "B601")
				{
					$table_name = $device[$c]['dev_name'] . "_" . $card_num . "_SS7_link";
					$param = "*";
					$where_param = "port_id = " . $array[$x]['port_id'];
					
					$table = $data->check_for_table ($db_location, $table_name);
					if ($table > 1)
					{
						$ss7_exist = "yes";
						$ss7_link_information = $data->select_statement ($db_location, $table_name, $param, $where_param);
					}
					
					$table_name = $device[$c]['dev_name'] . "_" . $card_num . "_SS7_ccspans";
					$param = "*";					
					$where_param = "port_id = " . $array[$x]['port_id'];
				
					$table = $data->check_for_table ($db_location, $table_name);
					if ($table > 1)
					{
						$ss7_ccspans_information = $data->select_statement ($db_location, $table_name, $param, $where_param);
					}
				}
				//If a device name exists for both tables, then the card is configured
				//Proceeds 
				if ($hw_information['dev_name'] != "" && $sig_information['dev_name'] != "" || $hw_information['dev_name'] != "" && $ss7_link_information['link_name'] != "" && $ss7_ccspans_information['profile_name'] != "" )
				{
					//echo $device[$c]['dev_name'] . " before config port id = " . $array[$x]['port_id'] . "<br />";
					//Check in perm_card_card-num
					$perm_table_name = "perm_" . $device[$c]['dev_name'] . "_" . $card_num;
					$perm_parameters = "dev_name";
					
					if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108" || $device[$c]['dev_name'] == "A200" || $device[$c]['dev_name'] == "A400" || $device[$c]['dev_name'] == "B600" || $device[$c]['dev_name'] == "B601")
					{
						$perm_where_param = "port_id = " . $array[$x]['port_id'];
					}
					elseif ($device[$c]['dev_name'] == "A500" || $device[$c]['dev_name'] == "B700")
					{
						$perm_where_param = "port_id = " . $array[$x]['port_id'];
					}
					
					$perm_hw_information = $data->select_statement ($db_location, $perm_table_name, $perm_parameters, $perm_where_param);		

					if ($perm_hw_information['dev_name'] == "")
					{
						if ($device[$c]['dev_name'] == "B601")
						{
							$b601_port[$x] = $array[$x]['port_id'];
						}
						//Insert
						if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108" || $device[$c]['dev_name'] == "B601")
						{
							$insert_param = "port_id, dev_name, line_type, coding, framing, clock, ref_clock, echo, dtmf, fax, lbo, txtristate, sigmode, impedence, rx_level, rxgain, txgain";
							$insert_values = "\"" . $hw_information['port_id'] . "\", \"" . $hw_information['dev_name'] . "\", \"" .$hw_information['line_type'] . "\", \"" .$hw_information['coding'] . "\", \"" . $hw_information['framing'] . "\", \"" . $hw_information['clock'] . "\",\"" . $hw_information['ref_clock'] . "\", \"" .$hw_information['echo']. "\", \"" . $hw_information['dtmf'] . "\", \"" . $hw_information['fax'] . "\", \"" . $hw_information['lbo'] . "\", \"" . $hw_information['txtristate'] . "\", \"" . $hw_information['sigmode'] . "\", \"" . $hw_information['impedence'] . "\", \"" . $hw_information['rx_level'] . "\", \"" . $hw_information['rxgain'] . "\", \"" . $hw_information['txgain'] . "\"";
						}
						elseif ($device[$c]['dev_name'] == "A500" || $device[$c]['dev_name'] == "B700")
						{
							$insert_param = "port_id, conn_type, dev_name, hw_ec, hw_dtmf, hw_fax, txgain, rxgain";
							$insert_values = $hw_information['port_id'] . ", \"" . $hw_information['conn_type'] . "\",  \"" . $hw_information['dev_name'] . "\", \"" . $hw_information['hw_ec'] . "\", \"" . $hw_information['hw_dtmf'] . "\", \"" . $hw_information['hw_fax'] . "\", \"" . $hw_information['txgain'] . "\", \"" . $hw_information['rxgain'] . "\"";							
						}
						elseif ($device[$c]['dev_name'] == "A200" || $device[$c]['dev_name'] == "A400" || $device[$c]['dev_name'] == "B600")
						{
							$insert_param = "port_id, dev_name, hw_ec, hw_dtmf, hw_fax, network_sync, txgain, rxgain";	
							$insert_values = $hw_information['port_id'] . ", \"" . $hw_information['dev_name'] . "\",\"" . $hw_information['hw_ec'] . "\", \"" . $hw_information['hw_dtmf']. "\", \"" . $hw_information['hw_fax'] . "\", \"" . $hw_information['network_sync'] . "\", \"" . $hw_information['txgain'] . "\", \"" . $hw_information['rxgain'] . "\"";
						}
						$data->insert_statement($db_location, $perm_table_name, $insert_param, $insert_values);
					}
					else
					{
						//Update
						if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108" || $device[$c]['dev_name'] == "B601")
						{
							$perm_update_parameters ="port_id = \"" . $hw_information['port_id'] . "\", dev_name = \"" . $hw_information['dev_name'] . "\", line_type = \"" . $hw_information['line_type'] . "\", coding = \"" . $hw_information['coding'] . "\", framing = \"" . $hw_information['framing'] . "\", clock = \"" . $hw_information['clock'] . "\", ref_clock = \"" . $hw_information['ref_clock'] . "\", echo = \"" . $hw_information['echo'] . "\", dtmf = \"" . $hw_information['dtmf'] . "\", fax = \"" . $hw_information['fax'] . "\", lbo = \"" . $hw_information['lbo'] . "\", txtristate = \"" . $hw_information['txtristate'] . "\", sigmode = \"" . $hw_information['sigmode'] . "\", impedence = \"" . $hw_information['impedence'] . "\", rx_level = \"" . $hw_information['rx_level'] . "\", rxgain = \"" . $hw_information['rxgain'] . "\", txgain = \"" . $hw_information['txgain'] . "\"";
							$perm_where_param = "port_id = " . $array[$x]['port_id'];
						}
						elseif ($device[$c]['dev_name'] == "A500" || $device[$c]['dev_name'] == "B700")
						{
							$perm_update_parameters = "port_id = \"" .  $hw_information['port_id'] . "\", conn_type = \"" . $hw_information['conn_type'] . "\", dev_name = \"" . $hw_information['dev_name'] . "\", hw_ec = \"" . $hw_information['hw_ec'] . "\", hw_dtmf = \"" . $hw_information['hw_dtmf'] . "\", hw_fax = \"" . $hw_information['hw_fax'] . "\", rxgain = \"" . $hw_information['rxgain'] . "\", txgain = \"" . $hw_information['txgain'] . "\"";
							$where_param = "port_id = " . $_SESSION['port_num_clicked'];							
							$perm_where_param = "id = " . $array[$x]['port_id'];
						}
						elseif ($device[$c]['dev_name'] == "A200" || $device[$c]['dev_name'] == "A400" || $device[$c]['dev_name'] == "B600")
						{
							$perm_update_parameters = "port_id = \"" .  $hw_information['port_id'] . "\", dev_name = \"" . $hw_information['dev_name'] . "\", hw_ec = \"" . $hw_information['hw_ec'] . "\", hw_dtmf = \"" . $hw_information['hw_dtmf'] . "\", hw_fax = \"" . $hw_information['hw_fax'] . "\", network_sync = \"" . $hw_information['network_sync'] . "\", rxgain = \"" . $hw_information['rxgain'] . "\", txgain = \"" . $hw_information['txgain'] . "\"";
							$perm_where_param = "port_id = 1";
						}						
						
						$data->update_table ($db_location, $perm_table_name, $perm_update_parameters, $perm_where_param);					
					}
					
					//Check in perm_card_card-num_signalling
					$perm_table_name = "perm_" . $device[$c]['dev_name'] . "_" . $card_num . "_signalling";
					$perm_parameters = "dev_name";

					if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108")
					{
						$perm_where_param = "port_id = " . $array[$x]['port_id'];
					}
					elseif ($device[$c]['dev_name'] == "A500" || $device[$c]['dev_name'] == "B700")
					{
						$perm_where_param = "id = " . $array[$x]['port_id'];
					}
					
					$table = $data->check_for_table ($db_location, $perm_table_name);
					//echo "$table <br />";
					if ($table > 1)
					{
						$perm_sig_information = $data->select_statement ($db_location, $perm_table_name, $perm_parameters, $perm_where_param);

						if ($perm_sig_information['dev_name'] == "")
						{
							//Insert
							if ($_SESSION['dahdi'] != "")
							{
								if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108")
								{
									$insert_param = "port_id, dev_name, line_type, signalling, channels, group_num, context";
									$insert_values = "\"" . $sig_information['port_id'] . "\", \"" . $sig_information['dev_name'] . "\", \"". $sig_information['line_type'] . "\", \"". $sig_information['signalling'] . "\", \"". $sig_information['channels'] . "\", \"". $sig_information['group_num'] . "\", \"". $sig_information['context'] . "\"" ;						
								}
								elseif ($device[$c]['dev_name'] == "A500")
								{
									$insert_param = "id, dev_name , profile_name, conn_type, sig_type, interface, switchtype, tei";
									$insert_values = "" . $sig_information['id'] . ", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"" . $sig_information['conn_type'] . "\", \"" . $sig_information['sig_type'] . "\", \"" . $sig_information['interface'] . "\", \"" . $sig_information['switchtype'] . "\", \"" . $sig_information['tei'] . "\"";
								}
								elseif ($device[$c]['dev_name'] == "B700")
								{
									$insert_param = "id, dev_name , profile_name, conn_type, sig_type, interface, switchtype, tei, codec, operation_mode";
									$insert_values = "" . $sig_information['id'] . ", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"" . $sig_information['conn_type'] . "\", \"" . $sig_information['sig_type'] . "\", \"" . $sig_information['interface'] . "\", \"" . $sig_information['switchtype'] . "\", \"" . $sig_information['tei'] . "\", \"" . $sig_information['codec'] . "\", \"" . $sig_information['operation_mode'] . "\"";
								}
								elseif ($device[$c]['dev_name'] == "B601")
								{
									$insert_param = "port_id, dev_name, profile_name, line_type, signalling, channels, group_num, context, codec, operation_mode";
									$insert_values = "\"" . $sig_information['port_id'] . "\", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"". $sig_information['line_type'] . "\", \"". $sig_information['signalling'] . "\", \"". $sig_information['channels'] . "\", \"". $sig_information['group_num'] . "\", \"". $sig_information['context'] . "\", \"" . $sig_information['codec'] . "\", \"" . $sig_information['operation_mode'] . "\"";		
								}							
							}
							elseif ($_SESSION['freetdm'] != "")
							{
								if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108")
								{							
									$insert_param = "port_id, dev_name, line_type, signalling, channels, group_num, ton_name, ton_value, npi_name, npi_value, facility, facility_timeout, bearer_ITC, bearer_UIL";
									$insert_values = "\"" . $sig_information['port_id'] . "\", \"" . $sig_information['dev_name'] . "\", \"". $sig_information['line_type'] . "\", \"". $sig_information['signalling'] . "\", \"". $sig_information['channels'] . "\", \"". $sig_information['group_num'] . "\", \"" . $sig_information['ton_name'] . "\",\"" . $sig_information['ton_value'] . "\",\"" . $sig_information['npi_name'] . "\",\"" . $sig_information['npi_value'] . "\",\"" . $sig_information['facility'] . "\",\"" . $sig_information['facility_timeout'] . "\", \"" . $sig_information['bearer_ITC'] . "\", \"" . $sig_information['bearer_UIL'] . "\"";	
								}
								elseif ($device[$c]['dev_name'] == "A500")
								{
									$insert_param = "id, dev_name, profile_name, conn_type, sig_type, interface, switchtype, tei, overlap, ton_name, ton_value, npi_name, npi_value, bearer_ITC, bearer_UIL, msn";
									$insert_values = "" . $sig_information['id'] . ", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"" . $sig_information['conn_type'] . "\", \"" . $sig_information['sig_type'] . "\", \"" . $sig_information['interface'] . "\", \"" . $sig_information['switchtype'] . "\", \"" . $sig_information['tei'] . "\", \"" . $sig_information['overlap'] . "\", \"" . $sig_information['ton_name'] . "\", \"" . $sig_information['ton_value'] . "\", \"" . $sig_information['npi_name'] . "\", \"" . $sig_information['npi_value'] . "\", \"" . $sig_information['bearer_ITC'] . "\", \"" . $sig_information['bearer_UIL'] . "\", \"" . $sig_information['msn'] . "\"";
								}
								elseif ($device[$c]['dev_name'] == "B700")
								{
									$insert_param = "id, dev_name, profile_name, conn_type, sig_type, interface, switchtype, tei, overlap, ton_name, ton_value, npi_name, npi_value, bearer_ITC, bearer_UIL, msn, codec, operation_mode";
									$insert_values = "" . $sig_information['id'] . ", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"" . $sig_information['conn_type'] . "\", \"" . $sig_information['sig_type'] . "\", \"" . $sig_information['interface'] . "\", \"" . $sig_information['switchtype'] . "\", \"" . $sig_information['tei'] . "\", \"" . $sig_information['overlap'] . "\", \"" . $sig_information['ton_name'] . "\", \"" . $sig_information['ton_value'] . "\", \"" . $sig_information['npi_name'] . "\", \"" . $sig_information['npi_value'] . "\", \"" . $sig_information['bearer_ITC'] . "\", \"" . $sig_information['bearer_UIL'] . "\", \"" . $sig_information['msn'] . "\",\"" . $sig_information['codec'] . "\",\"" . $sig_information['operation_mode'] . "\"";								
								}
								elseif ($device[$c]['dev_name'] == "B601")
								{
									$insert_param = "port_id, dev_name, profile_name, line_type, signalling, channels, group_num, ton_name, ton_value, npi_name, npi_value, facility, facility_timeout, bearer_ITC, bearer_UIL, codec, operation_mode";
									$insert_values = "\"" . $sig_information['port_id'] . "\", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"". $sig_information['line_type'] . "\", \"". $sig_information['signalling'] . "\", \"". $sig_information['channels'] . "\", \"". $sig_information['group_num'] . "\", \"" . $sig_information['ton_name'] . "\",\"" . $sig_information['ton_value'] . "\",\"" . $sig_information['npi_name'] . "\",\"" . $sig_information['npi_value'] . "\",\"" . $sig_information['facility'] . "\",\"" . $sig_information['facility_timeout'] . "\", \"" . $sig_information['bearer_ITC'] . "\", \"" . $sig_information['bearer_UIL'] . "\",\"" . $sig_information['codec'] . "\",\"" . $sig_information['operation_mode'] . "\"";										
								}							
							}
							
							if ($device[$c]['dev_name'] == "A200" || $device[$c]['dev_name'] == "A400" || $device[$c]['dev_name'] == "B600")
							{
								if ($_SESSION['freetdm'] != "")
								{
									$insert_param = "port_id, dev_name , profile_name, codec, operation_mode, group_num";
									$insert_values = "" . $sig_information['port_id'] . ", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"" . $sig_information['codec'] . "\", \"" . $sig_information['operation_mode'] . "\", \"" . $sig_information['group_num'] . "\"";
								}
								elseif ($_SESSION['dahdi'] != "")
								{
									$insert_param = "port_id, dev_name , profile_name, codec, operation_mode, group_num, context";
									$insert_values = "" . $sig_information['port_id'] . ", \"" . $sig_information['dev_name'] . "\", \"" . $sig_information['profile_name'] . "\", \"" . $sig_information['codec'] . "\", \"" . $sig_information['operation_mode'] . "\", \"" . $sig_information['group_num'] . "\", \"" . $sig_information['context'] . "\"";
								}
							}							
													
							$data->insert_statement($db_location, $perm_table_name, $insert_param, $insert_values);
						}
						else
						{
							//Update
							if ($_SESSION['dahdi'] != "")
							{
								if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108")
								{							
									$perm_update_parameters = "port_id = \"" . $sig_information['port_id'] . "\", dev_name = \"" . $sig_information['dev_name'] . "\", line_type = \"" . $sig_information['line_type'] . "\", signalling = \"" . $sig_information['signalling'] . "\", channels = \"" . $sig_information['channels'] . "\", group_num = \"". $sig_information['group_num'] . "\", context = \"" . $sig_information['context'] . "\"";					
								}
								elseif ($device[$c]['dev_name'] == "A500")
								{
									$perm_update_parameters = "id = " . $sig_information['id'] . ", dev_name = \"" . $sig_information['dev_name'] . "\", profile_name = \"" . $sig_information['profile_name'] . "\", conn_type = \"" . $sig_information['conn_type'] . "\", sig_type = \"" . $sig_information['sig_type'] . "\", interface = \"" . $sig_information['interface'] . "\", switchtype = \"" . $sig_information['switchtype'] . "\", tei = \"" . $sig_information['tei'] . "\"";								
								}
								elseif ($device[$c]['dev_name'] == "B700")
								{
									$perm_update_parameters = "id = " . $sig_information['id'] . ", dev_name = \"" . $sig_information['dev_name'] . "\", profile_name = \"" . $sig_information['profile_name'] . "\", conn_type = \"" . $sig_information['conn_type'] . "\", sig_type = \"" . $sig_information['sig_type'] . "\", interface = \"" . $sig_information['interface'] . "\", switchtype = \"" . $sig_information['switchtype'] . "\", tei = \"" . $sig_information['tei'] . "\", codec = \"" . $sig_information['codec'] . "\", operation_mode = \"" . $sig_information['operation_mode'] . "\"";								
								}
								elseif ($device[$c]['dev_name'] == "B601")
								{
									$perm_update_parameters = "port_id = \"" . $sig_information['port_id'] . "\", dev_name = \"" . $sig_information['dev_name'] . "\", profile_name =  \"" . $sig_information['profile_name'] . "\", line_type = \"" . $sig_information['line_type'] . "\", signalling = \"" . $sig_information['signalling'] . "\", channels = \"" . $sig_information['channels'] . "\", group_num = \"". $sig_information['group_num'] . "\", context = \"" . $sig_information['context'] . "\", codec = \"" . $sig_information['codec'] . "\", operation_mode = \"" . $sig_information['operation_mode'] . "\"";	
								}							
							}
							elseif ($_SESSION['freetdm'] != "")
							{
								if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108")
								{
									$perm_update_parameters = "port_id = \"" . $sig_information['port_id'] . "\", dev_name = \"" . $sig_information['dev_name'] . "\", line_type = \"" . $sig_information['line_type'] . "\", signalling = \"" . $sig_information['signalling'] . "\", channels = \"" . $sig_information['channels'] . "\", group_num = \"". $sig_information['group_num'] . "\", ton_name = \"" . $sig_information['ton_name'] . "\", ton_value = \"" . $sig_information['ton_value'] . "\", npi_name = " . $sig_information['npi_name'] . "\", npi_value = \"" . $sig_information['npi_value'] . "\", facility = \"" . $sig_information['facility'] . "\", facility_timeout = \"" . $sig_information['facility_timeout'] . "\", bearer_ITC = \"" . $sig_information['bearer_ITC'] . "\", bearer_UIL = \"" . $sig_information['bearer_UIL'] . "\"";	
								}
								if ($device[$c]['dev_name'] == "A500")
								{
									$perm_update_parameters = "id = " . $sig_information['id'] . ", dev_name = \"" . $sig_information['dev_name'] . "\",  profile_name = \"" . $sig_information['profile_name'] . "\", conn_type = \"" . $sig_information['conn_type'] . "\", sig_type = \"" . $sig_information['sig_type'] . "\", interface = \"" . $sig_information['interface'] . "\", switchtype = \"" . $sig_information['switchtype'] . "\", tei = \"" . $sig_information['tei'] . "\", overlap = \"" . $sig_information['overlap'] . "\", ton_name = \"" . $sig_information['ton_name'] . "\", ton_value = \"" . $sig_information['ton_value'] . "\", npi_name = \"" . $sig_information['npi_name'] . "\", npi_value = \"" . $sig_information['npi_value'] . "\", bearer_ITC =  \"" . $sig_information['bearer_ITC'] . "\", bearer_UIL = \"" . $sig_information['bearer_UIL'] . "\", msn = \"" . $sig_information['msn'] . "\"";								
								}
								if ($device[$c]['dev_name'] == "B700")
								{
									$perm_update_parameters = "id = " . $sig_information['id'] . ", dev_name = \"" . $sig_information['dev_name'] . "\",  profile_name = \"" . $sig_information['profile_name'] . "\", conn_type = \"" . $sig_information['conn_type'] . "\", sig_type = \"" . $sig_information['sig_type'] . "\", interface = \"" . $sig_information['interface'] . "\", switchtype = \"" . $sig_information['switchtype'] . "\", tei = \"" . $sig_information['tei'] . "\", overlap = \"" . $sig_information['overlap'] . "\", ton_name = \"" . $sig_information['ton_name'] . "\", ton_value = \"" . $sig_information['ton_value'] . "\", npi_name = \"" . $sig_information['npi_name'] . "\", npi_value = \"" . $sig_information['npi_value'] . "\", bearer_ITC =  \"" . $sig_information['bearer_ITC'] . "\", bearer_UIL = \"" . $sig_information['bearer_UIL'] . "\", msn = \"" . $sig_information['msn'] . "\", codec = \"" . $sig_information['codec'] . "\", operation_mode = \"" . $sig_information['operation_mode'] . "\"";								
								}
								elseif ($device[$c]['dev_name'] == "B601")
								{
									$perm_update_parameters = "port_id = \"" . $sig_information['port_id'] . "\", dev_name = \"" . $sig_information['dev_name'] . "\", line_type = \"" . $sig_information['line_type'] . "\",  profile_name =  \"" . $sig_information['profile_name'] . "\", signalling = \"" . $sig_information[	'signalling'] . "\", channels = \"" . $sig_information['channels'] . "\", group_num = \"". $sig_information['group_num'] . "\", ton_name = \"" . $sig_information['ton_name'] . "\", ton_value = \"" . $sig_information['ton_value'] . "\", npi_name = " . $sig_information['npi_name'] . "\", npi_value = \"" . $sig_information['npi_value'] . "\", facility = \"" . $sig_information['facility'] . "\", facility_timeout = \"" . $sig_information['facility_timeout'] . "\", bearer_ITC = \"" . $sig_information['bearer_ITC'] . "\", bearer_UIL = \"" . $sig_information['bearer_UIL'] . "\", codec = \"" . $sig_information['codec'] . "\", operation_mode = \"" . $sig_information['operation_mode'] . "\"";								
								}							
							}
						
							if ($device[$c]['dev_name'] == "A200" || $device[$c]['dev_name'] == "A400" || $device[$c]['dev_name'] == "B600")
							{
								if ($_SESSION['freetdm'] != "")
								{
									$perm_update_param = "port_id = " . $sig_information['port_id'] . ", dev_name = \"" . $sig_information['dev_name'] . "\", profile_name = \"" . $sig_information['profile_name'] . "\", codec = \"" . $sig_information['codec'] . "\", operation_mode = \"" . $sig_information['operation_mode'] . "\", group_num = \"" . $sig_information['group_num'] . "\"";
								}
								elseif ($_SESSION['dahdi'] != "")
								{
									$perm_update_param = "port_id = " . $sig_information['port_id'] . ", dev_name = \"" . $sig_information['dev_name'] . "\", profile_name = \"" . $sig_information['profile_name'] . "\", codec = \"" . $sig_information['codec'] . "\", operation_mode = \"" . $sig_information['operation_mode'] . "\", group_num = \"" . $sig_information['group_num'] . "\", context = \"" . $sig_information['context'] . "\"";
								}
								$perm_where_param = "port_id = 1";							
							}							
													
							$data->update_table ($db_location, $perm_table_name, $perm_update_parameters, $perm_where_param);
						}
					}
					//SS7 Tables
					if ($device[$c]['dev_name'] == "A101" || $device[$c]['dev_name'] == "A102" || $device[$c]['dev_name'] == "A104" || $device[$c]['dev_name'] == "A108" || $device[$c]['dev_name'] == "B601")
					{
						//Check in perm_card_card-num
						$perm_table_name = "perm_" . $device[$c]['dev_name'] . "_" . $card_num . "_SS7_link";
						$perm_parameters = "link_name";
					
						$perm_where_param = "port_id = " . $array[$x]['port_id'];
					
						$table = $data->check_for_table ($db_location, $perm_table_name);
						//echo "$table <br />";
						if ($table > 1)
						{
							$perm_ss7_link_information = $data->select_statement ($db_location, $perm_table_name, $perm_parameters, $perm_where_param);		
	
							if ($perm_ss7_link_information['link_name'] == "")
							{
								//Insert
								$insert_param = "port_id, link_name, span, sig_channel, error_type, lssu, priority, switchtype, SSF, SLC, link_type, line_type, voice, linkset";
								$insert_values = $ss7_link_information['port_id'] . ", \"" . $ss7_link_information['link_name'] . "\", " . $ss7_link_information['span'] . ", " . $ss7_link_information['sig_channel'] . ", \"" . $ss7_link_information['error_type'] . "\", " . $ss7_link_information['lssu'] . ", " . $ss7_link_information['priority'] . ", \"" . $ss7_link_information['switchtype'] . "\", \"" . $ss7_link_information['SSF'] . "\", " . $ss7_link_information['SLC'] . ", \"" . $ss7_link_information['link_type'] . "\", \"" . $ss7_link_information['line_type'] . "\", \"" . $ss7_link_information['voice'] . "\", \"" . $ss7_link_information['linkset'] . "\"";	
		
								$data->insert_statement($db_location, $perm_table_name, $insert_param, $insert_values);
							}
							else
							{
								//Update
								$perm_update_parameters = "port_id = \"" .  $ss7_link_information['port_id'] . "\", link_name = \"" .  $ss7_link_information['link_name'] . "\", span = " .  $ss7_link_information['span'] . ", sig_channel = " .  $ss7_link_information['sig_channel'] . ", error_type = \"" .  $ss7_link_information['error_type'] . "\", lssu = " .  $ss7_link_information['lssu'] . ", priority = " .  $ss7_link_information['priority'] . ", switchtype = \"" .  $ss7_link_information['switchtype'] . "\", SSF = \"" .  $ss7_link_information['SSF'] . "\", SLC = " .  $ss7_link_information['SLC'] . ", link_type = \"" .  $ss7_link_information['link_type'] . "\", line_type = \"" .  $ss7_link_information['line_type'] . "\", voice = \"" .  $ss7_link_information['voice'] . "\", linkset = \"" . $ss7_link_information['linkset'] . "\"";
								
								$perm_where_param = "port_id = " . $array[$x]['port_id'];
						
								$data->update_table ($db_location, $perm_table_name, $perm_update_parameters, $perm_where_param);	
							}
							
							//Check in perm_card_card-num
							$perm_table_name = "perm_" . $device[$c]['dev_name'] . "_" . $card_num . "_SS7_ccspans";
							$perm_parameters = "profile_name";
						
							$perm_where_param = "port_id = " . $array[$x]['port_id'];
						
							$perm_ss7_ccspans_information = $data->select_statement ($db_location, $perm_table_name, $perm_parameters, $perm_where_param);		
	
							if ($perm_ss7_ccspans_information['profile_name'] == "")
							{
								//Insert
								//$insert_param = "port_id, profile_name, isup, cic, channels, min_digits, clg_nadi, cld_nadi, obci_bita, typeCntrl, group_num";
								$insert_param = "port_id, profile_name, isup, cic, channels, min_digits, clg_nadi, cld_nadi, obci_bita, typeCntrl, group_num";
								$insert_values = $ss7_ccspans_information['port_id'] . ", \"" . $ss7_ccspans_information['profile_name'] . "\", \"" . $ss7_ccspans_information['isup'] . "\", " . $ss7_ccspans_information['cic'] . ", \"" . $ss7_ccspans_information['channels'] . "\", \"" . $ss7_ccspans_information['min_digits'] . "\", \"" . $ss7_ccspans_information['clg_nadi'] . "\", \"" . $ss7_ccspans_information['cld_nadi'] . "\", \"" . $ss7_ccspans_information['obci_bita'] . "\", \"" . $ss7_ccspans_information['typeCntrl'] . "\", " . $ss7_ccspans_information['group_num'] . "";
		
							$data->insert_statement($db_location, $perm_table_name, $insert_param, $insert_values);
							}
							else
							{
								//Update
								$perm_update_parameters = "profile_name = \"" . $ss7_ccspans_information['profile_name'] . "\", cic = \"" . $ss7_ccspans_information['cic'] . "\", isup = \"" . $ss7_ccspans_information['isup'] . "\", channels = \"" . $ss7_ccspans_information['channels'] . "\", min_digits = " . $ss7_ccspans_information['min_digits'] . ", clg_nadi = " . $ss7_ccspans_information['clg_nadi'] . ", cld_nadi = " . $ss7_ccspans_information['cld_nadi'] . ", obci_bita = " . $ss7_ccspans_information['obci_bita'] . ", typeCntrl = \"" . $ss7_ccspans_information['typeCntrl'] . "\", group_num = \"" . $ss7_ccspans_information['group_num'] . "\"";
								
								$perm_where_param = "port_id = " . $array[$x]['port_id'];
						
								$data->update_table ($db_location, $perm_table_name, $perm_update_parameters, $perm_where_param);	
							}						
						}	
					}
				}
			}
		}
		
		//Create permananent linkset/route/isup tables and copy information into them
		$table_name = "ss7_linkset_profile";
		$new_table = "perm_ss7_linkset_profile";
		$parameters = "id, profile_name, apc, minactive";
		$data->select_into ($db_location, $table_name, $parameters, $new_table);		
		
		$table_name = "ss7_route_profile";
		$new_table = "perm_ss7_route_profile";
		$parameters = "id, profile_name, dpc, stp";
		$data->select_into ($db_location, $table_name, $parameters, $new_table);
		
		$table_name = "ss7_isup_profile";
		$new_table = "perm_ss7_isup_profile";
		$parameters = "id, profile_name, spc, route";
		$data->select_into ($db_location, $table_name, $parameters, $new_table);
		
		//echo "generate <br />";
		//Starts the generation process
		//$a = Number of cards in the system
		//tokenize the dev_name
		//unset ($array);
		$l = 0;

		for ($b = 1; $b < $a; $b++)
		{
			//echo "b = $b<br />";
			//echo "port = " . $array[$b]['port_id'] . "<br />";
			 $device[$b]['dev_name'] = $tokenization->tokenize_wanpipe($cards[$b]['dev_name']);
			 $card_num = $cards[$b]['id'];
			 $db_location = "sqlite:sqlite/cardinfo.db";
			 
			 $table_name = "perm_" . $device[$b]['dev_name'] . "_" . $card_num;
			 
			 //Check if database exists
			 $total = $data->check_for_table ($db_location, $table_name);
			 
			 if ($total > 1)
			 {
				try
				{
					$select = "SELECT port_id FROM ". $table_name . " ORDER BY port_id;";

					//While Loop Counter
					$port_count = 0;
	
					//open the database
					$db = new PDO($db_location);

					$result = $db->query($select);
						
				    foreach($result as $row)
				    {			
						$array[$b][$port_count] = $row['port_id'];
						//$array[$port_count]['port_id'] = $row['port_id'];
						//echo $device[$b]['dev_name'] . " port = " . $array[$b][$port_count]['port_id'] . "<br />"; 
						$port_count++;
					}
					// close the database connection
					$db = NULL;
				}
				catch(PDOException $e)
				{
					print 'Exception : '.$e->getMessage();
				}					 
						 
				$device[$b]['port_num']	= $port_count;	
				//echo $device[$b]['port_num'] . "<br />";		
			}
		}
		
		//Get the port type from the b700 hardware table
		$conn = 0;
		for ($b = 1; $b < $a; $b++)
		{
			if ($device[$b]['dev_name'] == "B700")
			{	
				$table = "perm_" . $device[$b]['dev_name'] . "_" . $cards[$b]['id'];
				$select = "SELECT port_id, conn_type FROM " . $table . " ORDER BY port_id;";
				//echo $select . "<br />";

				try
				{
					//open the database
					$db = new PDO($db_location);
		
					$result = $db->query($select);
				
					foreach($result as $row)
					{
						$connection[$conn] = $row['conn_type'];
						//echo "Port if = " . $row['port_id'] . "<br />";
						if ($connection[$conn] == "FXO")
						{
							$fxo_exist = "yes";
						}
						elseif ($connection[$conn] == "FXS")
						{
							$fxs_exist = "yes";
						}
						
						$conn++;
						
					}
					// close the database connection
					$db = NULL;
					}
				catch(PDOException $e)
				{
					//echo "hello <br />";
					print 'Exception : '.$e->getMessage();
				}
			}
		}	
		
		//$a is the number of cards in the system
		//$device[$b]['dev_name'] = Device Name (Tokenized)
		//$device[$b]['port_num'] is a calculation of the number of ports for each card that needs to be generated
		$x = 0;
		
		//Determine the API
		if ($_SESSION['dahdi'] != "")
		{
			$API = "TDM_VOICE";
			$BRI_API = "TDM_VOICE_API";
			$BRI_SPAN = 1;
			$DAHDI_SPAN = 1;
		}
		elseif ($_SESSION['freetdm'] != "")
		{
			$API = "TDM_VOICE_API";
		}
		
		$a500 = $_SESSION['a500_ports'];
		$b700 = $_SESSION['b700_ports'];
		//echo "wanpipe <br />";
		shell_exec("mkdir /etc/wanpipe/wanpipe_old_configs");
		shell_exec("mv /etc/wanpipe/wanpipe*.conf /etc/wanpipe/wanpipe_old_configs/");
		
		$p = 1;	
		for ($b = 1; $b < $a; $b++)
		{		
			if ($device[$b]['dev_name'] == "B700")						
			{
				for ($l = 1; $l <= count($b700); $l++)
				{
					//echo "Port = " . $a500[$l] . "<br />";echo "Port = " . $a500[$l] . "<br />";
					//Check to see which ports were configured
					$db_location = "sqlite:sqlite/cardinfo.db";
					$table = "perm_" . $device[$b]['dev_name'] . "_" . $cards[$b]['id'] . "_signalling";
					$where = "id = " . $b700[$l];
					$result = $data->select_statement($db_location, $table, "id", $where);
					
					if ($result['id'] != "")
					{
						$b700_port[$p] = $_SESSION['b700_ports'][$l];
						//echo "Port = " . $a500_port[$p] . "<br />";
						$p++;
					}
				}
				$device[$b]['port_num']	= $p;
			}
		}			
		
		$p = 0;	
		for ($b = 1; $b < $a; $b++)
		{		
			if ($device[$b]['dev_name'] == "A500")						
			{
				for ($l = 1; $l <= count($a500); $l++)
				{
					//echo "Port = " . $a500[$l] . "<br />";echo "Port = " . $a500[$l] . "<br />";
					//Check to see which ports were configured
					$db_location = "sqlite:sqlite/cardinfo.db";
					$table = "perm_" . $device[$b]['dev_name'] . "_" . $cards[$b]['id'] . "_signalling";
					$where = "id = " . $a500[$l];
					$result = $data->select_statement($db_location, $table, "id", $where);
					
					if ($result['id'] != "")
					{
						$p++;
						$a500_port[$p] = $_SESSION['a500_ports'][$l];
						//echo "$p, Port = " . $a500_port[$p] . "<br />";
					}
				}
				$device[$b]['port_num']	= $p;
			}
		}					
				
		for ($b = 1; $b < $a; $b++)
		{	
			$num = 0;
			//echo "Card Ports = " . $device[$b]['port_num'] . "<br />";
			for ($c = 0; $c < $device[$b]['port_num']; $c++)
			{
				//echo "port = " . $a500_port[$c] . "<br />";

				$x++;
				//echo $device[$b]['port_num'] . "<br />";
				//echo "<b>" . $device[$b]['dev_name'] . " before config port id = " . $array[$b][$c]['port_id'] . "</b><br />";	
				if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108")
				{
					//Initialize class
					$wanpipe_config = new T1_E1_wanpipe_dahdi;
					//$port = $c + 1;
					//Gather information
					//echo $c . "<br />";
					$wanpipe_config->populate_vars($device[$b]['dev_name'], $cards[$b]['id'], $x, $array[$b][$c]['port_id'] , $data, $DAHDI_SPAN);
					//Generate config
					$wanpipe_config->A10x_template($API);
					
					$wanpipe[$x] = "wanpipe" . $x;
					
					$DAHDI_SPAN++;
				}
				elseif ($device[$b]['dev_name'] == "B601" &&  $b601_port[$c] == 1)
				{
					//Initialize class
					$wanpipe_config = new T1_E1_wanpipe_dahdi;
						
					//Gather information
					$wanpipe_config->populate_vars($device[$b]['dev_name'], $cards[$b]['id'], $x,  $b601_port[$c], $data, $DAHDI_SPAN);
					//Generate config
					$wanpipe_config->A10x_template($API);
					
					$wanpipe[$x] = "wanpipe" . $x;
					
					$DAHDI_SPAN++;					
				}
				elseif ($device[$b]['dev_name'] == "B601" &&  $b601_port[$c] == 2)
				{
					//Initialize class
					$wanpipe_config = new analog_wanpipe_dahdi;
						
					//Gather information
					$wanpipe_config->populate_vars($device[$b]['dev_name'], $cards[$b]['id'], $x,  $b601_port[$c], $data, $DAHDI_SPAN);
					//Generate config
					$wanpipe_config->analog_template($API);
					
					$wanpipe[$x] = "wanpipe" . $x;
					
					$DAHDI_SPAN++;
				}
				elseif ($device[$b]['dev_name'] == "A200" || $device[$b]['dev_name'] == "A400" || $device[$b]['dev_name'] == "B600" )
				{
					//Initialize class
					$wanpipe_config = new analog_wanpipe_dahdi;
					$port = $c + 1;		
					//Gather information
					$wanpipe_config->populate_vars($device[$b]['dev_name'], $cards[$b]['id'], $x, $port, $data, $DAHDI_SPAN);
					//Generate config
					$wanpipe_config->analog_template($API);
					
					$wanpipe[$x] = "wanpipe" . $x;
					
					$DAHDI_SPAN++;
				}
				if ($device[$b]['dev_name'] == "B700")				
				{
					if ($connection[$c] == "FXO" || $connection[$c] == "FXS")
					{
						//Initialize class
						$wanpipe_config = new analog_wanpipe_dahdi;
						$num = $c + 1;	
						//Gather information
						$wanpipe_config->populate_vars($device[$b]['dev_name'], $cards[$b]['id'], $x, $b700_port[$num], $data, $DAHDI_SPAN);
						//Generate config
						$wanpipe_config->analog_template($API);
					
						$wanpipe[$x] = "wanpipe" . $x;
						
						$DAHDI_SPAN++;						
					}				
				}
				elseif ($device[$b]['dev_name'] == "A500")
				{	
					//Initialize class
					$wanpipe_config = new BRI_wanpipe;
					//$port = $array[$b][$c]['port_id'];	
					$num = $c+1;
					//echo "$c, port = " . $a500_port[$c] . "<br />";
					//echo "<b>card = " . $device[$b]['dev_name'] . " on port " . $array[$b][$c]['port_id'] . "</b><br />";
					//Gather information
					$wanpipe_config->populate_vars($device[$b]['dev_name'], $cards[$b]['id'], $x, $a500_port[$num], $data, $BRI_SPAN);
					//Generate config
					if ($_SESSION['dahdi'] != "")
					{
						$wanpipe_config->A500_template($BRI_API);
					}
					elseif ($_SESSION['freetdm'] != "")
					{
						$wanpipe_config->A500_template($API);
					}
					
					$wanpipe[$x] = "wanpipe" . $x;					
					
					$BRI_SPAN++;					
				}
				if ($device[$b]['dev_name'] == "B700")
				{
					$num = $c+1;
					//echo "<b>card = " . $device[$b]['dev_name'] . " on port " . $b700_port[$num] . "</b><br />";
					//echo "$c = " . $connection[$c] . "<br />";							
					if ($connection[$c] == "NT" || $connection[$c] == "TE")
					{ 	
						//Initialize class
						$wanpipe_config = new BRI_wanpipe;
						$num = $c + 1;
						//Gather information
						$wanpipe_config->populate_vars($device[$b]['dev_name'], $cards[$b]['id'], $x, $b700_port[$num], $data, $BRI_SPAN);
						//Generate config
						if ($_SESSION['dahdi'] != "")
						{
							$wanpipe_config->A500_template($BRI_API);
						}
						elseif ($_SESSION['freetdm'] != "")
						{
							$wanpipe_config->A500_template($API);
						}
						
						$wanpipe[$x] = "wanpipe" . $x;					
						
						$BRI_SPAN++;					
					}
				}
			}
		}			
		
		//Loops to figure out all the wanpipeX.conf to include in the wanrouter.rc file
		for ($l = 1; $l <= $x; $l++)
		{
			$wanpipes = $wanpipes . $wanpipe[$l] . " ";
		}
		
		$wanpipe_common_functions = new wanpipe_common;
		
		//Generates the wanrouter.rc file to use
		$wanpipe_common_functions->wanrouter_rc($wanpipes);

		//If $input['wanrouter'] is YES create wanrouter start scripts
		if ($input['wanrouter'] == "YES")
		{
			$wanpipe_common_functions->wanrouter_start_script();
			$_SESSION['wanrouter'] = "YES";
		}
		elseif ($input['wanrouter'] == "NO")
		{
			$wanpipe_common_functions->wanrouter_no_startup();
			$_SESSION['wanrouter'] = "NO";
		}
		
		
		//If you are using an analog card, it will detect the positions of the FXO and FXS modules
		$x = 0;
		for ($b = 1; $b < $a; $b++)
		{	
			for ($c = 0; $c < $device[$b]['port_num']; $c++)
			{
				//echo "card = " . $device[$b]['dev_name'] . " " . $array[$c]['port_id'] . "<br />";
				$x++;
				if ($device[$b]['dev_name'] == "A200" || $device[$b]['dev_name'] == "A400" || $device[$b]['dev_name'] == "B600" || $device[$b]['dev_name'] == "B601" && $b601_port[$c] == 2)
				{
					$count = 0;
					$wanrouter_hwprobe = exec ('wanrouter hwprobe dump', $output);
					$counter = count($output);
					//echo "counter = $counter<br />";
					for ($l = 0; $l < $counter; $l ++)
					{
						if (preg_match('/(\d+)(.*):.*SLOT=(\d+).*BUS=(\d+).*CPU=(\w+).*PORT=(\w+).*/', $output[$l]) || preg_match('/(\d+).(\w+\w+).*SLOT=(\d+).*BUS=(\d+).*(\w+).*PORT=(\w+).*HWEC=(\d+)/', $output[$l]))
						{
							$tok = strtok($output[$l], "|");
					
							while ($tok !== false)
							{
								$card_token[$card_count] = $tok;
								$tok = strtok("|");
								$card_count++;
							}
						}
					}
					
					$tok = "";
					
					for ($u = 0; $u <= $card_count; $u ++)
					{	
						$tok = strtok($card_token[$u], "=");
				
						while ($tok !== false)
						{
							$tokenize[$values] = $tok;
							$tok = strtok("=");
							$values++;
						}
					}
					
					//Find the analog cards
					for ($analog = 0; $analog <= $values; $analog++)
					{
						$count_module = 0;
						
						if ($tokenize[$analog] == "AFT-A200-SH")
						{
							$analog_token = $analog + 66;
							for ($module = $analog; $module <= $analog_token; $module++)
							{
								if ($tokenize[$module] == "FE")
								{
									$count_module++;
									$module_type = $module + 1;
									$a200_module_position[$count_module] = $tokenize[$module_type];
									if ($tokenize[$module_type] == "FXS")
									{
										$fxs_exist = "yes";
									}
									elseif ($tokenize[$module_type] == "FXO")
									{
										$fxo_exist = "yes";
									}
									//echo "$count_module = $a200_module_position[count_module]<br />";									
								}
							}
						}
						elseif ($tokenize[$analog] == "AFT-A400-SH")
						{
							$analog_token = $analog + 66;
							for ($module = $analog; $module <= $analog_token; $module++)
							{
								if ($tokenize[$module] == "FE")
								{
									$count_module++;
									$module_type = $module + 1;
									//echo "$module = $tokenize[$module_type]<br />";
									$a400_module_position[$count_module] = $tokenize[$module_type];
									if ($tokenize[$module_type] == "FXS")
									{
										$fxs_exist = "yes";
									}
									elseif ($tokenize[$module_type] == "FXO")
									{
										$fxo_exist = "yes";
									}
								}
							}			
						}
						elseif ($tokenize[$analog] == "AFT-B600-SH")
						{
							$analog_token = $analog + 26;
							for ($module = $analog; $module <= $analog_token; $module++)
							{
								if ($tokenize[$module] == "FE")
								{
									$count_module++;
									$module_type = $module + 1;
									//echo "$module = $tokenize[$module_type]<br />";
									$b600_module_position[$count_module] = $tokenize[$module_type];
									
									if ($tokenize[$module_type] == "FXS")
									{
										$fxs_exist = "yes";
									}
									elseif ($tokenize[$module_type] == "FXO")
									{
										$fxo_exist = "yes";
									}									
								}
							}							
						}
						elseif ($tokenize[$analog] == "AFT-B601-SH")
						{
							$analog_token = $analog + 26;
							for ($module = $analog; $module <= $analog_token; $module++)
							{
								if ($tokenize[$module] == "FE")
								{
									$count_module++;
									$module_type = $module + 1;
									//echo "$module = $tokenize[$module_type]<br />";
									
									
									if ($tokenize[$module_type] == "FXS")
									{
										$b601_module_position[$count_module] = $tokenize[$module_type];										
										$fxs_exist = "yes";
									}
									elseif ($tokenize[$module_type] == "FXO")
									{
										$b601_module_position[$count_module] = $tokenize[$module_type];										
										$fxo_exist = "yes";
									}									
								}
							}							
						}																		
					}
					//echo  "------------------<br />";								
				}
			}
		}
				
		//echo "Number of modules in A200 = " . count($a200_module_position) . "<br />";
		//echo "Number of modules in A400 = " . count($a400_module_position) . "<br />";
		//echo "Number of modules in B600 = " . count($b600_module_position) . "<br />";
		//echo "Number of modules in B601 = " . count($b601_module_position) . "<br />";		
		
		/*for ($z = 1; $z <= count($a200_module_position); $z++)
		{
			echo "$z = $a200_module_position[$z]<br />";
		}
				echo  "------------------<br />";			
		for ($z = 1; $z <= count($a400_module_position); $z++)
		{
			echo "$z = $a400_module_position[$z]<br />";
		}
		for ($z = 1; $z <= count($b600_module_position); $z++)
		{
			echo "$z = $b600_module_position[$z]<br />";
		}
				echo  "------------------<br />";
				
		for ($z = 1; $z <= count($b601_module_position); $z++)
		{
			echo "$z = $b601_module_position[$z]<br />";
		}	*/
			
		
				
		
		//If dahdi/zaptel module is detected, generate 
		//"/etc/asterisk/chan_dahdi.conf"/"/etc/asterisk/zapata.conf" & "/etc/dahdi/system.conf"/"/etc/zaptel.conf"			
		if ($_SESSION['dahdi'] != "")
		{
			//Initializes seperate spans for each type of devices
			$DAHDI_SPAN = 1;
			$BRI_SPAN = 1;
			
			shell_exec ("cp smg_ctrl/woomera.conf.template smg_ctrl/woomera.conf");
			shell_exec ("cp smg_ctrl/smg_bri.conf.template smg_ctrl/smg_bri.conf");			
			
			//Initializes the dahdi class
			$smg_ctrl = new BRI_SMG;
			$dahdi_cfg = new Dahdi_configuration;

			$dahdi_cfg->system_conf("");
			$dahdi_cfg->chan_dahdi_conf("");

			$x = 0;
			for ($b = 1; $b < $a; $b++)
			{			
				for ($c = 0; $c < $device[$b]['port_num']; $c ++)
				{				
					$x++;
					
					if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108" )
					{
						$port = $c + 1;
						//populate class
						$dahdi_cfg->populate($device[$b]['dev_name'], $cards[$b]['id'], $DAHDI_SPAN,$array[$b][$c]['port_id'], $data,"", $x);
						
						//create system.conf
						$dahdi_cfg->system_conf("True");
						//chan_dahdi.conf
						$dahdi_cfg->chan_dahdi_conf("True");							
						$DAHDI_SPAN++;
					}	
					elseif ($device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
					{
						//populate class
						$dahdi_cfg->populate($device[$b]['dev_name'], $cards[$b]['id'], $DAHDI_SPAN,$b601_port[$c], $data,"", $x);
						
						//create system.conf
						$dahdi_cfg->system_conf("True");
						//chan_dahdi.conf
						$dahdi_cfg->chan_dahdi_conf("True");							
						$DAHDI_SPAN++;						
					}
					elseif ($device[$b]['dev_name'] == "A200")
					{
						$port = $c + 1;
						//populate class
						$dahdi_cfg->populate($device[$b]['dev_name'], $cards[$b]['id'], $DAHDI_SPAN,$port, $data, $a200_module_position, $x);
		
						//create system.conf
						$dahdi_cfg->system_conf("True");
						//chan_dahdi.conf
						$dahdi_cfg->chan_dahdi_conf("True");							
						$DAHDI_SPAN++;
					}
					elseif ($device[$b]['dev_name'] == "A400")
					{
						$port = $c + 1;
						//populate class
						$dahdi_cfg->populate($device[$b]['dev_name'], $cards[$b]['id'], $DAHDI_SPAN,$port, $data, $a400_module_position, $x);
		
						//create system.conf
						$dahdi_cfg->system_conf("True");
						//chan_dahdi.conf
						$dahdi_cfg->chan_dahdi_conf("True");							
						$DAHDI_SPAN++;
					}	
					elseif ($device[$b]['dev_name'] == "B600")
					{
						$port = $c + 1;
						//populate class
						$dahdi_cfg->populate($device[$b]['dev_name'], $cards[$b]['id'], $DAHDI_SPAN,$port, $data, $b600_module_position, $x);
		
						//create system.conf
						$dahdi_cfg->system_conf("True");
						//chan_dahdi.conf
						$dahdi_cfg->chan_dahdi_conf("True");							
						$DAHDI_SPAN++;
					}
					elseif ($device[$b]['dev_name'] == "B601" && $b601_port[$c] == 2)
					{
						//populate class
						$dahdi_cfg->populate($device[$b]['dev_name'], $cards[$b]['id'], $DAHDI_SPAN,$b601_port[$c], $data, $b601_module_position, $x);
		
						//create system.conf
						$dahdi_cfg->system_conf("True");
						//chan_dahdi.conf
						$dahdi_cfg->chan_dahdi_conf("True");							
						$DAHDI_SPAN++;
					}																
					elseif ($device[$b]['dev_name'] == "A500")
					{
						$num = $c + 1;
						//populate class
						$smg_ctrl->populate($device[$b]['dev_name'], $cards[$b]['id'], $BRI_SPAN,$a500_port[$num], $data,"");
		
						//create system.conf
						$smg_ctrl->smg_bri();
						//chan_dahdi.conf
						$smg_ctrl->woomera();							
						$BRI_SPAN++;						
					}
					elseif ($device[$b]['dev_name'] == "B700")
					{
						$num = $c + 1;
						if ($connection[$c] == "NT" || $connection[$c] == "TE")
						{
							//populate class
							$smg_ctrl->populate($device[$b]['dev_name'], $cards[$b]['id'], $BRI_SPAN,$b700_port[$num], $data,"");
		
							//create system.conf
							$smg_ctrl->smg_bri();
							//chan_dahdi.conf
							$smg_ctrl->woomera();							
							$BRI_SPAN++;	
						}
						elseif ($connection[$c] == "FXS" || $connection[$c] == "FXO")
						{
							$dahdi_cfg->b700_module = $connection[$c];
							
							//populate class
							$dahdi_cfg->populate($device[$b]['dev_name'], $cards[$b]['id'], $DAHDI_SPAN,$b700_port[$num], $data, "", $x);
		
							//create system.conf
							$dahdi_cfg->system_conf("True");
							//chan_dahdi.conf
							$dahdi_cfg->chan_dahdi_conf("True");							
							$DAHDI_SPAN++;
						}
					}					
				}
			}					
			
			shell_exec ("mv chan_dahdi.conf /etc/asterisk");
			shell_exec ("mv system.conf /etc/dahdi");	
			shell_exec ("mv smg_ctrl/woomera.conf /etc/asterisk");
			shell_exec ("mv smg_ctrl/smg_bri.conf /etc/wanpipe");			
			
			//If run dahdi_cfg is selected, include the start file within the /etc/wanpipe/scripts directory
			if ($input['dahdi_cfg'] == "YES")
			{
				$dahdi_cfg->start_wanrouter_dahdi();
				$_SESSION['dahdi_cfg'] = "YES";
			}
			elseif ($input['dahdi_cfg'] == "NO")
			{
				$dahdi_cfg->no_dahdi_cfg();
				$_SESSION['dahdi_cfg'] = "NO";
			}
			
			//smg_bri functions
			if ($input['smg_bri'] == "YES")
			{
				if ($input['dahdi_cfg'] == "YES")
				{
					$smg_ctrl->append_start_script();
				}
				else
				{
					shell_exec("cp smg_ctrl/start /etc/wanpipe/scripts");
				}
				$_SESSION['smg_bri'] = "YES";				
			}
			elseif ($input['smg_bri'] == "NO")
			{
				if ($input['dahdi_cfg'] == "YES")
				{
					shell_exec ("cp dahdi_config/start /etc/wanpipe/scripts");
				}
				else
				{
					shell_exec ("rm /etc/wanpipe/scripts/start");
				}
				$_SESSION['smg_bri'] = "NO";								
			}
		}
		
		//If FreeTDM module is found, generate
		//"PATHTOSMG/conf/freetdm.conf" and "PATHTOSMG/conf/autoload_configs/freetdm.conf.xml"
		elseif ($_SESSION['freetdm'] != "")
		{
			//initializes the freetdm class
			$freetdm_cfg = new freetdm_configuration;
			$freetdm_cfg->freetdm_conf("", "");
			$freetdm_cfg->freetdm_xml("");
			unset ($_SESSION['last_t1_e1_profile']);
			unset ($_SESSION['last_bri_profile']);

			$x = 0;
			for ($b = 1; $b < $a; $b++)
			{			
				for ($c = 0; $c < $device[$b]['port_num']; $c ++)
				{				
					$x++;
					
					if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108")
					{
						$port = $c + 1;
						//populate class
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$array[$b][$c]['port_id'] , $data);
		
						//create freetdm.conf
						$freetdm_cfg->freetdm_conf("hello", "");

						if ($freetdm_cfg->ss7_span == "no")
						{
							//echo "I am here<br />";							
							//freetdm.conf.xml profile portion
							$freetdm_cfg->freetdm_xml("Profile");							
						}
					}
					elseif ($device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
					{
						//populate class
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);
		
						//create freetdm.conf
						$freetdm_cfg->freetdm_conf("hello", "");

						if ($freetdm_cfg->ss7_span == "no")
						{
							//echo "I am here<br />";							
							//freetdm.conf.xml profile portion
							$freetdm_cfg->freetdm_xml("Profile");							
						}
					}						
					if ($device[$b]['dev_name'] == "A500")
					{
						$num = $c + 1;
						//populate class
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$a500_port[$num], $data);
		
						//create freetdm.conf
						$freetdm_cfg->freetdm_conf("hello", "");
							
						//freetdm.conf.xml profile portion
						$freetdm_cfg->freetdm_xml("Profile");							
					}
					if ($device[$b]['dev_name'] == "B700")
					{
						$num = $c + 1;
						//echo "module = " . $connection[$c] . "<br />";
						if ($connection[$c] == "NT" || $connection[$c] == "TE")
						{
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b700_port[$num], $data);
							//echo "value = " . $freetdm_cfg->facility . "<br />";
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "");
								
							//freetdm.conf.xml profile portion
							$freetdm_cfg->freetdm_xml("Profile");							
						}
					}					
				}
			}	
			
			//Starts the FXS/FXO headers in freetdm.conf
			//echo $fxo_exist . "<br />";
			if ($fxo_exist == "yes")
			{
				//Start the FXO Header if FXO exists
				$freetdm_cfg->freetdm_conf("empty_fxo", "");				

				//FXO Channels
				$x = 0;
				for ($b = 1; $b < $a; $b++)
				{			
					for ($c = 0; $c < $device[$b]['port_num']; $c ++)
					{				
						$x++;
						
						//Perform FXO Span data
						if ($device[$b]['dev_name'] == "A200")				
						{
							unset ($freetdm_cfg->module_list);
							$port = $c + 1;
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$port, $data, $a200_module_position);
			
							$freetdm_cfg->module_list = $a200_module_position;

							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXO");
															
						}
						if ($device[$b]['dev_name'] == "A400")				
						{
							unset ($freetdm_cfg->module_list);
							$port = $c + 1;
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$port, $data, $a400_module_position);
			
							$freetdm_cfg->module_list = $a400_module_position;
							
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXO");
								
						}
						if ($device[$b]['dev_name'] == "B600")				
						{
							unset ($freetdm_cfg->module_list);
							$port = $c + 1;
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$port, $data, $b600_module_position);
				
							$freetdm_cfg->module_list = $b600_module_position;
			
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXO");	
						}
						if ($device[$b]['dev_name'] == "B601" && $b601_port[$c] == 2)				
						{
							unset ($freetdm_cfg->module_list);
							//echo "i am here <br />";
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data, $b601_module_position);
				
							$freetdm_cfg->module_list = $b601_module_position;
			
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXO");	
						}						
						if ($device[$b]['dev_name'] == "B700")				
						{
							$port = $c + 1;
							//echo "module = " . $connection[$c] . "<br />";
							if ($connection[$c] == "FXO")
							{
								$num = $c + 1;
								unset ($freetdm_cfg->module_list);
								//populate class
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b700_port[$num], $data, "");
					
								$freetdm_cfg->module_list[1] = "FXO";
								$freetdm_cfg->module_list[2] = "FXO";
								echo 
								//create freetdm.conf
								$freetdm_cfg->freetdm_conf("hello", "FXO");	
							}
						}						
					}
				}	
			}
			
			//Starts the FXS/FXO headers in freetdm.conf
			if ($fxs_exist == "yes")
			{
				//Start the FXS header if FXS exists
				$freetdm_cfg->freetdm_conf("empty_fxs", "");
			
				//FXS Channels
				$x = 0;
				for ($b = 1; $b < $a; $b++)
				{			
					for ($c = 0; $c < $device[$b]['port_num']; $c ++)
					{			
						$x++;
						//Perform FXS Span data
						if ($device[$b]['dev_name'] == "A200")				
						{
							unset ($freetdm_cfg->module_list);
							$port = $c + 1;
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$port, $data, $a200_module_position);
			
							$freetdm_cfg->module_list = $a200_module_position;
			
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXS");
								
						}
						if ($device[$b]['dev_name'] == "A400")				
						{
							unset ($freetdm_cfg->module_list);
							$port = $c + 1;
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$port, $data, $a400_module_position);
	
							$freetdm_cfg->module_list = $a400_module_position;
			
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXS");
								
						}
						if ($device[$b]['dev_name'] == "B600")				
						{
							unset ($freetdm_cfg->module_list);
							$port = $c + 1;
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$port, $data, $b600_module_position);
	
							$freetdm_cfg->module_list = $b600_module_position;
			
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXS");
								
						}
						if ($device[$b]['dev_name'] == "B601" && $b601_port[$c] == 2)				
						{
							unset ($freetdm_cfg->module_list);
							//echo "i am here <br />";
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data, $b601_module_position);
				
							$freetdm_cfg->module_list = $b601_module_position;
			
							//create freetdm.conf
							$freetdm_cfg->freetdm_conf("hello", "FXS");	
						}
						if ($device[$b]['dev_name'] == "B700")				
						{
							unset ($freetdm_cfg->module_list);
							$num = $c + 1;
							if ($connection[$c] == "FXS")
							{
								//populate class
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b700_port[$num], $data, $a200_module_position);
					
								$freetdm_cfg->module_list[1] = "FXS";
								$freetdm_cfg->module_list[2] = "FXS";
			
								//create freetdm.conf
								$freetdm_cfg->freetdm_conf("hello", "FXS");	
							}
						}						
					}
				}	
			}
			
			//Freetdm.conf.xml close tags
			$freetdm_cfg->freetdm_xml("end config_profiles");
			
			//Run through the PRI Spans
			$freetdm_cfg->freetdm_xml("start PRI spans");

			$x = 0;
			for ($b = 1; $b < $a; $b++)
			{			
				for ($c = 0; $c < $device[$b]['port_num']; $c ++)
				{				
					$x++;
					
					if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108")
					{
						$port = $c + 1;
						//populate class
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$array[$b][$c]['port_id'] , $data);
						
						//echo $freetdm_cfg->ss7_span  . "<br />";
						
						if ($freetdm_cfg->ss7_span == "no")
						{
							//echo "I am here<br />";							
							//freetdm.conf.xml profile portion
							$freetdm_cfg->freetdm_xml("PRI spans");							
						}
					}
					if ($device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
					{
						$port = $c + 1;
						//populate class
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);
						
						//echo $freetdm_cfg->ss7_span  . "<br />";
						
						if ($freetdm_cfg->ss7_span == "no")
						{
							//echo "I am here<br />";							
							//freetdm.conf.xml profile portion
							$freetdm_cfg->freetdm_xml("PRI spans");							
						}						
					}
				}
			}
			
			//Freetdm.conf.xml close tags
			$freetdm_cfg->freetdm_xml("close PRI spans");
			
			//Run through the BRI Spans
			$freetdm_cfg->freetdm_xml("start BRI spans");			
			
			$x = 0;
			for ($b = 1; $b < $a; $b++)
			{			
				for ($c = 0; $c < $device[$b]['port_num']; $c ++)
				{				
					$x++;
					if ($device[$b]['dev_name'] == "A500")
					{
						$num = $c + 1;
						//populate class
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$a500_port[$num], $data);

						//freetdm.conf.xml profile portion
						$freetdm_cfg->freetdm_xml("BRI spans");							
					}
					if ($device[$b]['dev_name'] == "B700")
					{
						$num = $c + 1;
						if ($connection[$c] == "NT" || $connection[$c] == "TE")
						{						
							//populate class
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b700_port[$num], $data);

							//freetdm.conf.xml profile portion
							$freetdm_cfg->freetdm_xml("BRI spans");							
						}
					}
				}
			}

			//Freetdm.conf.xml close tags
			$freetdm_cfg->freetdm_xml("close BRI spans");			
			
			//Analog Spans	
			$x = 0;
			$freetdm_cfg->freetdm_xml("start analog spans");
			for ($b = 1; $b < $a; $b++)
			{			
				for ($c = 0; $c < $device[$b]['port_num']; $c ++)
				{				
					$x++;
					
					if ($device[$b]['dev_name'] == "A200" || $device[$b]['dev_name'] == "A400" || $device[$b]['dev_name'] == "B600")
					{
						$port = $c + 1;
						//echo "span = $x <br />";
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$port, $data);
								
						if ($fxo_exist == "yes")
						{
							$freetdm_cfg->freetdm_xml("fxo analog spans");
						}
						if ($fxs_exist == "yes")
						{
							$freetdm_cfg->freetdm_xml("fxs analog spans");
						}
					
					}
					if ($device[$b]['dev_name'] == "B601" && $b601_port[$c] == 2)
					{
						$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);
					
						if ($fxo_exist == "yes")
						{
							$freetdm_cfg->freetdm_xml("fxo analog spans");
						}
						if ($fxs_exist == "yes")
						{
							$freetdm_cfg->freetdm_xml("fxs analog spans");
						}
					
					}					
					if ($device[$b]['dev_name'] == "B700")
					{
						$num = $c + 1;
						if ($connection[$c] == "FXS" || $connection[$c] == "FXO" )
						{						
							$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b700_port[$num], $data);
						
							if ($connection[$c] == "FXO")
							{
								$freetdm_cfg->freetdm_xml("fxo analog spans");
							}
							if ($connection[$c] == "FXS")
							{
								$freetdm_cfg->freetdm_xml("fxs analog spans");
							}
						}
					}
				}
			}			
			$freetdm_cfg->freetdm_xml("end analog spans");

			//SS7 Configuration for FreeTDM.conf.xml
			
			if ($ss7_exist == "yes")
			{
				//Run through the SS7 Spans Section
				$freetdm_cfg->freetdm_xml("start SS7 config");
				
				$freetdm_cfg->freetdm_xml("start_mtp1_links");
				$x = 0;
				for ($b = 1; $b < $a; $b++)
				{			
					for ($c = 0; $c < $device[$b]['port_num']; $c ++)
					{				
						$x++;
						
						if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108" || $device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
						{
							$port = $c + 1;
							//populate class
							if ($device[$b]['dev_name'] == "B601")
							{
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);	
							}
							else
							{
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$array[$b][$c]['port_id'] , $data);
							}
	
							if ($freetdm_cfg->ss7_span == "yes" && $freetdm_cfg->ss7_voice == "")
							{
								//freetdm.conf.xml profile portion
								$freetdm_cfg->freetdm_xml("mtp1_links");							
							}
						}
					}
				}
				$freetdm_cfg->freetdm_xml("stop_mtp1_links");
				
				$freetdm_cfg->freetdm_xml("start_mtp2_links");
				$x = 0;
				for ($b = 1; $b < $a; $b++)
				{			
					for ($c = 0; $c < $device[$b]['port_num']; $c ++)
					{				
						$x++;
						$port = $c + 1;
						if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108" || $device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
						{
							$port = $c + 1;
							//populate class
							if ($device[$b]['dev_name'] == "B601")
							{	
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);
							}
							else
							{
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$array[$b][$c]['port_id'] , $data);
							}
	
							if ($freetdm_cfg->ss7_span == "yes" && $freetdm_cfg->ss7_voice == "")
							{
								//freetdm.conf.xml profile portion
								$freetdm_cfg->freetdm_xml("mtp2_links");							
							}
						}
					}
				}
				$freetdm_cfg->freetdm_xml("stop_mtp2_links");
				
				$freetdm_cfg->freetdm_xml("start_mtp3_links");
				$x = 0;
				for ($b = 1; $b < $a; $b++)
				{			
					for ($c = 0; $c < $device[$b]['port_num']; $c ++)
					{				
						$x++;
						
						if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108" || $device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
						{
							$port = $c + 1;
							//populate class
							if ($device[$b]['dev_name'] == "B601")
							{	
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);
							}
							else
							{
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$array[$b][$c]['port_id'] , $data);
							}
							
							if ($freetdm_cfg->ss7_span == "yes" && $freetdm_cfg->ss7_voice == "")
							{
								//freetdm.conf.xml profile portion
								$freetdm_cfg->freetdm_xml("mtp3_links");							
							}
						}
					}
				}
				$freetdm_cfg->freetdm_xml("stop_mtp3_links");				
				
				//mtp_linksets, mtp_routes and mtp_isup
				if ($ss7_exist == "yes")
				{
					$freetdm_cfg->freetdm_xml("start_linkset");
					$freetdm_cfg->freetdm_xml("mtp_linksets");
					$freetdm_cfg->freetdm_xml("stop_linkset");
					
					$freetdm_cfg->freetdm_xml("start_route");
					$freetdm_cfg->freetdm_xml("mtp_route");
					$freetdm_cfg->freetdm_xml("stop_route");
					
					$freetdm_cfg->freetdm_xml("start_isup");
					$freetdm_cfg->freetdm_xml("isup");
					$freetdm_cfg->freetdm_xml("stop_isup");
				}
				
				
				$freetdm_cfg->freetdm_xml("start_ccspans");
				$x = 0;
				for ($b = 1; $b < $a; $b++)
				{			
					for ($c = 0; $c < $device[$b]['port_num']; $c ++)
					{				
						$x++;
						
						if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108" || $device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
						{
							$port = $c + 1;
							//populate class
							if ($device[$b]['dev_name'] == "B601")
							{	
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);
							}
							else
							{
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$array[$b][$c]['port_id'] , $data);
							}
							if ($freetdm_cfg->ss7_span == "yes")
							{
								//freetdm.conf.xml profile portion
								$freetdm_cfg->freetdm_xml("ccspans");							
							}
						}
					}
				}
				$freetdm_cfg->freetdm_xml("stop_ccspans");	
				
				$freetdm_cfg->freetdm_xml("stop SS7 config");
				
				//Run through the SS7 Spans Section
				$freetdm_cfg->freetdm_xml("start SS7 spans");
	
				$x = 0;
				for ($b = 1; $b < $a; $b++)
				{			
					for ($c = 0; $c < $device[$b]['port_num']; $c ++)
					{				
						$x++;
						
						if ($device[$b]['dev_name'] == "A101" || $device[$b]['dev_name'] == "A102" || $device[$b]['dev_name'] == "A104" || $device[$b]['dev_name'] == "A108" || $device[$b]['dev_name'] == "B601" && $b601_port[$c] == 1)
						{
							$port = $c + 1;
							//populate class
							if ($device[$b]['dev_name'] == "B601")
							{	
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$b601_port[$c], $data);
							}
							else
							{
								$freetdm_cfg->freetdm_generate($device[$b]['dev_name'], $cards[$b]['id'], $x,$array[$b][$c]['port_id'] , $data);
							}
							
							if ($freetdm_cfg->ss7_span == "yes")
							{
								//freetdm.conf.xml profile portion
								$freetdm_cfg->freetdm_xml("SS7 spans");							
							}
						}
					}
				}
				
				//Freetdm.conf.xml close tags
				$freetdm_cfg->freetdm_xml("close SS7 spans");
			}
			
			
			
				
			unset($_SESSION['last_freetdm_profile']);	
			
			$freetdm_cfg->freetdm_xml("end");	
			
			shell_exec("mv freetdm.conf ../../../conf");
			shell_exec("mv freetdm.conf.xml ../../../conf/autoload_configs");
		}
		
		$_SESSION['created'] = "YES";
		$_SESSION['wanpipes'] = $wanpipes;
		
		//Redirect page to itself
		header( 'Location:wanrouterhwprobe.php' );				
		
	}
}	
}


?>